#include <iostream>
#include <string>
#include <queue>
#include <algorithm>
#include <set>
#include <cassert>

using namespace std;
using ll = long long;

const int N = 10000;
const int K = 19;
const int MOD = 1e9+21;
const int B = 734;

struct mod {
    int x;

    mod(ll y = 0) : x(y % MOD) {
        if (x < 0) x += MOD;
    }

    mod operator + (mod m) { 
        int t = x + m.x;
        if (t >= MOD) t -= MOD;
        return mod { t };
    }

    mod operator - (mod m) {
        int t = x - m.x;
        if (t < 0) t += MOD;
        return mod { t };
    }

    mod operator * (mod m) {
        return mod { (ll) m.x * x % MOD };
    }

    bool operator == (mod m) const {
        return x == m.x;
    }
};

string s;
int len[N], up[K][N];
mod hup[K][N];

bool cmp(int i, int j) {
    //cout << "cmp " << i << " and " << j << endl;
    for (int h = K; h--; ) {
        if ((1 << h) < min(len[i], len[j])) {
            if (hup[h][i] == hup[h][j]) {
                i = up[h][i];
                j = up[h][j];
            }
        }
    }

    //cout << " => " << s[i] << " " << s[j] << endl;
    if (!len[j]) return false;
    if (!len[i]) return true;
    return s[i] < s[j];
}

void connect(int i, int j) {
    up[0][i] = j;
    len[i] = len[j] + 1;
    hup[0][i] = mod(s[i]-'a'+1);
    mod b(B);
    for (int j = 1; j < K; ++j) {
        int u = up[j-1][i];
        up[j][i] = up[j-1][u];
        hup[j][i] = hup[j-1][i] * hup[j-1][u];
        b = b * b;
    }
}

int main() {
    int k, n; cin >> k >> n;
    vector<int> len(n);
    vector t(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s; cin >> s;
        for (int j = 0; j < k; ++j) t[i][j] = s[j] == '1';
    }

    for (int i = 0; i < K; ++i) up[i][n] = n;

    cin >> s;
    vector<int> dp(n, 0);
    vector<int> gomin(n), gomax(n);

    for (int i = 0; i < n; ++i) {
        gomin[i] = gomax[i] = i + 1;
    }

    for (int i = 1; i < n; ++i) {
        dp[i] = i;
        int j = i - 1;
        while(t[s[j]-'a'][s[i]-'a'] == 0 && j != dp[j]) {
            j = dp[j];
        }
        if (t[s[j]-'a'][s[i]-'a']) dp[i] = j;
        if (dp[i] < i) {
            int j = dp[i];
            while (true) {
                gomax[j] = i + 1;
                if (j == dp[j]) break;
                j = dp[j];
            }
        }
    }

    for (int i = n; i--; ) {
        int t = i+1;
        for (int j = gomin[i]; j <= gomax[i]; ++j) {
            t = min(t, j, cmp);
        }
        connect(i, t);
    }

    string ans;
    for (int i = 0; i != n; i = up[0][i]) ans.push_back(s[i]);
    cout << ans << endl;
}