#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 10;
vector<vector<int>> ch, ans, vars;
vector<vector<pair<int, int>>> sons;
vector<int> cons, choose;

bool dfs(int u) {
    ans[u].clear();
    if (ch[u].empty()) {
        ans[u] = {u};
        return true;
    }
    sons[u].clear();
    for (int v: ch[u]) {
        if (!dfs(v))
            return false;
        sons[u].emplace_back(choose[ans[v][0]], v);
    }
    sort(sons[u].begin(), sons[u].end());
    for (int i = 1; i < sons[u].size(); ++i) {
        if (sons[u][i].first < choose[ans[sons[u][i - 1].second].back()])
            return false;
    }
    for (auto s: sons[u]) {
        for (int v: ans[s.second])
            ans[u].push_back(v);
    }
    return true;
}

bool gen(int i) {
    if (i == cons.size()) {
        if (dfs(0)) {
            cout << "Yes\n";
            for (int u = 0; u < ch.size(); ++u) {
                if (ch[u].empty())
                    cout << choose[u] << '\n';
                else {
                    for (auto v: sons[u])
                        cout << v.second + 1 << ' ';
                    cout << '\n';
                }
            }
            return true;
        }
        return false;
    }
    for (int var: vars[cons[i]]) {
        choose[cons[i]] = var;
        if (gen(i + 1))
            return true;
    }
    return false;
}

vector<pair<int, int>> dp;

bool dfs2(int u) {
    if (ch[u].empty()) {
        int mn = INF, mx = 0;
        for (int var: vars[u]) {
            mn = min(mn, var);
            mx = max(mx, var);
        }
        dp[u] = {mn, mx};
        return true;
    }
    if (ch[u].size() == 1) {
        if (!dfs2(ch[u][0]))
            return false;
        dp[u] = dp[ch[u][0]];
        return true;
    }
    else {
        int v1 = ch[u][0], v2 = ch[u][1];
        if (!dfs2(v1))
            return false;
        if (!dfs2(v2))
            return false;
        if (dp[v1].first > dp[v2].second || dp[v1].second < dp[v2].first)
            return false;
        dp[u] = {max(dp[v1].first, dp[v2].first), min(dp[v1].second, dp[v2].second)};
        return true;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    ch.resize(n);
    ans.resize(n);
    vars.resize(n);
    sons.resize(n);
    choose.resize(n);
    int K = 0, M = 0;
    for (int i = 0; i < n; ++i) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            K = max(K, k);
            for (int j = 0; j < k; ++j) {
                int u;
                cin >> u;
                --u;
                ch[i].push_back(u);
            }
        }
        else {
            M += k;
            cons.push_back(i);
            for (int j = 0; j < k; ++j) {
                int var;
                cin >> var;
                vars[i].push_back(var);
            }
        }
    }
    if (M <= 20) {
        if (!gen(0))
            cout << "No" << endl;
    }
    else if (K <= 2) {
        dp.resize(n);
        if (dfs2(0))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
    else
        cout << "No" << endl;
}
