#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 20;

vector<int> g[MAXN], ans[MAXN];
set<int> upgrades[MAXN];
int sz[MAXN], c[MAXN];

void init(int u)
{
	sz[u] = 1;
	if (g[u].size() == 0)
		c[u] = 1;
	for (auto v : g[u])
	{
		init(v);
		sz[u] += sz[v];
		c[u] += c[v];
		for (auto x : upgrades[v])
			upgrades[u].insert(x);
	}
}

bool check(const vector<int>& up, int l, int r, int u)
{
	if (g[u].size() == 0)
		return r == l + 1 && upgrades[u].count(up[l]);
	//if (c[u] != r - l)
	//	return false;

	int cur = 0, prevBlock = l;
	set<int> used;
	for (int i = l; i <= r; ++i)
	{
		if (i == r)
		{
			used.insert(cur);
			return check(up, prevBlock, i, g[u][cur]);
		}
		else if (cur == -1 || !upgrades[g[u][cur]].count(up[i]))
		{
			used.insert(cur);
			if (cur != -1)
			{
				if (!check(up, prevBlock, i, g[u][cur]))
					return false;
			}
			prevBlock = i;
			

			for (int j = 0; j < g[u].size(); ++j)
			{
				if (upgrades[g[u][j]].count(up[i]))
				{
					cur = j;
					break;
				}
			}

			if (used.count(cur))
				return false;
		}
	}

	return true;
}

void setAns(const vector<int>& up, int l, int r, int u)
{
	if (g[u].size() == 0)
	{
		ans[u].push_back(up[l] - 1);
		return;
	}

	int cur = 0, prevBlock = l;
	set<int> used;
	for (int i = l; i <= r; ++i)
	{
		if (i == r)
		{
			used.insert(cur);
			setAns(up, prevBlock, r, g[u][cur]);
			ans[u].push_back(g[u][cur]);
			return;
		}
		else if (cur == -1 || !upgrades[g[u][cur]].count(up[i]))
		{
			used.insert(cur);
			if (cur != -1)
			{
			setAns(up, prevBlock, i, g[u][cur]);
			ans[u].push_back(g[u][cur]);
			}
			prevBlock = i;

			for (int j = 0; j < g[u].size(); ++j)
			{
				if (upgrades[g[u][j]].count(up[i]))
				{
					cur = j;
					break;
				}
			}
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	int type = 0, k = 0, a = 0;
	vector<int> allUp;
	int cnt = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> type >> k;
		if (type == 1)
		{
			for (int j = 0; j < k; ++j)
			{
				cin >> a;
				g[i].push_back(a - 1);
			}
		}
		else
		{
			++cnt;
			for (int j = 0; j < k; ++j)
			{
				cin >> a;
				upgrades[i].insert(a);
				allUp.push_back(a);
			}
		}
	}

	init(0);
	sort(allUp.begin(), allUp.end());
	int m = allUp.size();
	for (int mask = 0; mask < (1 << m); ++mask)
	{
		vector<int> up;
		for (int i = 0; i < m; ++i)
			if ((mask >> i) & 1)
				up.push_back(allUp[i]);

		if (up.size() == cnt && check(up, 0, up.size(), 0))
		{
			setAns(up, 0, up.size(), 0);
			cout << "Yes\n";
			/*for (int i = 0; i < n; ++i)
			{
				for (auto x : ans[i])
					cout << x + 1 << " ";
				cout << "\n";
			}*/

			return 0;
		}
	}

	cout << "No\n";

	return 0;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/