#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
struct segtree {
    vector<pair<int, int>> tree;
    int sz;
    void upd(int v) {
        if (v * 2 + 1 < tree.size())
            tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
    void make(int n, vector<int> a) {
        sz = 1;
        while (n >= sz)
            sz *= 2;
        tree.assign(sz * 2, {10000000, 0});
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = {a[i], i};
        }
        for (int i = sz - 1; i > 0; --i) {
            upd(i);
        }
    }
    void update(int v, int c) {
        v += sz;
        tree[v].first += c;
        while (v) {
            upd(v);
            v /= 2;
        }
    }
    pair<int, int> get() {
        return tree[1];
    }
};
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> m >> n;
    string s;
    cin >> s;
    vector<int> nums(m);
    vector<vector<int>> bd(n);
    vector<vector<int>> good(m);
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        int cn = 0;
        while (t--) {
            int k;
            char c;
            cin >> k >> c;
            k--;
            if (s[k] == c) {
                good[i].push_back(k);
            } else {
                cn++;
                bd[k].push_back(i);
            }
        }
        nums[i] = cn;
    }
    segtree st;
    st.make(m, nums);
    vector<int> ans;
    vector<int> gds(n);
    //cout << st.get().first << ' ' << st.get().second << endl;
    while (st.get().first == 0) {
        int v = st.get().second;
        ans.push_back(v);
        st.update(v, 1000000);
        for (auto i : good[v]) {
            if (!gds[i]) {
                gds[i] = 1;
                for (auto j : bd[i]) {
                    st.update(j, -1);
                }
            }
        }
    }
    int cnt = accumulate(all(gds), 0);
    if (cnt == n) {
        for (auto i : ans)
            cout << i + 1 << ' ';
    } else {
        cout << -1;
    }
    return 0;
}
