#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

const int MAXN = 26;
const int MAXE = 25;

bool can[MAXN][MAXN];
vi adj[MAXE];
bool canEnd[MAXE];
vi a;

bool CanDelete(int l, int r) {
    if (l >= r) {
        return true;
    }
    if (!can[a[l]][a[l + 1]]) {
        return false;
    }
    vi poses;
    for (int i = l + 1; i <= r;++i) {
        poses.eb(i);
    }
    point:
    for (int i = sz(poses) - 1; i > 0; --i) {
        if (can[a[poses[i - 1]]][a[poses[i]]]) {
            poses.erase(poses.begin() + i);
            i = min(i, sz(poses) - 1) + 1;
        }
    }
    for (auto u : poses) {
        if (!can[a[l]][a[u]]) {
            return false;
        }
    }
    return true;
}

bool Comp(int x, int y) {
    return a[x] < a[y];
}

int Merge(int a, int b) {
    if (sz(adj[a]) > sz(adj[b])) {
        swap(a, b);
    }
    for (auto u : adj[a]) {
        adj[b].eb(u);
    }
    return b;
}

void Solve() {
    int k, n;
    cin >> k >> n;
    forn(i, k) {
        forn(j, k) {
            char x;
            cin >> x;
            can[i][j] = (x - '0');
        }
    }
    forn(i, n) {
        char x;
        cin >> x;
        a.eb(x - 'a');
    }
    forn(i, n) {
        if (CanDelete(i, n - 1)) {
            canEnd[i] = 1;
        }
        for (int j = i + 1; j < n; ++j) {
            if (CanDelete(i, j - 1)) {
                adj[i].eb(j);
            }
        }
    }
    string ans = "";
    int v = 0;
    while(true) {
        ans += char(a[v] + 'a');
        if (canEnd[v]) {
            break;
        }
        sort(all(adj[v]));
        adj[v].resize(unique(all(adj[v])) - adj[v].begin());
        sort(rall(adj[v]), Comp);
        int to = adj[v].back();
        adj[v].pop_back();
        while(!adj[v].empty() && a[to] == a[adj[v].back()]) {
            to = Merge(adj[v].back(), to);
            adj[v].pop_back();
        }
        v = to;
    }
    cout << ans;
}

signed main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
    int start = clock();
    IO();
    Solve();
#ifdef DIVAN
    int Timeme = (clock() - start + 999) / 1000;
    cout << '\n' << "TIME: " << Timeme;
#endif
    return 0;
}
