#include <iostream>
#include <string>
#include <unordered_set>
#include <vector>

using namespace std;

void read_card(int *card, const string &s) {
    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        int a;
        char c;

        cin >> a >> c;

        --a;

        if (s[a] == c) card[a] = 1;
        else card[a] = -1;
    }
}

vector<pair<unordered_set<int>, unordered_set<int>>> make_groups(int **cards, int n, int m) {
    vector<pair<unordered_set<int>, unordered_set<int>>> res;

    for (int i = 0; i < m; ++i) {
        unordered_set<int> ones, minus_ones;

        for (int j = 0; j < n; ++j) {
            switch (cards[j][i]) {
                case 1: ones.insert(j); break;
                case -1: minus_ones.insert(j); break;
            }
        }

        res.push_back({ ones, minus_ones });
    }

    return res;
}


int main() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    int **cards = new int*[n];

    for (int i = 0; i < n; ++i) {
        cards[i] = new int[m];

        for (int j = 0; j < m; ++j) cards[i][j] = 0;

        read_card(cards[i], s);
    }

    auto groups = make_groups(cards, n, m);

    unordered_set<int> probable_indices;
    unordered_set<int> unused_indices;
    for (int i = 0; i < n; ++i) {
        probable_indices.insert(i);
        unused_indices.insert(i);
    }
    for (auto &g : groups) {
        for (int idx : g.second) probable_indices.erase(idx);
    }

    unordered_set<int> uncleared_cells;
    for (int i = 0; i < m; ++i) uncleared_cells.insert(i);
    vector<int> indices;

    while (!probable_indices.empty()) {
        for (auto idx : probable_indices) {
            indices.push_back(idx);
            unused_indices.erase(idx);

            vector<int> to_erase;
            for (int i : uncleared_cells) {
                if (groups[i].first.count(idx) == 1) to_erase.push_back(i);
            }
            for (int i : to_erase) uncleared_cells.erase(i);
        }

        probable_indices.clear();

        for (int i : unused_indices) {
            probable_indices.insert(i);
        }
        for (int i : uncleared_cells) {
            auto &g = groups[i];
            for (int idx : g.second) probable_indices.erase(idx);
        }
    }

    if (uncleared_cells.empty()) {
        for (int i : indices) {
            cout << i + 1 << " ";
        }
        cout << endl;
    } else cout << -1 << endl;
}
