#include <iostream>
#include <string>
#include <unordered_set>
#include <vector>

using namespace std;

vector<int> read_string() {
    vector<int> res;

    string str;
    cin >> str;

    for (char ch : str) res.push_back(ch - 'a');

    return res;
}

template<>
struct std::hash<pair<int, int>> {
    size_t operator()(const pair<int, int> &val) const {
        return ((size_t) val.first << 32) | val.second;
    }
};

unordered_set<pair<int, int>> read_table(int k) {
    unordered_set<pair<int, int>> res;

    for (int i = 0; i < k; ++i) {
        string str;
        cin >> str;
        for (int j = 0; j < k; ++j) {
            if (str[j] == '1') res.insert({i, j});
        }
    }

    return res;
}

void write_string(const vector<int> &ans) {
    for (auto i : ans) cout << (char) (i + 'a');

    cout << endl;
}

bool operator<(const vector<int> &left, const vector<int> &right) {
    for (int i = 0; i < min(left.size(), right.size()); ++i) {
        if (left[i] < right[i]) return true;
        else if (left[i] > right[i]) return false;
    }

    return left.size() < right.size();
}

vector<int> use_dp(vector<int> &str, vector<vector<bool>> &dp, int start_pos) {
    vector<int> res;

    for (int i = start_pos; i < str.size(); ++i) {
        int min = str[i];
        vector<int> ids;
        for (int j = i + 1; j < str.size(); ++j) {
            if (min >= str[j] && dp[j - i][i]) {
                if (min == str[j] && ids.empty()) continue;
                min = str[j];
                if (min > str[j]) ids.clear();
                ids.push_back(j);
            }
        }

        if (ids.empty()) {
            res.push_back(str[i]);
            if (i < str.size() - 1 && dp[str.size() - i - 1][i + 1]) return res;
        } else {
            if (ids.size() == 1) i = ids[0] - 1;
            else {
                if (ids.size() > 3) {
                    i = ids[rand() % ids.size()] - 1;
                    continue;
                }
                vector<int> min_suffix = use_dp(str, dp, ids[0]);

                for (int j = 1; j < ids.size(); ++j) {
                    vector<int> suf = use_dp(str, dp, ids[j]);
                    if (suf < min_suffix) min_suffix = suf;
                }

                for (int a : min_suffix) res.push_back(a);

                return res;
            }
        }
    }

    return res;
}

vector<int> solve(const unordered_set<pair<int, int>> &table, vector<int> &str) {
    //     len    r
    vector<vector<bool>> dp;

    dp.push_back(vector<bool>(str.size(), true));

    vector<bool> dp1;
    dp1.push_back(false);
    for (int i = 1; i < str.size(); ++i) {
        dp1.push_back(table.count({str[i - 1], str[i]}) == 1);
    }
    dp.push_back(dp1);

    for (int len = 2; len <= str.size(); ++len) {
        vector<bool> dpi;
        dpi.push_back(false);

        for (int l = 1; l <= str.size() - len; ++l) {
            dpi.push_back(false);
            for (int m = l; m < l + len; ++m) {
                if (table.count({str[l - 1], str[m]}) == 1 && dp[m - l][l] && dp[l + len - m - 1][m + 1]) {
                    dpi[l] = true;
                    break;
                }
            }
        }
        dp.push_back(dpi);
    }

    return use_dp(str, dp, 0);
}

int main() {
    int k, n;
    cin >> k >> n;

    auto table = read_table(k);
    auto str = read_string();

    write_string(solve(table, str));
}
