#include <iostream>
#include <string>
#include <unordered_set>
#include <vector>

using namespace std;

void fill(vector<vector<bool>> &field, int x, int y) {
    for (int i = x; i < field.size(); ++i) {
        for (int j = y; j < field.size(); ++j) {
            field[i][j] = true;
        }
    }
}

void solve1(const int n, const int k, const int m) {
    string str;
    cin >> str;
    vector<vector<bool>> field(n, vector<bool>(n, false));

    int pos = 0;

    int player = 1;
    int start_player = 1;

    while (true) {
        if (player == -1) {
            int x, y;
            cin >> x >> y;
            if (x == 1 && y == 1) {
                start_player = -start_player;
                player = start_player;
                for (auto &a : field) for (auto &&b : a) b = false;
                continue;
            } else fill(field, x - 1, y - 1);
        } else {
            if (pos == str.size()) {
                cout << 1 << " " << 1 << endl << 0 << endl;
                return;
            }
            int x = 0, y = 0;
            for (int i = (int)field.size() - 1; i >= 0; --i) {
                for (int j = (int)field.size() - 1; j >= 0; --j) {
                    if (!field[i][j] && (i != 0 || j != 0)) {
                        if (str[pos] == '1' && (j == (int)field.size() - 1 || field[i][j + 1])) continue;
                        x = i;
                        y = j;
                        ++pos;
                        goto end;
                    }
                }
            }
            end:
            if (x == 0 && y == 0) {
                start_player = -start_player;
                player = start_player;
                for (auto &a : field) for (auto &&b : a) b = false;
                cout << 1 << " " << 1 << endl;
                continue;
            } else {
                fill(field, x, y);
                cout << x + 1 << " " << y + 1 << endl;
            }
        }
        player = -player;
    }
}

void solve2(const int n, const int k, const int m) {
    string str;
    vector<vector<bool>> field(n, vector<bool>(n, false));

    int pos = 0;

    int player = 1;
    int start_player = 1;

    int games;
    cin >> games;

    while (true) {
        if (player == -1) {
            int x, y;
            cin >> x >> y;
            if (x == 1 && y == 1) {
                start_player = -start_player;
                player = start_player;
                for (auto &a : field) for (auto &&b : a) b = false;
                continue;
            } else fill(field, x - 1, y - 1);
        } else {
            if (pos == m) {
                cout << str << endl;
                return;
            }
            int x = 0, y = 0;
            for (int i = (int)field.size() - 1; i >= 0; --i) {
                for (int j = (int)field.size() - 1; j >= 0; --j) {
                    if (!field[i][j] && (i != 0 || j != 0)) {
                        x = i;
                        y = j;
                        ++pos;
                        goto end;
                    }
                }
            }
            end:
            int x1, y1;
            cin >> x1 >> y1;
            if ((--x1 != 0)| (--y1 != 0)) {
                if (x1 == x && y1 == y) str.append(1, '0');
                else str.append(1, '1');
            }
            if (x1 == 0 && y1 == 0) {
                start_player = -start_player;
                player = start_player;
                for (auto &a : field) for (auto &&b : a) b = false;
                continue;
            } else {
                fill(field, x1, y1);
            }
        }
        player = -player;
    }

}

int main() {

    int mode;
    cin >> mode;

    int n, k, m;
    cin >> n >> k >> m;

    if (mode == 1) solve1(n, k, m);
    else solve2(n, k, m);
}
