#include <bits/stdc++.h>
using namespace std;

const int MAXN = (1 << 19);
vector<int> tree[MAXN * 2];

int k;

void build() {
    vector<int> el(k, -1);
    fill(tree, tree + 2 * MAXN, el);
}

vector<int> op(const vector<int> &a, const vector<int> &b) {
    vector<int> c = a;
    for (int i = 0; i < k; ++i) {
        c[i] = max(c[i], b[i]);
    }
    return c;
}

void pull(int v) {
    tree[v] = op(tree[v * 2], tree[v * 2 + 1]);
}

void update(int ind, vector<int> val) {
    ind += MAXN;
    tree[ind] = val;
    while (ind / 2 > 0) {
        ind /= 2;
        pull(ind);
    }
}

vector<int> get(int l, int r) {
    vector<int> ans(26, -1);
    l += MAXN; r += MAXN;
    while (r >= l) {
        if (l % 2 == 1) {
            ans = op(ans, tree[l]);
        }
        if (r % 2 == 0) {
            ans = op(ans, tree[r]);
        }
        l = (l + 1) / 2;
        r = (r - 1) / 2;
    }
    return ans;
}

const int MAXK = 28;

int can[MAXK][MAXK];

int dp[MAXN][MAXK];

main() {
    int n;
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            can[i][j] = s[j] - '0';
        }
    }
    /// k = 26;
    build();
    string a;
    cin >> a;
    for (int i = 0; i < k; ++i) {
        dp[n - 1][i] = n - 1;
    }
    vector<int> arr(k);
    for (int i = 0; i < k; ++i) {
        arr[i] = dp[n - 1][i];
    }
    update(n - 1, arr);
    for (int i = n - 2; i >= 0; --i) {
        auto res = get(i + 1, dp[i + 1][a[i + 1] - 'a']);
        for (int j = 0; j < k; ++j) {
            if (!can[j][a[i + 1] - 'a']) {
                res[j] = i;
            }
            dp[i][j] = res[j];
        }
        update(i, res);
    }
    string ans;
    vector<int> cur;
    ans.push_back(a[0]);
    cur.push_back(0);
    int sz = 1;
    while (true) {
        vector<int> nw;
        char ch = 'z';
        int rt = -1;
        for (auto elem : cur) {
            int l = elem + 1, r = dp[elem][a[elem] - 'a'] + 1;
            l = max(l, rt);
            for (int i = l; i <= r; ++i) {
                if (i == n) {
                    cout << ans;
                    return 0;
                }
                if (a[i] < ch) {
                    nw.clear();
                    ch = a[i];
                    nw.push_back(i);
                } else if (a[i] == ch) {
                    nw.push_back(i);
                }
            }
            rt = max(rt, r + 1);
        }
        ans.push_back(ch);
        cur = nw;
        sz += cur.size();
        assert(sz <= n * 20);
    }
    return 0;
}
