#include <iostream>
#include <bitset>
#include <vector>
#include <algorithm>
#include <set>

#pragma optimize("0fast");

using namespace std;

void print(bitset<100000> & a, int m)
{
	for (int i = 0; i < m; i++)
		cout << a[i];
	cout << endl;
}

vector<int> sfcount;
vector<int> gapcount;

bool comp(pair<int, pair<bitset<100000>, bitset<100000>>> & a, pair<int, pair<bitset<100000>, bitset<100000>>> & b)
{
	return (sfcount[a.first] < sfcount[b.first]) || (sfcount[a.first] == sfcount[b.first] && gapcount[a.first] > gapcount[b.first]);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	bitset<100000> set_bs;
	for (int i = 0; i < m; i++)
		set_bs[i] = 1;
	vector<pair<int, pair<bitset<100000>, bitset<100000>>>> cards(n);
	sfcount.resize(n);
	gapcount.resize(n);
	for (int i = 0; i < n; i++)
	{
		cards[i].first = i;
		cards[i].second.second |= set_bs;
		cards[i].second.first.reset();
		sfcount[i] = 0;
		gapcount[i] = m;
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int a;
			char c;
			cin >> a >> c;
			cards[i].second.second[a - 1] = 0;
			gapcount[i]--;
			if (s[a - 1] != c)
			{
				cards[i].second.first[a - 1] = 1;
				sfcount[i]++;
			}
		}
	}

	sort(cards.begin(), cards.end(), comp);

	vector<int> ans;
	bitset<100000> t;
	t |= set_bs;

	int i = 0;
	while (i < cards.size())
	{
		if ((t & cards[i].second.first).none())
		{
			ans.push_back(cards[i].first);
			t &= cards[i].second.second;
			cards.erase(cards.begin() + i);
		}
		else i++;
	}

	if (ans.size() != n || t.any())
	{
		cout << "-1";
		return 0;
	}

	for (auto& x : ans)
		cout << x + 1 << " ";
}