#include <iostream>
#include <vector>
#include <set>

using namespace std;

int INF = 1e9;

struct tree{
    vector <pair <int, int> > a;
    tree (int n) {
        a.resize(4 * n);
        build(0, 0, n);
    }
    void build (int v, int vl, int vr){
        if (vl == vr - 1) {
            a[v] = {0, vl};
            return;
        }
        int m = (vl + vr) / 2;
        build(2 * v + 1, vl, m);
        build(2 * v + 2, m, vr);
        a[v] = min(a[2 * v + 1], a[2 * v + 2]);
    }
    void inc(int v, int vl, int vr, int id, int val) {
        if (id < vl || vr <= id)
            return;
        if (vl == vr - 1){
            a[v].first += val;
            return;
        }
        int m = (vl + vr) / 2;
        inc(2 * v + 1, vl, m, id, val);
        inc(2 * v + 2, m, vr, id, val);
        a[v] = min(a[2 * v + 1], a[2 * v + 2]);
    }
    pair <int, int> get() {
        return a[0];
    }
};


struct kek{
    int id;
    char val;
    kek(){
        id = -1;
        val = '0';
    }
    kek(int a, char b){
        id = a;
        val = b;
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <vector<kek>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            char y;
            cin >> x >> y;
            a[i].push_back({x - 1, y});
        }
    }
    int k = 0;
    vector <int> ans;
    vector <vector <int> > errors(m);
    tree t(n);

    for (int i = 0; i < n; ++i) {
        int kek = 0;
        for (auto j : a[i]){
            if (s[j.id] != j.val) {
                kek++;
                errors[j.id].push_back(i);
            }
        }
        t.inc(0, 0, n, i, kek);
    }
    for (int i = 0; i < n; ++i) {
        auto p = t.get();
        if (p.first != 0) {
            cout << -1;
            return 0;
        }
        ans.push_back(p.second + 1);
       // cout << p.second << endl;
        for (auto j : a[p.second]) {
            if (s[j.id] == '0')
                continue;
            k++;
            s[j.id] = '0';
            for (auto j1 : errors[j.id]) {
                t.inc(0, 0, n, j1, -1);
            }
        }
        t.inc(0, 0, n, p.second, INF);
    }
  //  cout << k << endl;
    if (k != m){
        cout << -1;
        return 0;
    }
    for (auto i : ans) {
        cout << i << " ";
    }
}


