﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void Merge(vector<pair<int, int>>& a, vector<pair<int, int>>& b, vector<pair<int, int>>& res) {
	int n = a.size(), m = b.size(), i1 = 0, j1 = 0, i2 = 0, j2 = 0;
	pair<int, int> p;
	while (i1 < n && i2 < m) {
		if (a[i1].first < b[i2].first) {
			while (j2 < m && b[j2].first < a[i1].second) {
				++j2;
			}
			if (j2 < m) {
				p = make_pair(a[i1].first, b[j2].second);
				while (!res.empty() && res.back().second >= p.second) {
					res.pop_back();
				}
				res.push_back(p);
			}
			++i1;
		}
		else {
			while (j1 < m && a[j1].first < b[i2].second) {
				++j1;
			}
			if (j2 < m) {
				p = make_pair(b[i2].first, a[j1].second);
				while (!res.empty() && res.back().second >= p.second) {
					res.pop_back();
				}
				res.push_back(p);
			}
			++i2;
		}
	}
	while (i1 < n) {
		while (j2 < m && b[j2].first < a[i1].second) {
			++j2;
		}
		if (j2 < m) {
			p = make_pair(a[i1].first, b[j2].second);
			while (!res.empty() && res.back().second >= p.second) {
				res.pop_back();
			}
			res.push_back(p);
		}
		++i1;
	}
	while (i2 < m) {
		while (j1 < n && a[j1].first < b[i2].second) {
			++j1;
		}
		if (j1 < n) {
			p = make_pair(b[i2].first, a[j1].second);
			while (!res.empty() && res.back().second >= p.second) {
				res.pop_back();
			}
			res.push_back(p);
		}
		++i2;
	}
}

bool dfs(int v, vector<vector<int>>& ch, vector<vector<pair<int, int>>> val) {
	if (ch[v].empty()) {
		return true;
	}
	int x = ch[v][0], y = ch[v][1];
	if (!dfs(x, ch, val) || !dfs(y, ch, val)) {
		return false;
	}
	Merge(val[x], val[y], val[v]);
	return !val[v].empty();
}

int main() {
	int n, t, k;
	cin >> n;
	vector<vector<int>> ch(n);
	vector<vector<pair<int, int>>> val(n);
	for (int i = 0; i < n; ++i) {
		cin >> t >> k;
		if (t == 1) {
			ch[i].resize(k);
			for (int j = 0; j < k; ++j) {
				cin >> ch[i][j];
				--ch[i][j];
			}
		}
		else {
			val[i].resize(k);
			for (int j = 0; j < k; ++j) {
				cin >> val[i][j].first;
				val[i][j].second = val[i][j].first;
			}
			sort(val[i].begin(), val[i].end());
		}
	}
	if (!dfs(0, ch, val)) {
		cout << "No";
		return 0;
	}
	else {
		cout << "Yes\n";
	}
	return 0;
}
