#include <bits/stdc++.h>

using namespace std;

bool a[26][26];


const int MOD = 1000000009;
const int POW = 57;

vector<int> pows;


class Vertex {
public:
	int y, sz;
	char c;
	Vertex* left;
	Vertex* right;
	int hash;

	Vertex(char c): y(rand()), sz(1), c(c), hash(c) {
	}
	Vertex(Vertex* v): y(v->y), sz(v->sz), c(v->c), left(v->left), right(v->right), hash(v->hash) {
	}

	void pull() {
		sz = (left ? left->sz : 0) + 1 + (right ? right->sz : 0);
		hash = (
			(long long)(left ? left->hash : 0) * pows[1 + (right ? right->sz : 0)] +
			(long long)c * pows[right ? right->sz : 0] +
			(right ? right->hash : 0)
		) % MOD;
	}
};


void print(Vertex* v) {
	if(v == nullptr) {
		return;
	}
	print(v->left);
	cout << v->c;
	print(v->right);
}


Vertex* merge(Vertex* u, Vertex* v) {
	if(u == nullptr) {
		return v;
	}
	if(v == nullptr) {
		return u;
	}
	if(u->y > v->y) {
		u = new Vertex(u);
		u->right = merge(u->right, v);
		u->pull();
		return u;
	} else {
		v = new Vertex(v);
		v->left = merge(u, v->left);
		v->pull();
		return v;
	}
}

pair<Vertex*, Vertex*> split(Vertex* v, int i) {
	if(v == nullptr) {
		return {v, v};
	}
	v = new Vertex(v);
	int leftsz = (v->left ? v->left->sz : 0) + 1;
	if(i >= leftsz) {
		auto p = split(v->right, i - leftsz);
		v->right = p.first;
		v->pull();
		return {v, p.second};
	} else {
		auto p = split(v->left, i);
		v->left = p.second;
		v->pull();
		return {p.first, v};
	}
}

bool cmplt(Vertex* a, Vertex* b) {
	if(a == nullptr) {
		return true;
	}
	if(b == nullptr) {
		return false;
	}
	int minsz = min(a->sz, b->sz);
	int l = 0;
	int r = minsz + 1;
	while(r - l > 1) {
		int m = (l + r) / 2;
		auto pa = split(a, m);
		auto pb = split(b, m);
		delete pa.second;
		delete pb.second;
		if(pa.first->hash == pb.first->hash) {
			l = m;
		} else {
			r = m;
		}
		delete pa.first;
		delete pb.first;
	}
	auto va = split(split(a, l).second, 1).first;
	auto vb = split(split(b, l).second, 1).first;
	return (va == nullptr ? '\0' : va->c) < (vb == nullptr ? '\0' : vb->c);
}
Vertex* lexmin(Vertex* a, Vertex* b) {
	if(cmplt(a, b)) {
		return a;
	} else {
		return b;
	}
}


signed main() {
	int k, n;
	cin >> k >> n;

	for(int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for(int j = 0; j < k; j++) {
			a[i][j] = s[j] - '0';
		}
	}

	pows.resize(n + 1);
	pows[0] = 1;
	for(int i = 1; i < pows.size(); i++) {
		pows[i] = (long long)pows[i - 1] * POW % MOD;
	}

	string s;
	cin >> s;

	vector<int> dp_can_delete_r(n);
	vector<Vertex*> dp_lexmin(n);
	dp_can_delete_r[n - 1] = n - 1;

	for(int l = n - 2; l >= 0; l--) {
		dp_lexmin[l] = merge(new Vertex(s[l + 1]), dp_lexmin[l + 1]);
		int r = l;
		while(r + 1 < n && a[s[l] - 'a'][s[r + 1] - 'a']) {
			dp_lexmin[l] = lexmin(dp_lexmin[l], dp_lexmin[r + 1]);
			r = dp_can_delete_r[r + 1];
		}
		dp_can_delete_r[l] = r;
	}

	cout << s[0];
	print(dp_lexmin[0]);
	cout << endl;

	return 0;
}