#include <bits/stdc++.h>

using namespace std;


bool field[33][33];
int n, k, m;
char* s;


int streamptr = 0;

int poll_stream(int c) {
	int value = 0;
	for(int i = 0; i < c && streamptr < m; i++) {
		value |= (s[streamptr++] - '0') << i;
	}
	return value;
}



const int BITNESS = 5;

int cellrank(int x, int y) {
	return x + y;
}

bool cmpcell(pair<int, int> c1, pair<int, int> c2) {
	int r1 = cellrank(c1.first, c1.second);
	int r2 = cellrank(c2.first, c2.second);
	return r1 == r2 ? c1 < c2 : r1 < r2;
}

pair< int, vector< pair<int, int> > > generate_cells() {
	vector< pair<int, int> > free_cells;
	for(int x = 1; x <= n; x++) {
		for(int y = 1; y <= n; y++) {
			if(!field[x][y]) {
				free_cells.emplace_back(x, y);
			}
		}
	}
	assert(free_cells.size() > 0);
	sort(free_cells.rbegin(), free_cells.rend(), cmpcell);

	if(free_cells.size() <= 3) {
		return {0, {}};
	}

	int c = 0;
	int cntfree = free_cells.size();
	while(cntfree >= 2) {
		cntfree /= 2;
		c++;
	}

	c = min(c, BITNESS);

	while(free_cells.size() > (1 << c)) {
		free_cells.pop_back();
	}
	return {c, free_cells};
}

pair<int, int> find_cell() {
	auto [c, free_cells] = generate_cells();
	if(c == 0) {
		return {1, 1};
	}
	cerr << c;
	return free_cells[poll_stream(c)];
}

pair<int, int> valueof(int x, int y) {
	auto [c, free_cells] = generate_cells();
	int value = find(free_cells.begin(), free_cells.end(), make_pair(x, y)) - free_cells.begin();
	assert(value != free_cells.size());
	return {c, value};
}



bool i_start = true;

void mark(int x, int y) {
	for(int x1 = x; x1 <= n; x1++) {
		for(int y1 = y; y1 <= n; y1++) {
			field[x1][y1] = true;
		}
	}
	if(x == 1 && y == 1) {
		memset(field, 0, sizeof(field));
	}
}

void newgame() {
	memset(field, 0, sizeof(field));
	i_start = !i_start;
	if(!i_start) {
		int x, y;
		scanf("%d%d", &x, &y);
		mark(x, y);
	}
}


void go(int x, int y) {
	mark(x, y);
	printf("%d %d\n", x, y);
	fflush(stdout);
	if(x == 1 && y == 1) {
		newgame();
		return;
	}
	scanf("%d%d", &x, &y);
	mark(x, y);
	if(x == 1 && y == 1) {
		newgame();
	}
}


pair<int, int> readin() {
	int x, y;
	scanf("%d%d", &x, &y);
	return {x, y};
}


bool is_my_move = true;

pair<int, int> readmymove() {
	pair<int, int> move{1, 1};
	while(move == make_pair(1, 1)) {
		while(!is_my_move) {
			move = readin();
			mark(move.first, move.second);
			if(move == make_pair(1, 1)) {
				i_start = !i_start;
				is_my_move = i_start;
			} else {
				is_my_move = true;
			}
		}
		is_my_move = false;
		move = readin();
		if(move == make_pair(1, 1)) {
			mark(move.first, move.second);
			i_start = !i_start;
			is_my_move = i_start;
		}
	}
	return move;
}

int c = 0;
signed main() {
	ios_base::sync_with_stdio(0);

	int t;
	scanf("%d", &t);
	scanf("%d%d%d", &n, &k, &m);

	if(t == 1) {
		s = new char[m + BITNESS];
		scanf("%s", s);
		for(int i = 0; i < BITNESS; i++) {
			s[m + i] = '0';
		}

		while(streamptr < m) {
			auto best = find_cell();
			if(best == make_pair(1, 1)) {
				c++;
				go(1, 1);
				best = find_cell();
				assert(best != make_pair(1, 1));
			}
			go(best.first, best.second);
		}

		go(1, 1);
		printf("0\n");
		fflush(stdout);
	} else {
		int cnt;
		scanf("%d", &cnt);

		string s;

		while(streamptr < m) {
			auto [x, y] = readmymove();
			auto [c, value] = valueof(x, y);
			mark(x, y);
			streamptr += c;
			cerr << c;
			for(int j = 0; j < c; j++) {
				s.push_back('0' + ((value >> j) & 1));
			}
		}
		printf("%s\n", s.substr(0, m).c_str());
	}

	return 0;
}