#include <iostream>
#include <vector>
#include <set>

int main() {
    int32_t n, m;
    std::cin >> n >> m;

    std::string str;
    std::cin >> str;

    std::vector<int32_t>* cards_bad = new  std::vector<int32_t>[n];
    std::vector<int32_t>* cards_good = new  std::vector<int32_t>[n];
    for(int32_t i = 0; i < n; i++) {
        int32_t k;
        std::cin >> k;

        for(int32_t j = 0; j < k; j++) {
            int32_t pos;
            char val;
            std::cin >> pos >> val;
            pos--;

            if(val != str[pos])
                cards_bad[i].push_back(pos);
            else
                cards_good[i].push_back(pos);
        }
    }

    std::vector<int32_t>* bad_per_state = new std::vector<int32_t>[m];
    for(int32_t i = 0; i < n; i++) {
        for(int32_t j = 0; j < cards_bad[i].size(); j++)
            bad_per_state[cards_bad[i][j]].push_back(i);
    }

    std::set<std::pair<int32_t, int32_t> > remains;
    int32_t* bad_remains = new int32_t[n];
    for(int32_t i = 0; i < n; i++) {
        remains.emplace(cards_bad[i].size(), i);
        bad_remains[i] = cards_bad[i].size();
    }
    bool* states = new bool[m];
    for(int32_t i = 0; i < m; i++)
        states[i] = false;

    std::vector<int32_t> answer;
    for(int32_t i = 0; i < n; i++) {
        int32_t improving = remains.begin()->second;

        if(remains.begin()->first != 0) {
            std::cout << -1;
            return 0;
        }

        remains.erase(remains.begin());

        for(int32_t j = 0; j < cards_good[improving].size(); j++) {
            if(states[cards_good[improving][j]])
                continue;
            states[cards_good[improving][j]] = true;
            //all that have bad here should be decreased
            for(int32_t k = 0; k < bad_per_state[cards_good[improving][j]].size(); k++) {
                auto it = remains.find({bad_remains[bad_per_state[cards_good[improving][j]][k]],
                                        bad_per_state[cards_good[improving][j]][k]});
                if(it == remains.end())
                    continue;
                remains.erase(it);
                bad_remains[bad_per_state[cards_good[improving][j]][k]]--;
                remains.emplace(bad_remains[bad_per_state[cards_good[improving][j]][k]],
                                bad_per_state[cards_good[improving][j]][k]);
            }
        }
        answer.push_back(improving);
    }

    for(int32_t i = 0; i < m; i++)
        if(!states[i]) {
            std::cout << -1;
            return 0;
        }

    for(int32_t i = 0 ;i < n; i++)
        std::cout << answer[i] + 1 << " ";
    return 0;
}
