#include <iostream>
#include <vector>
#include <set>

bool deletable(std::string str, int32_t k, bool** allow) {
    bool marked[26];
    for(int32_t i = 0; i < k; i++)
        marked[i] = false;
    marked[str[0] - 'a'] = true;
    for(int32_t i = 1; i < str.size(); i++) {
        bool ok = false;
        if(marked[str[0] - 'a'] && allow[str[0] - 'a'][str[i] - 'a'])
            ok = true;
        if(marked[str[i - 1] - 'a'] && allow[str[i - 1] - 'a'][str[i] - 'a'])
            ok = true;
        if(!ok)
            return false;
        marked[str[i] - 'a'] = true;
    }
    return true;
}

int main() {
    int32_t k, n;
    std::cin >> k >> n;

    bool** allow = new bool*[k];
    for(int32_t i = 0; i < k; i++) {
        allow[i] = new bool[k];
        std::string str;
        std::cin >> str;

        for(int32_t j = 0; j < k; j++) {
            allow[i][j] = str[j] == '1';
        }
    }

    std::string str;
    std::cin >> str;

    std::pair<std::string, std::string>* dp = new std::pair<std::string, std::string>[n + 1];
    dp[1].first.push_back(str[0]);
    dp[1].second.push_back(str[0]);
    for(int32_t i = 2; i <= n; i++) {
        //the symbol is not deleted
        dp[i].first = std::string (1, (char)('z' + 1));
        for(int32_t suf = 1; suf <= i; suf++)
            dp[i].first = std::min(dp[i].first, dp[i - suf].second + str.substr(i - suf, suf));

        //the symbol IS deleted
        dp[i].second = std::string (1, (char)('z' + 1));
        for(int32_t j = i - 1; j >= 1; j--) {
            if(deletable(str.substr(j - 1, i - j + 1), k, allow))
                dp[i].second = std::min(dp[i].second, dp[j].first);
        }
    }
    std::cout << std::min(dp[n].first, dp[n].second);
    return 0;
}
