#include <iostream>
#include <vector>
#include <set>

void color(bool** field, int32_t n, int32_t row, int32_t col) {
    for(int32_t i = 0; i <= row; i++)
        for(int32_t j = col; j < n; j++)
            field[i][j] = true;
}

int32_t clever_color(bool** field, int32_t n, int32_t row, int32_t col) {
    int32_t res = 0;
    for(int32_t i = 0; i <= row; i++)
        for(int32_t j = col; j < n; j++) {
            if(!field[i][j])
                res++;
            field[i][j] = true;
        }
    return res;
}

int32_t uncolored_close(bool** field, int32_t n, int32_t row, int32_t col) {
    int32_t res = 0;
    for(int32_t i = row; i >= std::max(row - 2, 0); i--)
        for(int32_t j = col; j < std::min(j + 3, n); j++) {
            if(!field[i][j])
                res++;
        }
    return res;
}

#define MOVES 2

int main() {
    int32_t mode;
    std::cin >> mode;

    int32_t n, k, m;
    std::cin >> n >> k >> m;

    bool** field = new bool*[n];
    for(int32_t i = 0 ; i < n; i++)
        field[i] = new bool[n];

    if(mode == 1) {
        std::string str;
        std::cin >> str;

        for(int32_t i = 0; i < m / MOVES; i++) {
            int32_t my_moves = 0;
            for(int32_t p = 0; p < n; p++) {
                for(int32_t j = 0; j < n; j++)
                    field[p][j] = false;
            }

            //encode the next 100 bits
            if(i % 2 == 1) {
                int32_t row, col;
                std::cin >> row >> col;
                row--;
                col--;

                color(field, n, row, col);
            }

            /*if(str[i] == '0') {
                std::cout << 1 << " " << 1 << std::endl;
            } else {
                std::cout << 2 << " " << 2 << std::endl;
                int32_t r, c;
                std::cin >> r >> c;

                std::cout << 1 << " " << 1 << std::endl;
            }*/
            while(true) {
                //I move
                if(my_moves == MOVES) {
                    std::cout << 1 << " " << 1 << std::endl;
                    break;
                }
                my_moves++;

                int32_t row = -1, col;
                if(str[i + my_moves] == '0') {
                    //find a 1
                    for(int32_t j = 0; j < n; j++)
                        for(int32_t p = 0; p < n; p++) {
                            if(!field[j][p] && (j == 0 || field[j - 1][p]) && (p == n - 1 || field[j][p + 1])) {
                                row = j;
                                col = p;
                            }
                        }
                } else {
                    //find a 2 or 3
                    for(int32_t j = 0; j < n && row == -1; j++)
                        for(int32_t p = 0; p < n; p++) {
                            if(field[j][p])
                                continue;
                            int32_t c = uncolored_close(field, n, j, p);
                            if(c <= 3 && c > 1) {
                                row = j;
                                col = p;
                                break;
                            }
                        }
                }

                std::cout << row + 1 << " " << col + 1 << std::endl;
                color(field, n, row, col);

                int32_t row2, col2;
                std::cin >> row2 >> col2;
                row2--;
                col2--;

                color(field, n, row2, col2);
            }
        }

        std::cout << 0 << std::endl;
    } else {
        std::string answer;

        int32_t games;
        std::cin >> games;

        for(int32_t i = 0; i < games; i++) {
            for(int32_t p = 0; p < n; p++) {
                for(int32_t j = 0; j < n; j++)
                    field[p][j] = false;
            }

            //int32_t num_moves = 0;
            for(int32_t j = 0; ; j++) {
                int32_t row, col;
                std::cin >> row >> col;
                row--;
                col--;

                int32_t num_colored = clever_color(field, n, row, col);
                if(i % 2 == j % 2) {
                    answer.push_back(num_colored == 1 ? '0' : '1');
                }
                //num_moves++;

                if(row == 0 && col == 0)
                    break;
            }

            //answer.push_back(num_moves > 2 ? '1' : '0');
        }

        std::cout << answer << std::endl;
    }
    return 0;
}