#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

#define endl '\n'

const int Base = 30;
const int BigBase = 5e5 + 15;

struct List
{
	List* prev = nullptr;
	List* next = nullptr;
	int val = 0;
};

int k, n;
List s[BigBase];
List sCopy[BigBase];
bool canDel[Base][Base];
//bitset<Base> canDel[Base];
vector<int> id[Base];

void tryDel(List* id)
{
	if (id == nullptr)
	{
		return;
	}

	List* prev = id->prev;

	if (prev == nullptr)
	{
		return;
	}

	int val1 = id->val;
	int val2 = prev->val;

	if (canDel[val2][val1])
	{
		List* next = id->next;
		if (next == nullptr)
		{
			prev->next = nullptr;
			tryDel(prev);
		}
		else
		{
			prev->next = next;
			next->prev = prev;
			tryDel(next);
		}
	}
	else
	{
		tryDel(prev);
	}
}

int toInt(char key)
{
	return key - 'a';
}

bool canDelBetween(int l, int r)
{
	if (l + 1 == r)
	{
		return true;
	}

	for (int i = l; i < r; i++)
	{
		sCopy[i].val = s[i].val;
		if (i > l)
		{
			sCopy[i].prev = &sCopy[i - 1];
		}
		else
		{
			sCopy[i].prev = nullptr;
		}
		if (i < r - 1)
		{
			sCopy[i].next = &sCopy[i + 1];
		}
		else
		{
			sCopy[i].next = nullptr;
		}
	}

	tryDel(&sCopy[r - 1]);

	return (sCopy[l].next == nullptr);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> k >> n;

	for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < k; j++)
		{
			char t;
			cin >> t;
			if (t == '0')
			{
				canDel[i][j] = false;
			}
			else
			{
				canDel[i][j] = true;
			}
		}
	}

	for (int i = 0; i < n; i++)
	{
		char key;
		cin >> key;
		s[i].val = toInt(key);
		if (i > 0)
		{
			s[i].prev = &s[i - 1];
		}
		if (i < n - 1)
		{
			s[i].next = &s[i + 1];
		}
	}

	for (int i = 0; i < n; i++)
	{
		id[s[i].val].push_back(i);
	}

	int current = 0;
	while (true)
	{
		cout << char(s[current].val + 'a');
		if (canDelBetween(current, n))
		{
			break;
		}

		for (int i = 0; i < k; i++)
		{
			int nextId = upper_bound(id[i].begin(), id[i].end(), current) - id[i].begin();
			if (nextId != id[i].size())
			{
				nextId = id[i][nextId];
				if (canDelBetween(current, nextId))
				{
					current = nextId;
					break;
				}
			}
		}
	}

	cout << endl;

	return 0;
}