#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

//#define endl '\n'

const int Base = 40;
const int BigBase = 5e5 + 15;

int t;
int n, k, m;
string mes = "";
bool used[Base][Base];
int gamesCnt = 0;

int paint(int x, int y)
{
	int cnt = 0;
	for (int i = x; i <= n; i++)
	{
		for (int j = y; j <= n; j++)
		{
			if (used[i][j])
			{
				break;
			}
			used[i][j] = true;
			cnt++;
		}
	}

	return cnt;
}

pair<int, int> find2()
{
	for (int i = 1; i <= 32; i++)
	{
		for (int j = 1; j <= 32; j++)
		{
			if (((used[i + 1][j] && !used[i][j + 1] && used[i][j + 2]) ||
				(used[i][j + 1] && !used[i + 1][j] && used[i + 2][j])) && !used[i][j])
			{
				return make_pair(i, j);
			}
		}
	}

	return make_pair(1, 1);
}

pair<int, int> find1()
{
	for (int i = 1; i <= 32; i++)
	{
		for (int j = 1; j <= 32; j++)
		{
			if (used[i + 1][j] && used[i][j + 1] && !used[i][j])
			{
				return make_pair(i, j);
			}
		}
	}

	return make_pair(1, 1);
}

int play(int id, bool turnAI)
{
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			used[i][j] = false;
		}
	}
	while (!used[2][1] && !used[1][2])
	{
		if (turnAI)
		{
			int x, y;
			cin >> x >> y;
			if (x == 1 && y == 1)
			{
				return id;
			}
			paint(x, y);
		}
		else
		{
			if (id == m)
			{
				cout << 1 << ' ' << 1 << endl;
				return id;
			}
			pair<int, int> move;
			if (mes[id] == '0')
			{
				move = find2();
			}
			else
			{
				move = find1();
			}
			if (move.first == 1 && move.second == 1)
			{
				cout << 1 << ' ' << 1 << endl;
				return id;
			}
			if ((move.first == 1 && move.second == 2) || (move.first == 2 && move.second == 1))
			{
				cout << 1 << ' ' << 1 << endl;
				return id;
			}
			cout << move.first << ' ' << move.second << endl;
			paint(move.first, move.second);
			id++;
		}
		turnAI = !turnAI;
	}
	if (used[1][2])
	{
		cout << 2 << ' ' << 1 << endl;
	}
	else
	{
		cout << 1 << ' ' << 2 << endl;
	}
	int x, y;
	cin >> x >> y;
	return id;
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif // _DEBUG

	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	cin >> n >> k >> m;

	for (int i = 0; i <= n + 1; i++)
	{
		for (int j = 0; j <= n + 1; j++)
		{
			used[i][j] = true;
		}
	}

	if (t == 1)
	{
		cin >> mes;
		int id = 0;
		bool startAI = false;
		while (id != m)
		{
			id = play(id, startAI);
			startAI = !startAI;
		}
		if (startAI)
		{
			int x, y;
			cin >> x >> y;
		}
		cout << 0 << endl;
	}
	else
	{
		cin >> gamesCnt;
		for (int i = 1; i <= n; i++)
		{
			for (int j = 1; j <= n; j++)
			{
				used[i][j] = false;
			}
		}
		bool startAI = false;
		bool turnAI = false;
		for (int i = 0; i < gamesCnt; i++)
		{
			while (true)
			{
				int x, y;
				cin >> x >> y;
				if (x == 1 && y == 1)
				{
					break;
				}
				if (turnAI)
				{
					paint(x, y);
				}
				else
				{
					int cnt = paint(x, y);
					if (!((x == 1 && y == 2) || (x == 2 && y == 1)))
					{
						mes.push_back(cnt % 2 + '0');
					}
				}
				turnAI = !turnAI;
			}
			startAI = !startAI;
			turnAI = startAI;
		}
		if (mes.size() != m)
		{
			return -1;
		}
		cout << mes << endl;
	}

	return 0;
}