#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAXN = 21;

vector<int> g[MAXN];
bool isLeaf[MAXN];
int taskNum[MAXN];

bool checkVec(vector<int>& h) {
	for (int i = 1; i < h.size(); ++i) {
		assert(h[i] != h[i - 1]);
		if (h[i] < h[i - 1]) return false;
	}
	return true;
}

vector<int> dfs(int v) {
	if (isLeaf[v]) {
		vector<int> h({g[v][taskNum[v]]});
		return h;
	}
	else {
		vector<vector<int>> tmp;
		for (int u : g[v]) {
			tmp.push_back(dfs(u));
		}
		sort(tmp.begin(), tmp.end());
		vector<int> h;
		h.reserve(20);
		do {
			h.resize(0);
			for (int i = 0; i < tmp.size(); ++i) {
				for (int j = 0; j < tmp[i].size(); ++j) {
					h.push_back(tmp[i][j]);
				}
			}
			if (checkVec(h)) {
				return h;
			}
		} while (next_permutation(tmp.begin(), tmp.end()));
		for (int i = 0; i < tmp.size(); ++i) {
			for (int j = 0; j < tmp[i].size(); ++j) {
				h.push_back(tmp[i][j]);
			}
		}
		return h;
	}
}

bool check() {
	vector<int> ans = dfs(0);
	return checkVec(ans);
}

vector<int> leafs;

bool rec(int pos) {
	if (pos == leafs.size()) return check();
	for (int i = 0; i < g[leafs[pos]].size(); ++i) {
		taskNum[leafs[pos]] = i;
		if (rec(pos + 1)) return true;
	}
	return false;
}

int main()
{
	int n;
	cin >> n;
	for (int v = 0; v < n; ++v) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int i = 0; i < k; ++i) {
				int u;
				cin >> u;
				--u;
				g[v].push_back(u);
			}
		}
		else {
			isLeaf[v] = true;
			leafs.push_back(v);
			int m;
			cin >> m;
			for (int i = 0; i < m; ++i) {
				int c;
				cin >> c;
				g[v].push_back(c);
			}
		}
	}
	if (rec(0)) {
		cout << "Yes\n";
	}
	else {
		cout << "No\n";
	}
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/

/*
5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/