#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

#define endl '\n'

struct Card
{
	vector<int> right;
	vector<int> wrong;
};

void task()
{
	int k, n;
	cin >> k >> n;

	vector<vector<int>> v(k, vector<int>(k));

	for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < k; j++)
		{
			char x;
			cin >> x;

			v[i][j] = x - '0';
		}
	}

	string str;

	cin >> str;

	vector<int> prefsum(n + 1);
	prefsum[0] = 0;

	vector<int> lastpos(k, -1);

	string ans;

	for (int i = 0; i < n; i++)
	{
		int sym = str[i] - 'a';

		bool del = false;

		for (int j = 0; j < k; j++)
		{
			if (v[j][sym] == 1 && lastpos[j] != -1)
			{
				int l = lastpos[j] + 1;
				int r = i;

				int sum = prefsum[r] - prefsum[l];

				if (sum == 0)
				{
					del = true;
					break;
				}
			}
		}

		if (del)
		{
			prefsum[i + 1] = prefsum[i];
		}
		else
		{
			prefsum[i + 1] = prefsum[i] + 1;
			ans.push_back(str[i]);
		}

		lastpos[sym] = i;
	}

	cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	task();

	return 0;
}
