#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>

#include <ctime>


struct Vec {
	int x, y;

	bool operator==(const Vec &other)const {
		return x == other.x && y == other.y;
	}
};

int n, k, m;

bool get(const std::vector<std::vector<bool>> &vec, Vec v, int d) {
	int res = 0;
	for (int i = v.x; i < std::min(n, v.x + d); i++) {
		for (int j = v.y; j < std::min(n, v.y + d); j++) {
			if (!vec[i][j]) {
				res++;
				if (res > d) {
					return false;
				}
			}
		}
	}
	return true;
}

std::vector<Vec> get(const std::vector<std::vector<bool>> &vec, int d) {
	std::vector<Vec> res;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (!vec[i][j] && get(vec, Vec{ i, j }, d)) {
				res.push_back(Vec{ i, j });
			}
		}
	}
	return res;
}

constexpr int G = 3;

int32_t main() {
	freopen("\\\\.\\pipe\\game.in", "r", stdin);
	freopen("\\\\.\\pipe\\game.out", "w", stdout);

	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int _t;
	std::cin >> _t;
	std::cin >> n >> k >> m;
	if (_t == 1) {
		std::vector<bool> mes(m);
		for (int i = 0; i < m; i++) {
			char ch;
			std::cin >> ch;
			mes[i] = ch == '1';
		}
		std::reverse(mes.begin(), mes.end());

		for (bool first = true; !mes.empty(); first ^= true) {
			std::vector<std::vector<bool>> vec(n, std::vector<bool>(n, false));
			bool turn = first;
			while (vec != std::vector<std::vector<bool>>(n, std::vector<bool>(n, true))) {
				int x, y;
				if (turn) {
					auto ps = get(vec, G);
					std::sort(ps.begin(), ps.end(), [](Vec a, Vec b) {return std::pair{ a.x, a.y } < std::pair{ b.x, b.y }; });
					int r = 0;
					for (; (1 << r) <= ps.size(); r++) {
						;
					}
					r--;
					r = std::min<int>(r, mes.size());
					int p = 0;
					while (r--) {
						p *= 2;
						if (mes.back()) {
							p++;
						}
						mes.pop_back();
					}
					x = ps[p].x;
					y = ps[p].y;
					std::cout << x + 1 << " " << y + 1 << std::endl;

				} else {
					std::cin >> x >> y;
					x--; y--;
				}

				for (int i = x; i < n; i++) {
					for (int j = y; j < n; j++) {
						vec[i][j] = true;
					}
				}

				turn ^= true;
			}
		}
		std::cout << "0" << std::endl;
	} else {
		int goFuck;
		std::cin >> goFuck;

		std::vector<bool> mes;
		for (bool first = true; mes.size() < m; first ^= true) {
			std::vector<std::vector<bool>> vec(n, std::vector<bool>(n, false));
			bool turn = first;
			while (vec != std::vector<std::vector<bool>>(n, std::vector<bool>(n, true))) {
				int x, y;
				if (turn) {
					auto ps = get(vec, G);
					std::sort(ps.begin(), ps.end(), [](Vec a, Vec b) {return std::pair{ a.x, a.y } < std::pair{ b.x, b.y }; });
					int r = 0;
					for (; (1 << r) <= ps.size(); r++) {
						;
					}
					r--;
					r = std::min<int>(r, m - mes.size());
					std::cin >> x >> y;
					x--; y--;
					int p = std::find(ps.begin(), ps.end(), Vec{ x, y }) - ps.begin();
					for (int i = 0; i < r; i++) {
						mes.push_back((p >> i) & 1);
					}
				} else {
					std::cin >> x >> y;
					x--; y--;
				}

				for (int i = x; i < n; i++) {
					for (int j = y; j < n; j++) {
						vec[i][j] = true;
					}
				}

				turn ^= true;
			}
		}
		for (int i = 0; i < m; i++) {
			std::cout << mes[i];
		}
		std::cout << std::endl;
	}



	return 0;
}

/*
1
4 4 4
0101

2 3
1 1
1 1
3 2
1 1
1 1
2 3
1 1
1 1
3 2
1 1




*/