#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end();

const int N = 100 * 1000 + 7;

void fail() {
	cout << -1 << endl;
	exit(0);
}

int n, m;
string s;

vector< pair<int, char> > poses[N];
vector<int> bad[N];
int ineq[N], ki[N];
bool blocked[N];
set< pair<int, int> > st;

void solve() {
	vector<int> ans;
	while (!st.empty()) {
		pair<int, int> P = *st.begin();
		st.erase(P);
		if (P.first != 0) {
			fail();
		}
		int id = P.second;
		ans.push_back(id);

		for (auto pa : poses[id]) {
			int pos = pa.first;

			if (!blocked[pos]) {
				blocked[pos] = true;
				for (int i : bad[pos]) {
					st.erase({ineq[i], i});
					ineq[i]--;
					st.insert({ineq[i], i});
				}
			}
		}
	}

	if (ans.size() != n) {
		fail();
	}
	for (int i = 1; i <= m; ++i) {
		if (!blocked[i]) {
			fail();
		}
	}
	for (int x : ans) {
		cout << x << ' ';
	}
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	cin >> s;
	for (int i = 1; i <= n; ++i) {
		cin >> ki[i];
		for (int it = 0; it < ki[i]; ++it) {
			int a;
			char c;
			cin >> a >> c;

			poses[i].push_back({a, c});

			if (c != s[a - 1]) {
				++ineq[i];
				bad[a].push_back(i);
			}
		}
		st.insert({ineq[i], i});
	}
	solve();

	return 0;
}

/*

1 1
a
1 1 a


3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f



2 2
aa
2 1 a 2 b
2 1 b 2 a

*/