#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define all(v) v.begin(), v.end();

const int N = 10002; // may be needed 10000

struct fenwick
{
	int n;

	vector<int> t;

	fenwick() {
		n = 0;
		t.clear();
	}

	fenwick(int _n) {
		n = _n + 1;
		t.resize(n + 1);
	}

	void update(int i, int x) {
		for (; i <= n; i |= (i + 1)) {
			t[i] = max(t[i], x);
		}
	}
	int res = 0;
	int get(int r) {
		res = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			res = max(res, t[r]);
		}
		return res;
	}
};

int k, n;
string s;
bool A[N][N];
int right[N];

int R[N][26];

fenwick f[26];

void find_right() {
	for (int c = 0; c < 26; ++c) {
		R[n + 1][c] = n;
	}
	for (int c = 0; c < 26; ++c) {
		f[c] = fenwick(n + 1);
	}
	for (int i = n; i >= 1; --i) {
		for (int c = 0; c < 26; ++c) {
			if (i == n) {
				if (A[c][s[i] - 'a']) {
					R[i][c] = n;
				} else {
					R[i][c] = n - 1;
				}
			} else {
				if (A[c][s[i] - 'a']) {
					int to = R[i + 1][s[i] - 'a'];
					R[i][c] = f[c].get(min(n + 1, to + 1));
					for (int j = i + 1; j <= min(n + 1, to + 1); ++j) {
						uax(R[i][c], R[j][c]);
					}
				} else {
					R[i][c] = i - 1;
				}
			}
			f[c].update(i, R[i][c]);
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (i == n) {
			right[i] = n;
		} else {
			right[i] = R[i + 1][s[i] - 'a'];
		}
	}
}

string lexmin[N];

bool enclosed(int l1, int r1, int l2, int r2) {
	return l1 <= l2 && r2 <= r1;
}

void solve() {
	find_right();
	for (int i = 1; i <= n; ++i) {
		for (int j = i + 1; j <= n; ++j) {
			int l1 = i + 1;
			int r1 = right[i] + 1;
			int l2 = j + 1;
			int r2 = right[j] + 1;
			if (!enclosed(l1, r1, l2, r2) && !enclosed(l2, r2, l1, r1) && max(l1, l2) <= min(r1, r2)) {
				exit(-1);
			}
		}
	}
	for (int i = 0; i <= n; ++i) {
		lexmin[i] = "{";
	}
	lexmin[n + 1] = "";
	string ans = "{";
	for (int i = n; i >= 1; --i) {
		if (i == n) {
			lexmin[i] = "";
			lexmin[i] += s[i];
		} else {
			for (int to = i; to <= right[i]; ++to) {
				string cur = "";
				cur += s[i];
				cur += lexmin[to + 1];

				lexmin[i] = min(lexmin[i], cur);
			}
		}
	}
	cout << lexmin[1] << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> k >> n;

	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			A[i][j] = (c - '0');
		}
	}
	cin >> s;
	s = " " + s;
	solve();
	return 0;
}


/*

3 7
010
001
100
abacaba


3 5
010
001
100
bcacb

*/