#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <queue>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define next next228
#define prev prev228
#define list list228
#define all(v) v.begin(), v.end();

int n, k, m;
int a[35][35];
int sum[35][35];


void clear_all() {
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			a[i][j] = sum[i][j] = 0;
		}
	}
}

int make_turn(int x, int y) {
	int cnt = 0;
	for (int i = x; i <= n; ++i) {
		for (int j = y; j <= n; ++j) {
			if (a[i][j] == 0) {
				++cnt;
				a[i][j] = 1;
			}
		}
	}
	for (int i = n; i >= 1; --i) {
		for (int j = n; j >= 1; --j) {
			sum[i][j] = sum[i + 1][j] + sum[i][j + 1] - sum[i + 1][j + 1];
			sum[i][j] += (a[i][j] == 0);
		}
	}
	return cnt;
}

int count_move(int x, int y) {
	return sum[x][y];
}

void ask(int x, int y) {
	cout << x << " " << y << endl;
	make_turn(x, y);
}

void solve1() {
	cin >> n >> k >> m;
	string s;
	cin >> s;
	int start_turn = 0;

	int ptr = 0;

	bool stop_game = false;

	while (1) {
		// start game
		{
			// clear
			clear_all();
		}

		int turn = start_turn;

		while (1) {

			if (turn == 0) {
				// my turn

				if (stop_game) {
					cout << 0 << endl;
					exit(0);
				}

				if (ptr >= m) {
					ask(1, 1);
					stop_game = true;
					break;
				}
				int mask = 0;
				for (int i = 0; i < 4; ++i) {
					mask += (1 << i) * (s[ptr + i] - '0');
				}

				int X = -1;
				int Y = -1;

				int cnt = 0;
				for (int x = n; x >= 1; --x) {
					for (int y = n; y >= 1; --y) {
						if (a[x][y] == 0) {
							++cnt;
							if (cnt == mask + 1) {
								X = x;
								Y = y;
								break;
							}
						}
					}
					if (X != -1) {
						break;
					}
				}

				if (X == -1 || (X == 1 && Y == 1)) {
					ask(1, 1);
					break;
				}

				ask(X, Y);
				make_turn(X, Y);
				ptr += 4;
			} else {
				// bot turn
				int x, y;
				cin >> x >> y;
				make_turn(x, y);

				if (x == 1 && y == 1) {
					break;
				}
			}
			turn ^= 1;
		}

		start_turn ^= 1;
	}
}

void solve2() {
	cin >> n >> k >> m;
	int games;
	cin >> games;
	int start_turn = 0;

	string ans = "";

	for (int iter = 0; iter < games; ++iter) {
		clear_all();
		vector< pair<int, int> > list;
		int _x, _y;
		while (1) {
			cin >> _x;
			if (_x == 0) {
				break;
			}
			cin >> _y;
			list.push_back(make_pair(_x, _y));
			if (_x == 1 && _y == 1) {
				break;
			}
		}

		for (int i = 0; i < (int)list.size(); ++i) {
			int x = list[i].first;
			int y = list[i].second;

			int cnt = count_move(x, y);

			if (i % 2 == start_turn) {
				if (x != 1 || y != 1) {
					int cnt = 0;
					bool done = false;
					for (int X = n; X >= 1; --X) {
						for (int Y = n; Y >= 1; --Y) {
							if (a[X][Y] == 0) {
								++cnt;
								if (X == x && Y == y) {
									done = true;
									break;
								}
							}
						}
						if (done) {
							break;
						}
					}
					if (done) {
						int mask = cnt - 1;
						for (int bit = 0; bit < 4; ++bit) {
							int cur = (mask >> bit) & 1;
							ans += char('0' + cur);
						}
					}
				}
			}
			make_turn(x, y);
		}

		start_turn ^= 1;
	}

	while ((int)ans.size() > m) {
		ans.pop_back();
	}

	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	// freopen("/tmp/game.in", "r", stdin); 
	// freopen("/tmp/game.out", "w", stdout);
	int type;
	cin >> type;
	if (type == 1) {
		solve1();
	} else {
		solve2();
	}
	return 0;
}