#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

ll n, m, nxt = 0;
lvec s;
vector<lvec> field;
vector<lvec> up, ans;

#pragma GCC optimize(-O3)

void epic_fail() {
    cout << 0;
    exit(0);
}

void prep() {
    up.assign(n + 1, lvec(n + 1));
    ans.assign(n + 1, lvec(n + 1));
    for (ll i = n - 1; i > -1; i--)
        for (ll j = n - 1; j > -1; j--)
            if (field[i][j])
                up[i][j] = up[i + 1][j];
            else
                up[i][j] = up[i + 1][j] + 1;
    for (ll i = n - 1; i > -1; i--)
        for (ll j = n - 1; j > -1; j--)
            ans[i][j] = ans[i][j + 1] + up[i][j];
}


vector<lpair> find(ll num) {
    vector<pair<ll, lpair> > s;
    s.reserve(n * n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            if (field[i][j]) continue;
            s.push_back({ans[i][j], {i, j}});
            }
    }
    sort(s.begin(), s.end());
    vector<lpair> a;
    for(ll i =0; i < num && i < s.size(); i++)
        a.push_back(s[i].second);
    return a;
}

void mark(ll x, ll y) {
    for (ll i = x; i < n; i++)
        for (ll j = y; j < n; j++)
            field[i][j] = 1;
}

bool ops() {
    ll x, y;
    cin >> x >> y;
    x--;
    y--;
    if (x == 0 && y == 0) return true;
    mark(x, y);
    return false;
}

void print(lpair p) {
    cout << p.first + 1 << " " << p.second + 1 << endl;
    cerr << p.first + 1 << " " << p.second + 1 << "\n";
}

ll get() {
    if (nxt < m) {
        nxt++;
        return s[nxt - 1];
    } else return 1;
}

bool our() {
    prep();
    auto v = find(2);
    if (v.size() == 1) {
        print(v[0]);
        return true;
    }
    ll bit = get();
    print(v[bit]);
    mark(v[bit].first, v[bit].second);
    if (v[bit] == make_pair(0ll, 0ll)) return true;
    return false;
}

bool our2() {
    prep();
    auto v = find(2);
    if (v.size() == 1) {
        ll a;
        cin >> a >> a;
        return true;
    }
    lpair p;
    cin >> p.first >> p.second;
    p.first--;
    p.second--;
    mark(p.first, p.second);
    ll bit = 0;
    if (v[1] == p) bit = 1;
    s[nxt] = bit;
    nxt++;
    if (nxt == m) {
        for (auto el : s) cout << el;
        cout << endl;
        exit(0);
    }
    if (p == make_pair(0ll, 0ll)) return true;
    return false;
}

void game(bool first) {
    field.clear();
    field.resize(n + 1, lvec(n + 1));
    if (first) {
        our();
    }
    while (true) {
        if (ops())
            break;
        if (our())
            break;
    }
}

void game2(bool first) {
    field.assign(n + 1, lvec(n + 1));
    if (first) {
        our2();
    }
    while (true) {
        if (ops())
            break;
        if (our2())
            break;
    }
}

void session() {
    bool first = true;
    while (nxt != m) {
        game(first);
        first = !first;
    }
    if (!first) {
        ll a;
        cin >> a >> a;
    }
    epic_fail();
}

void session2() {
    bool first = true;
    while (nxt != m) {
        game2(first);
        first = !first;
    }
}

int main() {
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
   // freopen("\\\\.\\pipe\\game.out", "w", stdout);
    //freopen("log", "r", stdin);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    ll t, k, num = 0;
    cin >> t >> n >> k >> m;
    if (t == 2) cin >> num;
    s.resize(m);
    if (t == 1) {
        for (ll i = 0; i < m; i++) {
            char c = 0;
            cin >> c;
            s[i] = c - '0';
        }
    }
    if (t == 1) session();
    else session2();
    return 0;
}
