#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

bool intersect(lpair a, lpair b) {
    if (a.first > b.first) swap(a, b);
    return b.first < a.second;
}

lpair unite(lpair a, lpair b) {
    if (a.first > b.first) swap(a, b);
    return {a.first, b.second};
}

set<lpair> merge(set<lpair> a, set<lpair> b) {
    set<lpair> ans;
    for (auto &el : a)
        for (auto &em : b)
            if (!intersect(el, em))
                ans.insert(unite(el, em));
    return ans;
}

vector<lvec> g;

vector<lvec> bot;

set<lpair> dfs(ll v) {
    set<lpair> ans;
    if (g[v].empty()) {
        for (auto &el : bot[v]) {
            ans.insert({el, el});
        }
        return ans;
    }
    vector<set<lpair>> report(g[v].size());
    lvec permut(g[v].size());
    for (ll i = 0; i < g[v].size(); i++) {
        ll u = g[v][i];
        permut[i] = i;
        report[i] = dfs(u);
    }
    do {
        set<lpair> cur = report[permut[0]];
        for (ll i = 1; i < g[v].size(); i++) {
            cur = merge(cur, report[permut[i]]);
        }
        for(auto &el : cur)
            ans.insert(el);
    } while (next_permutation(permut.begin(), permut.end()));
    return ans;
}

int main() {
    //freopen("A2.in", "r", stdin);
    ll n;
    cin >> n;
    g.resize(n);
    bot.resize(n);
    for (ll i = 0; i < n; i++) {
        ll type, m;
        cin >> type >> m;
        if (type == 1) {
            g[i].resize(m);
            for (auto &el : g[i]) {cin >> el; --el;}
        } else {
            bot[i].resize(m);
            for (auto &el:bot[i]) cin >> el;
        }
    }
    if(dfs(0).empty()) cout << "No";
    else cout << "Yes";
    return 0;
}
