#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
#include <cmath>

using namespace std;
typedef long long LL;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	string key;
	cin >> key;

	vector<set<int>> badcards(n), goodcards(n);

	vector<set<int>> cardsWithBlock(m);

	vector<int> readyIds;

	vector<bool> used(n, false);

	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;


		bool hasBad = false;
		for (int j = 0; j < k; j++)
		{
			int a;
			char c;
			cin >> a >> c;
			a--;

			if (key[a] == c) {
				goodcards[i].insert(a);
			}
			else {
				badcards[i].insert(a);
				cardsWithBlock[a].insert(i);
				hasBad = true;
			}
		}

		if (!hasBad) {
			readyIds.push_back(i);
		}
	}

	vector<int> order;

	vector<bool> cleared(m, false);

	while (readyIds.size() > 0)
	{
		int current = readyIds.back();
		readyIds.pop_back();
		used[current] = true;
		order.push_back(current);

		for (auto pos : goodcards[current])
		{
			if (cleared[pos]) continue;
			cleared[pos] = true;
			for (auto id : cardsWithBlock[pos])
			{
				if (used[id]) continue;
				badcards[id].erase(pos);
				if (badcards[id].size() == 0) {
					readyIds.push_back(id);
				}
			}
		}
	}

	if (order.size() == n) {
		for (auto id : order)
		{
			cout << id + 1 << " ";
		}
		cout << endl;
	}
	else {
		cout << -1 << endl;
	}

	return 0;

}