#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

template<typename T>
vec<T> operator+(vec<T> a, vec<T> b) {
	for (auto x : b) {
		a.push_back(x);
	}
	return a;
}

const int INF = 1e9;

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int k, n;
	cin >> k >> n;
	vec<vec<int>> can(k, vec<int>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			can[i][j] = c - '0';
		}
	}
	auto ok = [&](vec<int> cur_a) -> bool {
		int pos = INF;
		while (len(cur_a) > 1) {
			pos = min(pos, len(cur_a) - 2);
			while (pos >= 0 && !can[cur_a[pos]][cur_a[pos + 1]]) {
				pos--;
			}
			if (pos == -1) {
				break;
			}
			cur_a.erase(cur_a.begin() + pos + 1);
			pos++;
		}
		return (len(cur_a) == 1);
	};
	vec<int> a(n);
	for (auto &x : a) {
		char c;
		cin >> c;
		x = c - 'a';
	}
	map<int, int> last;
	vec<int> to(n);
	for (int i = 0; i < n; i++) {
		int who = -1;
		for (int j = 0; j < k; j++) {
			if (can[j][a[i]]) {
				if (last.find(j) == last.end()) {
					continue;
				}
				if (who == -1 || last[who] < last[j]) {
					who = j;
				}
			}
		}
		if (who != -1) {
			to[last[who]] = i;
		}
		last[a[i]] = i;
	}
	vec<int> pref_max(n + 1);
	for (int i = 0; i < n; i++) {
		pref_max[i + 1] = max(pref_max[i], to[i]);
	}
	vec<char> special(n);
	vec<int> poses;
	for (int i = 0; i < n; i++) {
		if (pref_max[i] <= i) {
			special[i] = 1;
			poses.push_back(i);
		}
	}
	assert(special[0] && special[n - 1]);
	vec<vec<int>> dp(n, vec<int>(n));
	vec<int> mx(n);
	mx[n - 1] = n - 1;
	for (int i = len(poses) - 1; i > 0; i--) {
		int from = poses[i - 1], to = poses[i];
		int l = from, r = to + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (ok(vec<int>(a.begin() + from, a.begin() + mid + 1))) {
				l = mid;
			} else {
				r = mid;
			}
		}
		mx[from] = l;
		if (l == to) {
			mx[from] = mx[to];
		}
		for (int j = from; j <= mx[from]; j++) {
			dp[from + 1][j] = 1;
		}
	}
	dbg(poses);
	dbg(dp);
	// for (int i = 1; i < n; i++) {
	// 	int l = i - 1, r = n;
	// 	while (r - l > 1) {
	// 		int j = (l + r) / 2;
	// 		vec<int> cur_a(a.begin() + i - 1, a.begin() + j + 1);
	// 		if (ok(cur_a)) {
	// 			l = j;
	// 		} else {
	// 			r = j;
	// 		}
	// 	}
	// 	for (int k = i; k <= l; k++) {
	// 		dp[i][k] = 1;
	// 	}
	// }
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < i; j++) {
			dp[i][j] = 1;
		}
	}
	vec<int> ans{a[0]};
	vec<vec<int>> res(n);
	res.back() = {a.back()};
	for (int i = n - 2; i >= 0; i--) {
		if (dp[i + 1][n - 1]) {
			res[i] = {a[i]};
		} else {
			res[i] = {INF};
			for (int j = i + 1; j < n; j++) {
				if (dp[i + 1][j - 1]) {
					res[i] = min(res[i], res[j]);
				}
			}
			res[i].insert(res[i].begin(), a[i]);
		}
	}
	for (auto x : res[0]) {
		cout << char(x + 'a');
	}
	cout << '\n';
	// for (int i = 1; i < n;) {
	// 	if (dp[i][n - 1]) {
	// 		break;
	// 	}
	// 	for (int cur = 0; cur <= k; cur++) {
	// 		if (a[i] == cur) {
	// 			ans.push_back(cur);
	// 			i++;
	// 			break;
	// 		}
	// 		bool fnd = false;
	// 		for (int j = i + 1; j < n; j++) {
	// 			if (a[j] == cur && dp[i][j - 1]) {
	// 				fnd = true;
	// 				i = j + 1;
	// 				break;
	// 			}
	// 		}
	// 		if (fnd) {
	// 			ans.push_back(cur);
	// 			break;
	// 		}
	// 	}
	// }
	// for (auto x : ans) {
	// 	cout << char(x + 'a');
	// }
	// cout << '\n';
}
