#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

const int INF = 1e9;

int n;
vec<vec<int>> g;
vec<vec<int>> vals;
vec<int> coords;
vec<vec<int>> dp;
vec<vec<int>> who;

inline void resize_all() {
	g.resize(n);
	vals.resize(n);
}

inline int calc(int v, const vec<int> &ord, int l) {
	for (auto i : ord) {
		if (l >= len(coords)) {
			l = INF;
			break;
		}
		int u = g[v][i];
		l = dp[u][l] + 1;
	}
	l--;
	return l;
}

void dfs(int v) {
	if (!len(g[v])) {
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
	}
	vec<int> ord(len(g[v]));
	iota(all(ord), 0);
	do {
		for (int l = 0; l < len(coords); l++) {
			dp[v][l] = min(dp[v][l], calc(v, ord, l));
		}
	} while (next_permutation(all(ord)));
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	cin >> n;
	resize_all();
	for (int i = 0; i < n; i++) {
		int type, sz;
		cin >> type >> sz;
		vec<int> cur(sz);
		for (auto &x : cur) {
			cin >> x;
			x--;
		}
		if (type == 1) {
			g[i] = cur;
		} else {
			sort(all(cur));
			vals[i] = cur;
			for (auto x : vals[i]) {
				coords.push_back(x);
			}
		}
	}
	sort(all(coords));
	coords.resize(unique(all(coords)) - coords.begin());
	auto get_id = [&](int x) -> int {
		return lower_bound(all(coords), x) - coords.begin();
	};
	for (int i = 0; i < n; i++) {
		for (auto &x : vals[i]) {
			x = get_id(x);
		}
	}
	dp.resize(n, vec<int>(len(coords), INF));
	who.resize(n, vec<int>(len(coords), -1));
	for (int i = 0; i < n; i++) {
		if (!len(g[i])) {
			int pos = 0;
			for (int j = 0; j < len(coords); j++) {
				while (pos < len(vals[i]) && vals[i][pos] < j) {
					pos++;
				}
				if (pos == len(vals[i])) {
					break;
				}
				dp[i][j] = vals[i][pos];
				who[i][j] = pos;
			}
		}
	}
	dfs(0);
	if (dp[0][0] == INF) {
		cout << "No\n";
	} else {
		cout << "Yes\n";
	}
}
