#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size(0)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

signed main() {
    fastio;

    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<string> perfo(n, string(m, '#'));

    for (int i = 0; i < n; ++i) {
        int k; cin >> k;

        while (k--) {
            int pos; cin >> pos;
            char c; cin >> c;
            perfo[i][--pos] = c;
        }
    }

    int idx = 0, usedPerfo = 0;
    vector<bool> used(m, false);
    vector<int> place(n, -1);

    while (usedPerfo < n) {
        bool found = false;

        for (int i = 0; i < n; ++i) {
            if (place[i] != -1) continue;
            bool ok = true;

            for (int j = 0; j < m; ++j) {
                if (perfo[i][j] == '#') continue;
                if (!used[j] && perfo[i][j] != s[j]) {
                    ok = false;
                    break;
                }
            }

            if (ok) {
                for (int j = 0; j < m; ++j) {
                    if (perfo[i][j] != '#')
                        used[j] = true;
                }

                place[i] = usedPerfo++;
                found = true;

                break;
            }
        }

        if (!found) {
            cout << -1;
            return 0;
        }
    }

    bool check = true;

    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            check = false;
            break;
        }
    }

    if (check) {
        vector<pair<int, int>> ans;

        for (int i = 0; i < n; ++i) {
            if (place[i] == -1) ans.push_back({INF, i});
            else ans.push_back({place[i], i});
        }

        sort(ans.begin(), ans.end());

        for (auto &[trash, num] : ans) cout << num + 1 << " ";
    }
    else {
        cout << -1;
    }

    return 0;
}