#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 32, K = 8, M = 1e5;

char secret[M + 10];

int n, k, m;
int field[N];

const int MAGIC = 32;

mt19937 rnd(1);

auto calc_moves(int &cnt) {
	vector<pair<int, pair<int, int>>> res;
	for (int i = 0; i < n; ++i) {
		for (int j = field[i]; j < min(n, field[i] + MAGIC); ++j) {
			int score = 0;
			for (int h = i; h < n; ++h) {
				score += max(0, j - field[h] + 1);
			}
			if (score <= 3)
				res.push_back({score, {i, j}});
		}
	}
	sort(all(res));
	int i = 1;
	int iter = 0;
	while (i * 2 <= sz(res))
		i *= 2, ++iter;
	cnt = iter;
	res.resize(i);
	shuffle(all(res), rnd);
	return res;
}

void apply_move(int x, int y) {
	for (int i = x; i < n; ++i)
		field[i] = max(field[i], y + 1);
}

void solve1() {
	cin >> n >> k >> m >> secret;
	int iter = 0;
	int first = 0, curr = 0, ourcnt = 0;
	int movex, movey;
	auto upd_data = [&]() {
		if (movex == 0 && movey == n - 1) {
			first ^= 1, curr = first;
			fill(all(field), 0);
			ourcnt = 0;
		} else {
			curr = 1 - curr;
		}
	};
	while (iter < m) {
		if (curr == 0) {
			int today;
			auto moves = calc_moves(today);
			int value = 0;
			for (int i = 0; i < today && iter < m; ++i, ++iter) {
				value += (secret[iter] - '0') << i;
			}
			cerr << sz(moves) << endl;
			// cerr << "move at " << value << endl;
			movex = moves[value].y.x;
			movey = moves[value].y.y;
			for (int i = 0; i < n; ++i)
				cerr << field[i] << " ";
			cerr << endl;
			cerr << value << " " << movex << " " << movey << endl;
			cout << movex + 1 << " " << n - movey << endl;
			++ourcnt;
		} else {
			cin >> movex >> movey;
			--movex;
			movey = n - movey;
		}
		apply_move(movex, movey);
		upd_data();
	}
	if (curr != 0) {
		cin >> movex >> movey;
		--movex;
		movey = n - movey;
		upd_data();
	}
	if (ourcnt)
		cout << "1 1" << endl;
	cout << "0" << endl;
}

void solve2() {
	cin >> n >> k >> m >> secret;
	int iter = 0;
	int first = 0, curr = 0, ourcnt = 0;
	int movex, movey;
	auto upd_data = [&]() {
		if (movex == 0 && movey == n - 1) {
			first ^= 1, curr = first;
			fill(all(field), 0);
			ourcnt = 0;
		} else {
			curr = 1 - curr;
		}
	};
	while (iter < m) {
		cin >> movex >> movey;
		--movex;
		movey = n - movey;
		if (curr == 0) {
			int today;
			auto moves = calc_moves(today);
			int value = 0;
			for (int i = 0; i < sz(moves); ++i) {
				if (moves[i].y == pair<int, int>{movex, movey})
					value = i;
			}
			// cerr << "decoded " << value << endl;
			for (int i = 0; i < today && iter < m; ++i, ++iter) {
				secret[iter] = (value >> i & 1) + '0';
			}
		}
		apply_move(movex, movey);
		upd_data();
	}
	secret[m] = 0;
	cout << secret << endl;
}

signed main() {
#ifdef DEBUG
	// assert(freopen("/tmp/game.in", "r", stdin)); 
	// assert(freopen("/tmp/game.out", "w", stdout));
	assert(freopen("log.txt", "r", stdin));
#endif
	int type;
	cin >> type;
	if (type == 1) {
		solve1();
	} else {
		solve2();
	}
	return 0;
}