#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int k, n;
string s;
vector<vector<bool>> can_delete;

bool can_remove_substring(int l, int r) {
    vector<int> prev(r - l, -1);
    for (int i = 0; i < r - l - 1; ++i) {
        prev[i] = i + 1;
    }
    int len = r - l;
    while (len > 1) {
        bool changed = false;
        for (int j = r - l - 1; j >= 0; --j) {
            if (prev[j] == -1) continue;
            int c_o = s[l + j] - 'a';
            int c_j = s[l + prev[j]] - 'a';
            if (can_delete[c_o][c_j]) {
                changed = true;
                len--;
                prev[j] = prev[prev[j]];
                break;
            }
        }
        if (!changed) {
            break;
        }
    }
    return len == 1;
}

int solve() {
    if (!(cin >> k >> n))
        return 1;
    can_delete.clear();
    can_delete.resize(k, vector<bool>(k, false));
    for (int i = 0; i < k; ++i) {
        string e;
        cin >> e;
        for (int j = 0; j < k; ++j) {
            if (e[j] == '1') {
                can_delete[i][j] = true;
            }
        }
    }

    cin >> s;
    s += ('a' - 1);

    string answer;
    int cur_pos = 0;
    while (cur_pos != n) {
        answer += s[cur_pos];
        if (cur_pos == n - 1) break;
        int next_pos = cur_pos + 1;
        for (int i = next_pos; i <= n; ++i) {
            if (!can_remove_substring(cur_pos, i)) break;
            if (s[i] <= s[next_pos]) {
                next_pos = i;
            }
        }
        cur_pos = next_pos;
    }
    cout << answer << '\n';

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
