#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto& e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    solve();
}

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> ps(n);
    for (int i = 0; i < n; i++) {
        int sz;
        cin >> sz;
        ps[i] = vector<pair<int, char>>(sz);
        cin >> ps[i];
    }

    deque<pair<int, vector<pair<int, char>>>> queue(n);
    for (int i = 0; i < n; i++)
        queue[i] = {i, ps[i]};

    int MAX_ITER = 1e5 + 10;
    vector<bool> completed(m, false);
    deque<int> ans;
    for (int iter = 0; iter < MAX_ITER && !queue.empty(); iter++) {
        auto [idx, tt] = queue.front();
        queue.pop_front();
        bool ok = true;
        for (auto & e : tt) {
            if (s[e.first - 1] != e.second && !completed[e.first - 1])
                ok = false;
        }
        if (!ok) {
            queue.emplace_back(idx, tt);
            continue;
        }
        for (auto & e : tt) {
            completed[e.first - 1] = true;
        }
        ans.push_back(idx + 1);
    }
    if (ans.size() != n || !queue.empty()) {
        cout << "-1\n";
        return;
    }
    for (bool r : completed) {
        if (!r) {
            cout << "-1\n";
            return;
        }
    }
    for (int e : ans)
        cout << e << ' ';
    cout << '\n';
}