#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1e5;

vector <vector <int>> g(N);
vector <bool> used(N);
vector <int> ts;

void Dfs(int v) {
	used[v] = true;
	for (auto i : g[v]) {
		if (!used[i]) {
			Dfs(i);
		}
	}
	ts.push_back(v);
}

void Solve() {
	int n, m; string s;
	cin >> n >> m >> s;
	vector <vector <int>> cor(m);
	vector <vector <int>> incor(m);

	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		for (int j = 0; j < t; j++) {
			int a; char c;
			cin >> a >> c;
			a--;
			if (s[a] == c) cor[a].push_back(i);
			else incor[a].push_back(i);
		}
	}

	for (int i = 0; i < m; i++) {
		if (cor[i].empty()) {
			cout << -1;
			return;
		}
		for (auto f : incor[i]) {
			for (auto s : cor[i]) {
				g[f].push_back(s);
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) Dfs(i);
	}
	reverse(ts.begin(), ts.end());
	set <int> was;
	bool bad = false;
	for (int i = 0; i < n; i++) {
		for (auto j : g[ts[i]])
			if (was.count(j))
				bad = true;
		was.insert(ts[i]);
	}
	if (bad) {
		cout << -1;
		return;
	}
	for (int i = n - 1; i >= 0; i--)
	{
		cout << ts[i] + 1 << " ";
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}