#include <iostream>
#include <set>
#include <vector>
#include <cassert>

using namespace std;

struct cmp
{
	bool operator() (const pair<int, int>& a, const pair<int, int>& b) const
	{
		int sa = a.first + a.second, sb = b.first + b.second;
		if (sa == sb)
			return a.first > b.first;
		return (sa > sb);
	}
};

const int cnt = 1;
int n;
set<pair<int, int>, cmp> free_cells[(1 << cnt)][(1 << cnt)];

int get_s()
{
	int s = 0;
	for (int i = 0; i < (1 << cnt); i++)
	{
		for (int j = 0; j < (1 << cnt); j++)
			s += free_cells[i][j].size();
	}
	return s;
}

void fill_free_cells()
{
	for (int i = 0; i < (1 << cnt); i++)
	{
		for (int j = 0; j < (1 << cnt); j++)
			free_cells[i][j].clear();
	}
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			free_cells[i % (1 << cnt)][j % (1 << cnt)].insert({ i, j });
		}
	}
}

void remove_in_rect(int i, int j)
{
	for (int ii = i; ii <= n; ii++)
	{
		for (int jj = j; jj <= n; jj++)
		{
			free_cells[ii % (1 << cnt)][jj % (1 << cnt)].erase({ ii, jj });
		}
	}
}

int main()
{
	int num;
	cin >> num;
	int k, m;
	cin >> n >> k >> m;
	vector<bool> message;
	bool i_first = 1;
	pair<int, int> cell;
	if (num == 1)
	{
		char c;
		for (int i = 0; i < m; i++)
		{
			cin >> c;
			message.push_back(c == '1');
		}
		vector<int> blocks;
		for (int i = 0; i < m; i += cnt)
		{
			int mask = 0;
			for (int j = i; j < i + cnt; j++)
				mask = 2 * mask + message[j];
			blocks.push_back(mask);
		}
		if (blocks.size() % 2 == 1)
			blocks.push_back(0);
		int i = 0;
		fill_free_cells();
		while (i < blocks.size())
		{
			int sz = free_cells[blocks[i]][blocks[i + 1]].size();
			int s = get_s();
			auto it = free_cells[blocks[i]][blocks[i + 1]].begin();
			if (sz == 0 || (it->first == 1 && it->second == 1))
			{
				if (s >= 1)
					cout << "1 1" << endl;
				fill_free_cells();
				i_first = !i_first;
				if (!i_first)
				{
					cin >> cell.first >> cell.second;
					remove_in_rect(cell.first, cell.second);
				}
				continue;
			}
			cell = *it;
			free_cells[blocks[i]][blocks[i + 1]].erase(it);
			cout << cell.first << " " << cell.second << endl;
			remove_in_rect(cell.first, cell.second);
			cin >> cell.first >> cell.second;
			remove_in_rect(cell.first, cell.second);
			i += 2;
		}
		int s = get_s();
		if (s > 0)
			cout << "1 1" << endl;
		cout << "0" << endl;
	}
	else
	{
		int plays;
		cin >> plays;
		vector<int> blocks;
		int blocks_cnt = m / cnt;
		while (blocks.size() < blocks_cnt)
		{
			cin >> cell.first >> cell.second;
			if (cell.first == 1 && cell.second == 1)
			{
				i_first = !i_first;
				if (!i_first)
					cin >> cell.first >> cell.second;
				continue;
			}
			blocks.push_back(cell.first % (1 << cnt));
			blocks.push_back(cell.second % (1 << cnt));
			cin >> cell.first >> cell.second;
			if (cell.first == 1 && cell.second == 1)
			{
				i_first = !i_first;
				if (!i_first)
					cin >> cell.first >> cell.second;
			}
		}
		//while (cin >> cell.first >> cell.second);
		for (int i = 0; i < blocks.size(); i++)
		{
			for (int j = cnt - 1; j >= 0; j--)
				message.push_back((blocks[i] >> j) % 2);
		}
		for (bool bit : message)
			cout << bit;
		cout << endl;
	}
}
