#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 21;

int n;
vector<int> g[N];
int sz[N];
vector<int> have[N];
int take[N];

int r;

bool ok = 1;

pii dfs(int v) {
	dbg(v);
	if (!ok) return {-1, -1};
	if (g[v].empty()) {
		return {take[v], take[v]};
	} else {
		vector<pii> seg;
		for (auto u : g[v]) {
			seg.pb(dfs(u));
		}
		sort(all(seg));
		int ssz = seg.size();
		for (int i = 1; i < ssz; i++) {
			if (seg[i].first < seg[i - 1].second) {
				ok = 0;
			}
		}
		return {seg[0].first, seg[ssz - 1].second};
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int szw;
			cin >> szw;
			g[i].resize(szw);
			for (int j = 0; j < szw; j++) {
				cin >> g[i][j];
				g[i][j]--;
			}
		} else {
			cin >> sz[i];
			have[i].resize(sz[i]);
			for (int j = 0; j < sz[i]; j++) {
				cin >> have[i][j];
			}
			sort(all(have[i]));
		}
	}
	vector<pii> order;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < sz[i]; j++) {
			order.pb({have[i][j], i});
		}
	}
	sort(all(order));
	int osz = order.size();
	for (int mask = 0; mask < (1 << osz); mask++) {
		dbg(mask);
		for (int i = 0; i < n; i++) {
			take[i] = -1;
		}
		bool bad = 0;
		for (int i = 0; i < osz; i++) {
			if ((mask >> i) & 1) {
				if (take[order[i].second] != -1) bad = 1;
				take[order[i].second] = order[i].first;
			}
		}
		for (int i = 0; i < n; i++) {
			if (g[i].empty() && take[i] == -1) bad = 1;
		}
		if (bad) continue;
		ok = 1;
		dfs(0);
		if (ok) {
			cout << "Yes\n";
			return 0;
		}
	}
	cout << "No\n";
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
1 2 3 2 
2 4 30 90 91 92 

3 
1 2 2 3
2 1 1 
2 1 2 

5
1 2 2 3 
2 1 2 
1 2 4 5 
2 1 1 
2 1 3
*/