#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

struct Node
{
	ll sum;
	ll add;
	Node(ll s = 0) { sum = s; add = 0; }

};

struct SegmentTree
{
	vector<Node> tree;

	Node merge(Node n1, Node n2)
	{
		return Node(n1.sum + n2.sum);
	}

	void push(ll v)
	{
		tree[2 * v + 1].sum += tree[v].add;
		tree[2 * v + 2].sum += tree[v].add;
		tree[2 * v + 1].add += tree[v].add;
		tree[2 * v + 2].add += tree[v].add;
		tree[v].add = 0;
	}

	void init(ll v, ll l, ll r, vector<ll>& start)
	{
		if (l == r)
		{
			tree[v] = Node(start[l]);
			return;
		}
		push(v);
		ll m = (r + l) / 2;

		init(2 * v + 1, l, m, start);
		init(2 * v + 2, m + 1, r, start);

		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}

	Node query(ll v, ll l, ll r, ll id)
	{
		if (l == r && l == id)
		{
			return tree[v];
		}
		if (r < id || id < l)
			return Node(0);

		push(v);
		ll m = (r + l) / 2;

		return merge(query(2 * v + 1, l, m, id),
			query(2 * v + 2, m + 1, r, id));

	}

	void add(ll v, ll l, ll r, ll ql, ll qr, ll val)
	{
		if (ql <= l && r <= qr)
		{
			tree[v].sum += val;
			tree[v].add += val;
			return;
		}
		if (ql > r || l > qr)
			return;
		push(v);
		ll m = (r + l) / 2;

		add(2 * v + 1, l, m, ql, qr, val);
		add(2 * v + 2, m + 1, r, ql, qr, val);

		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}
};

const ll inf = 1e18;

signed main()
{
	ll k, n; cin >> k >> n;
	vector<vector<ll>> a(k, vector<ll>(k, 0));
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
		{
			char c; cin >> c;
			a[i][j] = c - '0';
		}
	string s; cin >> s;
//	s.push_back('a' - 1);
	
	if (k == 2)
	{
		vector<pair<char, ll>> c;
		for (int i = 0; i < n; ++i)
		{
			if (!c.empty() && s[i] == c.back().first)
			{
				c.back().second++;

			}
			else
			{
				c.push_back({ s[i],1 });
			}
		}
		vector<pair<char, ll>> c1;
		if (a[0][1])
		{
			for (int j = 0; j < c.size(); ++j)
			{
				if (j == 0 || c[j].first == 'a')
				{
					if (!c1.empty() && c[j].first == c1.back().first)
						c1.back().second += c[j].second;
					else
						c1.push_back(c[j]);
				}
			}
		}
		if (a[1][1])
		{
			for (int j = 0; j < c1.size(); ++j)
				if (c1[j].first == 'b')
					c1[j].second = 1;
		}
		if (a[1][0])
		{
			if (c1.back().first == 'a')
			{
				for (int j = 0; j < c1.size(); ++j)
					if (c1[j].first == 'b')
					{
						c1.pop_back();
						break;
					}
			}

		}
		if (a[0][0])
		{

			if (c1.back().first == 'a')
				c1.back().second = 1;
		}
		for (auto p : c1)
		{
			for (int i = 0; i < p.second; ++i)
				cout << p.first;
		}
	}



	return 0;
}