#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int get(vector<int> &cnt, int x, int y, int n) {
  int ans = 0;
  for (int i = x; i < n; ++i)
    ans += max(0, n - y - cnt[i]);
  return ans;
}

int main() {
#ifdef DEBUG
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  int n, k, m;
  cin >> n >> k >> m;
  k = 3;
  if (t == 1) {
    string s;
    cin >> s;
    int id = 0;
    int start_turn = 1;
    while (true) {
      if (id == m) {
        cout << 0 << endl;
        break;
      }
      vector<int> cnt(n);
      int turn = start_turn;
      while (true) {
        if (turn) {
          vector<pair<int, int>> possible_moves;
          for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n - cnt[i]; ++j) {
              if (get(cnt, i, j, n) <= k)
                possible_moves.emplace_back(i, j);
            }
          }
          int x = 0;
          while ((1 << (x + 1)) <= possible_moves.size())
            ++x;
          x = min(x, m - id);
          if (x == 0) {
            cout << 1 << ' ' << 1 << endl;
            break;
          }
          int val = 0;
          for (int i = 0; i < x; ++i)
            val = val * 2 + (s[id + i] - '0');
          id += x;
          cout << possible_moves[val].first + 1 << ' ' << possible_moves[val].second + 1 << endl;
          if (possible_moves[val].first == 0 && possible_moves[val].second == 0)
            break;
          for (int i = possible_moves[val].first; i < n; ++i)
            cnt[i] = max(cnt[i], n - possible_moves[val].second);
        } else {
          int x, y;
          cin >> x >> y;
          --x;
          --y;
          if (x == 0 && y == 0)
            break;
          for (int i = x; i < n; ++i)
            cnt[i] = max(cnt[i], n - y);
        }
        turn = 1 - turn;
      }
      start_turn = 1 - start_turn;
    }
  } else {
    int kek;
    cin >> kek;
    vector<int> ans(m);
    int id = 0;
    int start_turn = 1;
    while (kek--) {
      if (id == m)
        break;
      vector<int> cnt(n);
      int turn = start_turn;
      while (true) {
        if (turn) {
          vector<pair<int, int>> possible_moves;
          for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n - cnt[i]; ++j) {
              if (get(cnt, i, j, n) <= k)
                possible_moves.emplace_back(i, j);
            }
          }
          int x = 0;
          while ((1 << (x + 1)) <= possible_moves.size())
            ++x;
          x = min(x, m - id);
          if (x == 0) {
            int a, b;
            cin >> a >> b;
            break;
          }
          int a, b;
          cin >> a >> b;
          --a;
          --b;
          int val = 0;
          while (possible_moves[val] != make_pair(a, b))
            ++val;
          for (int i = x - 1; i >= 0; --i) {
            ans[id + i] = val % 2;
            val /= 2;
          }
          id += x;
          for (int i = a; i < n; ++i)
            cnt[i] = max(cnt[i], n - b);
          if (a == 0 && b == 0)
            break;
        } else {
          int x, y;
          cin >> x >> y;
          --x;
          --y;
          if (x == 0 && y == 0)
            break;
          for (int i = x; i < n; ++i)
            cnt[i] = max(cnt[i], n - y);
        }
        turn = 1 - turn;
      }
      start_turn = 1 - start_turn;
    }
    for (int i = 0; i < m; ++i)
      cout << ans[i];
    cout << endl;
  }
  return 0;
}
