#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long

string ans;

int get_hash(string s) {
	int hash = 0;
	for (int i = 0; i < s.size(); ++i) {
		hash = (31 * hash + (s[i] - 'a')) % (1000000007);
	}
	return hash;
}

set <int> used;

void gen(string s, vector <vector <int>>& able) {
	if (clock() >= 0.9 * CLOCKS_PER_SEC) {
		cout << ans << "\n";
		exit(0);
	}
	int hash = get_hash(s);
	if (used.find(hash) != used.end()) {
		return;
	}
	used.insert(hash);
	if (s < ans) {
		ans = s;
	}
	for (int i = 1; i < s.size(); ++i) {
		if (able[s[i - 1] - 'a'][s[i] - 'a']) {
			string s2;
			for (int j = 0; j < s.size(); ++j) {
				if (j != i) {
					s2.push_back(s[j]);
				}
			}
			gen(s2, able);
		}
	}
}

void solve() {
	int k, n;
	cin >> k >> n;
	vector <vector <int>> able(k, vector <int>(k));
	for (int i = 0; i < k; ++i) {
		string tmp;
		cin >> tmp;
		for (int j = 0; j < k; ++j) {
			able[i][j] = (tmp[j] - '0');
		}
	}
	string s;
	cin >> s;
	ans = s;
	gen(s, able);
	cout << ans << "\n";
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	while (test--) {
		solve();
	}
}