#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
#include<random>
using namespace std;

mt19937 gen(0);

const int INF = 1e9;
int n, k;
vector<vector<int>> A;
vector<int> s;
void generate() {
	A.clear();
	s.clear();
	n = gen() % 10 + 1;
	k = gen() % 4 + 1;
	A.assign(k, vector<int>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			A[i][j] = gen() % 2;
		}
	}
	s.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		s[i] = gen() % k;
	}
}

string smart() {
	vector<int> max_pref(n, 0);
	vector<string> ans(n + 1, "");
	vector<string> max_sub_ans(n + 1, "");
	ans[n - 1] = (char)(s[n - 1] + 'a');
	max_sub_ans[n - 1] = ans[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		int cur_pos = i + 1;
		int cur_val = 0;
		int good = 0;
		while (cur_pos <= n - 1 && A[s[i]][s[cur_pos]] == 1) {
			if (!good) {
				max_sub_ans[i] = max_sub_ans[cur_pos];
				good = 1;
			}
			else
				max_sub_ans[i] = min(max_sub_ans[i], max_sub_ans[cur_pos]);
			cur_val += max_pref[cur_pos] + 1;
			cur_pos += max_pref[cur_pos] + 1;
		}
		max_pref[i] = cur_val;
		string cur_ans;
		if (good)
			cur_ans = max_sub_ans[i];
		else
			cur_ans = ans[i + 1];
		if (i + 1 + cur_val <= n) {
			cur_ans = min(cur_ans, ans[i + 1 + cur_val]);
		}
		ans[i] = (char)(s[i] + 'a');
		ans[i] += cur_ans;
		if (good)
			max_sub_ans[i] = min(max_sub_ans[i], ans[i]);
		else
			max_sub_ans[i] = ans[i];
	}
	return ans[0];
}

string stupid(int debug = 0) {
	vector<int> max_pref(n, 0);
	for (int i = n - 2; i >= 0; --i) {
		int cur_pos = i + 1;
		int cur_val = 0;
		while (cur_pos <= n - 1 && A[s[i]][s[cur_pos]] == 1) {
			cur_val += max_pref[cur_pos] + 1;
			cur_pos += max_pref[cur_pos] + 1;
		}
		max_pref[i] = cur_val;
	}
	int cur_pos = 0;
	string ans = "";
	while (cur_pos <= n - 1) {
		ans += (char)('a' + s[cur_pos]);
		int min_pos = -1;
		int min_char = 27;
		if (cur_pos + max_pref[cur_pos] == n - 1) {
			cur_pos = n;
		}
		else {
			for (int i = 1; i <= max_pref[cur_pos]; ++i) {
				if (min_char > s[i + cur_pos]) {
					min_char = s[i + cur_pos];
					min_pos = i + cur_pos;
				}
			}
			if (min_char > s[cur_pos + max_pref[cur_pos] + 1]) {
				min_pos = max_pref[cur_pos] + cur_pos + 1;
			}
			cur_pos = min_pos;
		}
	}
	return ans;
}

void get_input() {
	cin >> k >> n;
	A.assign(k, vector<int>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			A[i][j] = c - '0';
		}
	}
	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		s.push_back(c - 'a');
	}
}
int main() {
	get_input();
	string new_s = stupid();
	s.clear();
	for (int i = 0; i < new_s.size(); ++i) {
		s.push_back(new_s[i] - 'a');
	}
	n = new_s.size();
	cout << smart();
}

//3 7
//010
//001
//100
//abacaba

//3 5
//010
//001
//100
//bcacb 