#include <bits/stdc++.h>

#define next my_next

using namespace std;

const int MAXN = 4000, MAXK = 8;

int next[MAXN][MAXN];
int ans[MAXN][MAXN][MAXK], cnt[MAXN], N;

inline int relax(int i, int j) {
    if (i == -1) {
        return j;
    }
    if (j == -1) {
        return i;
    }
    return min(i, j);
}

vector<int> m[MAXN];

vector<int> g[MAXN];

void dfs(int v = 0) {
    if (g[v].empty()) {
        cnt[v] = 1;
        for (auto &i : m[v]) {
            next[v][i] = i + 1;
        }
        for (int i = N - 1; i > 0; i--) {
            next[v][i] = relax(next[v][i - 1], next[v][i]);
        }
        return;
    }
    sort(g[v].begin(), g[v].end());
    for (auto &u : g[v]) {
        dfs(u);
        cnt[v] += cnt[u];
    }
    for (int i = 0; i < N; i++) {
        sort(g[v].begin(), g[v].end());
        do {
            int cur = i;
            bool possible = true;
            for (auto &u : g[v]) {
                if (next[u][cur] == -1) {
                    possible = false;
                    break;
                }
                cur = next[u][cur];
            }
            if (possible) {
                if (next[v][i] == -1 || cur < next[v][i]) {
                    next[v][i] = cur;
                    for (int j = 0; j < g[v].size(); j++) {
                        ans[v][i][j] = g[v][j];
                    }
                }
            }
        } while (next_permutation(g[v].begin(), g[v].end()));
    }
    for (int i = N - 1; i > 0; i--) {
        next[v][i] = relax(next[v][i - 1], next[v][i]);
    }
}

int start[MAXN];

void mark(int v = 0, int cur = 0) {
    start[v] = cur;
    for (int i = 0; i < g[v].size(); i++) {
        mark(ans[v][start[v]][i], cur);
        cur += cnt[ans[v][start[v]][i]];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    memset(ans, 255, sizeof(ans));
    memset(next, 255, sizeof(next));
    int n;
    cin >> n;
    vector<int> val;
    for (int v = 0; v < n; v++) {
        int type;
        cin >> type;
        if (type == 1) {
            int m;
            cin >> m;
            g[v].resize(m);
            for (auto &u : g[v]) {
                cin >> u;
                u--;
            }
        } else {
            int sz;
            cin >> sz;
            m[v].resize(sz);
            for (auto &u : m[v]) {
                cin >> u;
                val.emplace_back(u);
            }
        }
    }
    sort(val.begin(), val.end());
    N = val.size();
    val.erase(unique(val.begin(), val.end()), val.end());
    assert(N == val.size());
    N = val.size() + 2;
    for (int v = 0; v < n; v++) {
        for (auto &x : m[v]) {
            x = lower_bound(val.begin(), val.end(), x) - val.begin();
        }
    }
    dfs();
    if (next[0][0] != -1) {
        cout << "Yes\n";
//        mark();
//        for (int v = 0; v < n; v++) {
//            if (g[v].empty()) {
//                cout << val[start[v]] << '\n';
//            } else {
//                for (int i = 0; i < g[v].size(); i++) {
//                    cout << ans[v][start[v]][i] + 1 << ' ';
//                }
//                cout << '\n';
//            }
//        }
    } else {
        cout << "No\n";
    }
    return 0;
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
 */