#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <random>
#include <queue>

using namespace std;

const int N = 5001;

int used[N];
int x[N];
int h[N];

void solve(int l, int r) {
	set<int> S;
	for (int i = l - 1; i <= r + 1; i++) {
		S.insert(i);
	}
	auto can_l = [&](int i) {
		auto it = S.lower_bound(i);
		return x[*prev(it)] <= x[i] - h[i];		
	};
	auto can_r = [&](int i) {
		auto it = S.lower_bound(i);
		return x[i] + h[i] <= x[*next(it)];
	};
	queue<int> q;
	for (int i = l; i <= r; i++) {
		used[i] = 0;
		if (can_l(i) || can_r(i)) {
			q.push(i);
			used[i] = 1;
		}
	}
	int ans = 0;
	while (!q.empty()) {
		int i = q.front();
		q.pop();
		ans++;
		auto it = S.lower_bound(i);
		int pr = *prev(it);
		int nx = *next(it);
		S.erase(it);
		if (pr != l - 1 && can_r(pr) && !used[pr]) {
			used[pr] = 1;
			q.push(pr);
		}
		if (nx != r + 1 && can_l(nx) && !used[nx]) {
			used[nx] = 1;
			q.push(nx);
		}
	}
	cout << ans << '\n';
}

signed main() {

	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	n += 2;
	while (q--) {
		int l, r;
		cin >> l >> r;
		solve(l, r);
	}
}