#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;
int inf = 1e9 + 462;

struct vertex {
	int v, mn, mx;
	bool operator<(vertex b) const {
		return (mn + mx) < (b.mn + b.mx);
	}
	bool operator>(vertex b) const {
		return (mn + mx) > (b.mn + b.mx);
	}
};
struct edge {
	int u, c, i;
};

vector<vector<edge>>g;

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, m; cin >> n >> m;
	g.resize(n);
	vector<bool>used(m);
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[v].push_back({ u, c, i });
		g[u].push_back({ v, c, i });
	}
	vector<int>ans(n, inf);
	ans[0] = inf;
	set<pair<int,int>>s;
	s.insert({ ans[0], 0 });
	while (!s.empty()) {
		int v = (*s.begin()).second;
		s.erase(s.begin());
		for (auto& u : g[v]) {
			if (!used[u.i] && ans[u.u] > min(u.c, ans[v])) {
				s.erase({ ans[u.u], u.u });
				ans[u.u] = min(u.c, ans[v]);
				s.insert({ ans[u.u], u.u });
				used[u.i] = true;
			}
		}
	}
	for (int i = 1; i < n; i++)
		cout << ans[i]+int(1e9) << '\n';
	return 0;
}