#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
//#define int ll

vector<ll> cost(27);

const ll INF = 2e18;

void solve() {
	string s;
	cin >> s;
	int n = s.size();
	vector<vector<ll>> dp(n, vector<ll>(26, -INF));
	vector<vector<pair<int, int>>> pr(n, vector<pair<int, int>>(26));
	if (s[n - 1] == '?') {
		for (int j = 0; j < 26; ++j) {
			dp[n - 1][j] = cost[j];
			pr[n - 1][j] = { 0, j };
		}
	}
	else {
		dp[n - 1][s[n - 1] - 'A'] = cost[s[n - 1] - 'A'];
		pr[n - 1][s[n - 1] - 'A'] = { 0, s[n - 1] - 'A' };
	}
	for (int i = n - 2; i >= 0; --i) {
		if (s[i] == '?') {
			for (int j1 = 0; j1 < 26; ++j1) {
				for (int j2 = 0; j2 < 26; ++j2) {
					if (j1 < j2) {
						if (dp[i][j2] < dp[i + 1][j2] - cost[j1]) {
							dp[i][j2] = dp[i + 1][j2] - cost[j1];
							pr[i][j2] = { j2, j1 };
						}
					}
					else {
						if (dp[i][j1] < dp[i + 1][j2] + cost[j1]) {
							dp[i][j1] = dp[i + 1][j2] + cost[j1];
							pr[i][j1] = { j2, j1 };
						}
					}
				}
			}
			continue;
		}
		for (int j = 0; j <= s[i] - 'A'; ++j) {
			if (dp[i][s[i] - 'A'] < dp[i + 1][j] + cost[s[i] - 'A']) {
				dp[i][s[i] - 'A'] = dp[i + 1][j] + cost[s[i] - 'A'];
				pr[i][s[i] - 'A'] = { j, s[i] - 'A' };
			}
		}
		for (int j = s[i] - 'A' + 1; j < 26; ++j) {
			if (dp[i][j] < dp[i + 1][j] - cost[s[i] - 'A']) {
				dp[i][j] = dp[i + 1][j] - cost[s[i] - 'A'];
				pr[i][j] = { j, s[i] - 'A' };
			}
		}
	}
	ll ma = -INF;
	pair<int, int> in = { -1, -1 };
	for (int i = 0; i < 26; ++i) {
		if (dp[0][i] > ma) {
			ma = dp[0][i];
			in = pr[0][i];
		}
	}
	cout << ma << '\n';
	s.clear();
	int k = 1;
	while (k != n + 1) {
		s += char(in.second + 'A');
		if (k == n)
			break;
		in = pr[k][in.first];
		++k;
	}
	cout << s;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif 
	cost[0] = 1;
	for (int i = 1; i < 26; i += 2) {
		cost[i] = cost[i - 1] * 5;
		cost[i + 1] = cost[i] * 2;
	}
	cost.pop_back();
	int t;
	cin >> t;
	while (t-- > 0) {
		solve();
		cout << '\n';
	}
	return 0;
}