#include <iostream>
#include <vector>
#include <array>

template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

using namespace std;
using ll = long long;

const int A = 26;
const ll LINF = 1e18;

array<ll, A> cost;

void solve() {
    string s; cin >> s;
    int n = s.size();
    vector dp(A, vector<ll>(n+1, -LINF));
    vector pt(A, vector<int>(n+1, -1));
    vector ch(A, vector<char>(n+1, '.'));
    dp[0][n] = 0;
    for (int i = n; i--;) {
        if (s[i] == '?') {
            ll t = -LINF;
            int nxt = -1;
            for (int k = 0; k < 26; ++k) {
                if (ckmax(t, dp[k][i+1])) nxt = k;
                if (ckmax(dp[k][i], cost[k] + t)) {
                    pt[k][i] = nxt;
                    ch[k][i] = 'A' + k;
                }
            }
        } else {
            int u = s[i] - 'A';
            for (int k = 26; k--; ) {
                if (k <= u) {
                    if (ckmax(dp[u][i], dp[k][i+1] + cost[u])) {
                        pt[u][i] = k;
                        ch[u][i] = u + 'A';
                    }
                } else {
                    if (ckmax(dp[k][i], dp[k][i+1] - cost[u])) {
                        pt[k][i] = k;
                        ch[k][i] = u + 'A';
                    }
                }
            }
        }
    }

    int u = 0;
    for (int k = 0; k < 26; ++k) {
        if (dp[k][0] > dp[u][0]) {
            u = k;
        }
    }
    ll mx = dp[u][0];
    string ans(n, '.');
    for (int i = 0; i < n; ++i) {
        ans[i] = ch[u][i];
        u = pt[u][i];
    }
    cout << mx << '\n' << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    ll x = 1;
    for (int i = 0; i < 26; i += 2) {
        cost[i] = x;
        cost[i+1] = 5*x;
        x *= 10;
    }
    int t; cin >> t;
    while (t--) solve();
}