#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
using pi = pair<int, int>;

const int N = 3e5+7;

vector<int> g[N], pin[N], pout[N],  tin[N], tout[N];
int used[N];
vector<pair<pi, pi>> ans;
bool okay = true;

void solve(int v, int p = -1) {
    used[v] = true;
    for (int to : g[v]) {
        if (to == p) continue;
        solve(to, v);
    }

    for (int to : pout[v]) {
        if (to != p) continue;
        if (tout[v].size() < tin[v].size()) {
            tout[v].push_back(to);
        } else {
            tin[to].push_back(v);
        }
    }

    for (int to : pin[v]) {
        if (to != p) continue;
        if (tin[v].size() < tout[v].size()) {
            tin[v].push_back(to);
        } else {
            tout[to].push_back(v);
        }
    }

    if (tin[v].size() != tout[v].size()) {
        okay = false;
    } else {
        for (int i = 0; i < tin[v].size(); ++i) {
            int a = tin[v][i], b = tout[v][i];
            ans.emplace_back(pi{a, v}, pi{v, b});
        }
    }
}

int main() {
    int n, m; cin >> n >> m;
    vector<pair<int, int>> edges(m);
    for (auto& [a, b] : edges) {
        cin >> a >> b; a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
        pin[b].push_back(a);
        pout[a].push_back(b);
    }

    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
        g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) solve(i);
    }

    if (ans.size()*2 == m && okay) {
        cout << "Yes" << endl;
        for (auto [x, y] : ans) {
            cout << x.first+1 << ' ' << x.second+1 << ' '
                << y.first+1 << ' ' << y.second+1 << endl;
        }
    } else {
        cout << "No" << endl;
    }
}