#include <iostream>
#include <algorithm>
#include <numeric>
#include <queue>

using namespace std;

const int N = 5e5+7;

int n, q, x[N], h[N], used[N], inq[N], pl[N], pr[N];

int getNear(int v, int* ptr) {
    return used[v] ? ptr[v] = getNear(ptr[v], ptr) : v;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) cin >> x[i] >> h[i];
    x[0] = x[1];
    x[n+1] = x[n];
    while (q--) {
        int l, r; cin >> l >> r;
        fill(used, used+n+2, 0);
        fill(inq, inq+n+2, 0);
        iota(pl, pl+n+2, -1);
        iota(pr, pr+n+2, 1);
        queue<int> Q;
        for (int i = l; i <= r; ++i) {
            if (max(x[i+1]-x[i], x[i]-x[i-1]) >= h[i]) {
                Q.push(i);
                inq[i] = true;
            }
        }

        int cnt = 0;
        while (!Q.empty()) {
            int v = Q.front(), u = -1; Q.pop();
            used[v] = true; cnt++;
            u = getNear(v, pl);
            if (l <= u && u <= r && !inq[u]) {
                int p = getNear(u-1, pl), q = getNear(u+1, pr);
                if (max(x[u]-x[p], x[q]-x[u]) >= h[u]) {
                    inq[u] = true;
                    Q.push(u);
                }
            }

            u = getNear(v, pr);
            if (l <= u && u <= r && !inq[u]) {
                int p = getNear(u-1, pl), q = getNear(u+1, pr);
                if (max(x[u]-x[p], x[q]-x[u]) >= h[u]) {
                    inq[u] = true;
                    Q.push(u);
                }
            }
        }

        cout << cnt << '\n';
    }
}