#include <iostream>
#include <vector>
#include <tuple>
#include <set>

using namespace std;

#pragma GCC optimize("Ofast")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> graph(n);
    vector<vector<int>> tgraph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        tgraph[v].push_back(u);
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;

    while (ans.size() != m / 2) {
        bool good = false;
        for (int u = 0; u < n; u++) {
            if (tgraph[u].empty() && graph[u].size() == 1) {
                int v = graph[u][0];
                if (graph[v].size() == 1) {
                    int w = graph[v][0];
                    ans.push_back({{u, v}, {v, w}});
                    graph[u].pop_back();
                    graph[v].pop_back();
                    for (int i = 0; i < tgraph[v].size(); i++) {
                        if (tgraph[v][i] == u) {
                            swap(tgraph[v][i], tgraph[v].back());
                            tgraph[v].pop_back();
                            break;
                        }
                    }
                    for (int i = 0; i < tgraph[w].size(); i++) {
                        if (tgraph[w][i] == v) {
                            swap(tgraph[w][i], tgraph[w].back());
                            tgraph[w].pop_back();
                            break;
                        }
                    }
                    good = true;
                }
            }
        }
        if (!good) {
            for (int w = 0; w < n; w++) {
                if (graph[w].empty() && tgraph[w].size() == 1) {
                    int v = tgraph[w][0];
                    if (tgraph[v].size() == 1) {
                        int u = tgraph[v][0];
                        ans.push_back({{u, v}, {v, w}});
                        tgraph[u].pop_back();
                        tgraph[v].pop_back();
                        for (int i = 0; i < graph[u].size(); i++) {
                            if (graph[u][i] == v) {
                                swap(graph[u][i], graph[u].back());
                                graph[u].pop_back();
                                break;
                            }
                        }
                        for (int i = 0; i < graph[v].size(); i++) {
                            if (graph[v][i] == w) {
                                swap(graph[v][i], graph[v].back());
                                graph[v].pop_back();
                                break;
                            }
                        }
                        good = true;
                    }
                }
            }
            if (!good) {
                for (int u = 0; u < n; u++) {
                    for (int i = 0; i < graph[u].size(); i++) {
                        int v = graph[u][i];
                        if (!graph[v].empty()) {
                            int w = graph[v].back();
                            ans.push_back({{u, v}, {v, w}});
                            graph[v].pop_back();
                            swap(graph[u][i], graph[u].back());
                            graph[u].pop_back();
                            for (int i = 0; i < tgraph[v].size(); i++) {
                                if (tgraph[v][i] == u) {
                                    swap(tgraph[v][i], tgraph[v].back());
                                    tgraph[v].pop_back();
                                    break;
                                }
                            }
                            for (int i = 0; i < tgraph[w].size(); i++) {
                                if (tgraph[w][i] == v) {
                                    swap(tgraph[w][i], tgraph[w].back());
                                    tgraph[w].pop_back();
                                    break;
                                }
                            }
                            good = true;
                            break;
                        }
                    }
                    if (good) {
                        break;
                    }
                }
                if (!good) {
                    cout << "No";
                    return 0;
                }
            }
        }
    }

    if (ans.size() != m / 2) {
        cout << "No";
    }
    else {
        cout << "Yes\n";
        for (auto& i : ans) {
            cout << i.first.first+1 << " " << i.first.second+1 << " " << i.second.first+1 << " " << i.second.second+1 << "\n";
        }
    }
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
    return 0;
}

