#include <iostream>
#include <vector>
#include <set>
#include <tuple>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for (auto& i : a) {
        cin >> i.first >> i.second;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int ll = a[0].first;
        if (l) {
            ll = a[l - 1].first;
        }
        int rr = a.back().first;
        if (r + 1 < n) {
            rr = a[r + 1].first;
        }
        if (l == r) {
            if (a[l].first + a[l].second <= rr || a[l].first - a[l].second >= ll) {
                cout << "1\n";
            }
            else {
                cout << "0\n";
            }
            continue;
        }

        set<pair<int, int>> can;
        for (int i = l; i <= r; i++) {
            can.insert({a[i].first, i});
        }

        vector<int> dist(r - l + 1);
        set<pair<int, int>> s;
        dist[0] = max(a[l].first - ll, a[l + 1].first - a[l].first);
        dist[r - l] = max(a[r].first - a[r - 1].first, rr - a[r].first);
        s.insert({a[l].second - dist[0], l});
        s.insert({a[r].second - dist[r - l], r});
     //   cout << "dist[0] == " << dist[0] << "\n";
        for (int i = l + 1; i <= r - 1; i++) {
            dist[i - l] = max(a[i].first - a[i - 1].first, a[i + 1].first - a[i].first);
            s.insert({a[i].second - dist[i - l], i});
        }
        while (!s.empty()) {
            int d, i;
            tie(d, i) = *s.begin();
            if (d > 0) {
                break;
            }
            s.erase(s.begin());
            if (s.empty()) {
                break;
            }
            auto it = can.find({a[i].first, i});

            int i_l, x_l, h_l, i_r, x_r, h_r;
            i_l = x_l = h_l = i_r = x_r = h_r = -1;

            auto it_r = it;
            it_r++;
            if (it_r != can.end()) {
                tie(x_r, i_r) = *it_r;
                h_r = a[i_r].second;
            }
            auto it_l = it;
            if (it != can.begin()) {
                it_l--;
                tie(x_l, i_l) = *it_l;
                h_l = a[i_l].second;
            }

            if (i_l != -1) {
                int dist_l = x_l - ll;
                if (it_l != can.begin()) {
                    it_l--;
                    dist_l = x_l - it_l->first;
                }
                int dist_r = rr - x_l;
                if (i_r != -1) {
                    dist_r = x_r - x_l;
                }
                s.erase({h_l - dist[i_l - l], i_l});
                dist[i_l - l] = max(dist_l, dist_r);
                s.insert({h_l - dist[i_l - l], i_l});
            }
            if (i_r != -1) {
               // cout << "tuta " << i_r << " " << x_r << " " << h_r << "\n";
                int dist_r = rr - x_r;
                it_r++;
                if (it_r != can.end()) {
                    dist_r = it_r->first - x_r;
                }
                int dist_l = x_r - ll;
                if (i_l != -1) {
                    dist_l = x_r - x_l;
                }
                s.erase({h_r - dist[i_r - l], i_r});
                dist[i_r - l] = max(dist_l, dist_r);
                s.insert({h_r - dist[i_r - l], i_r});
            }
            can.erase(it);
        }
        cout << r - l + 1 - s.size() << '\n';
    }
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/
    return 0;
}
