#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void dfs(int v, int p, int d, vector<vector<int> > &g, vector<int> &vis, vector<pair<int, int> > &order, vector<int> &depth)
{
    depth[v] = d;
    order.push_back({d, v});
    vis[v] = 1;
    for (auto u : g[v]) if (u != p)
    {
        dfs(u, v, d + 1, g, vis, order, depth);
    }
}

const int N = 160000;
map<int, int> pos_dir[N], pos_rev[N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;

    set<pair<int, int> > s;

    vector<vector<int> > dir(n), rev(n);

    for (int i = 0; i < m; i++)
    {
        int f, t;
        cin >> f >> t;
        f--, t--;
        pos_dir[f][t] = dir[f].size();
        dir[f].push_back(t);
        pos_rev[t][f] = rev[t].size();
        rev[t].push_back(f);
        s.insert({f, t});
        s.insert({t, f});
    }

    vector<vector<int> > g(n);
    for (auto e : s)
    {
        g[e.first].push_back(e.second);
    }

    vector<int> vis(n);
    vector<int> depth(n);

    vector<pair<int, int> > ans;

    auto remove_edge = [&](int f, int t){
        int pos = pos_dir[f][t];
        assert(dir[f][pos] == t);
        int lst = dir[f].back();
        pos_dir[f][lst] = pos;
        swap(dir[f][pos], dir[f][dir[f].size() - 1]);
        dir[f].pop_back();
        pos_dir[f].erase(t);

        pos = pos_rev[t][f];
        assert(rev[t][pos] == f);
        lst = rev[t].back();
        pos_rev[t][lst] = pos;
        swap(rev[t][pos], rev[t][rev[t].size() - 1]);
        rev[t].pop_back();
        pos_rev[t].erase(f);
    };

    for (int i = 0; i < n; i++)
    {
        if (vis[i] == 0)
        {
            vector<pair<int, int> > order;
            dfs(i, -1, 0, g, vis, order, depth);
            sort(order.begin(), order.end());
            reverse(order.begin(), order.end());
            for (int j = 0; j < order.size(); j++)
            {
                int v = order[j].second;
                //cout << "Search from " << v << endl;
                int in_id = -1, out_id = -1;
                for (auto u : dir[v])
                {
                    assert(out_id == -1), out_id = u;
                }
                for (auto u : rev[v])
                {
                    assert(in_id == -1), in_id = u;
                }
                //cout << in_id << " " << out_id << endl;
                if (in_id != -1 && out_id != -1)
                {
                    assert(in_id == out_id);
                    ans.push_back({in_id, v});
                    ans.push_back({v, out_id});
                    remove_edge(in_id, v);
                    remove_edge(v, out_id);
                    continue;
                }
                if (in_id == -1 && out_id == -1)
                {
                    continue;
                }
                if (in_id == -1)
                {
                    int par = out_id;
                    int to = -1;

                    // Note:
                    // in this and next place it can be optimized

                    // probably, it can be optimized more
                    // we don't make more than 2 operations here
                    for (auto e : dir[par])
                    {
                        if (depth[e] != depth[par] - 1)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({v, par});
                        ans.push_back({par, to});
                        remove_edge(v, par);
                        remove_edge(par, to);
                        continue;
                    }
                    // we visited all the edges previously so it does not affect complexity
                    for (auto e : dir[par])
                    {
                        to = e;
                    }
                    if (to != -1)
                    {
                        ans.push_back({v, par});
                        ans.push_back({par, to});
                        remove_edge(v, par);
                        remove_edge(par, to);
                        continue;
                    }
                    cout << "No\n";
                    return 0;
                }
                if (out_id == -1)
                {
                    int par = in_id;
                    int to = -1;
                    for (auto e : rev[par])
                    {
                        if (depth[e] != depth[par] - 1)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({to, par});
                        ans.push_back({par, v});
                        remove_edge(to, par);
                        remove_edge(par, v);
                        continue;
                    }
                    for (auto e : rev[par])
                    {
                        to = e;
                    }
                    if (to != -1)
                    {
                        ans.push_back({to, par});
                        ans.push_back({par, v});
                        remove_edge(to, par);
                        remove_edge(par, v);
                        continue;
                    }
                    cout << "No\n";
                    return 0;
                }
            }
        }
    }

    cout << "Yes\n";
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << " \n"[i % 2];
    }
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/







