#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 300000;
const int INF = (int)1e9;

int t[MAXN], ans[MAXN];
vector<pair<int, int>> g[MAXN];

void dfs(int u, int prev, int maxT, int minT)
{
	ans[u] = maxT + minT;
	for (auto [v, e] : g[u])
		if (v != prev)
			dfs(v, u, max(maxT, t[e]), min(minT, t[e]));
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	int u = 0, v = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> u >> v >> t[i];
		--u, --v;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
	}

	dfs(0, -1, 0, INF);

	for (int i = 1; i < n; ++i)
		cout << ans[i] << "\n";

	return 0;
}