#include <algorithm>
#include <set>
#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 300000;
const int INF = (int)1e9;

int t[MAXN], ans[MAXN];
vector<pair<int, int>> g[MAXN];

void dj(int n)
{
	set<pair<int, int>> s;
	s.emplace(0, 0);
	vector<int> d(n, INF);
	d[0] = 0;

	while (!s.empty())
	{
		auto [curD, u] = *s.begin();
		ans[u] = curD;
		s.erase(s.begin());

		for (auto [v, i] : g[u])
		{
			if (max(curD, t[i]) < d[v])
			{
				s.erase({ d[v], v });
				d[v] = max(curD, t[i]);
				s.emplace(d[v], v);
			}
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	int u = 0, v = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> u >> v >> t[i];
		--u, --v;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
	}

	dj(n);

	for (int i = 1; i < n; ++i)
		cout << ans[i] << "\n";

	return 0;
}