#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <ctime>
#include <stack>


using namespace std;


#define int long long
#define ll long long
#define all(a) a.begin(), a.end()


struct rb {
	int i;
	int v;
	int to;


	rb(int v, int to, int i) : v(v), to(to), i(i) {}
	rb() : i(-1), v(-1), to(-1) {}



	rb reversed(){
		return rb(to, v, i);
	}
};


int n, m;


vector<vector<rb>> t;
vector<vector<rb>> g;
vector<vector<rb>> rg;
vector<rb> rbrs;
vector<bool> rusd;
vector<bool> usd;
vector<pair<int, int>> res;
bool ok;


void connect(int i, int j) {
	res.emplace_back(i, j);
	rusd[i] = true;
	rusd[j] = true;
}


void dfs(int v, int p) {
	usd[v] = true;
	if (!ok) {
		return;
	}
	for (auto r : t[v]) {
		int to = r.to;
		if (!usd[to]) {
			dfs(to, v);
			if (!ok) {
				return;
			}
		}
	}
	stack<int> x;
	stack<int> y;
	rb to_p(-1, -1, -1);
	rb fr_p(-1, -1, -1);
	for (auto r : g[v]) {
		if (r.to == p) {
			to_p = r;
		}
		else if (!rusd[r.i]) {
			x.push(r.i);
		}
	}
	for (auto r : rg[v]) {
		if (r.to == p) {
			fr_p = r;
		}
		else if (!rusd[r.i]) {
			if (!x.empty()) {
				connect(r.i, x.top());
				x.pop();
			}
			else {
				y.push(r.i);
			}
		}
	}
	if(x.size() > 1 || y.size() > 1) {
		ok = false;
		return;
	}
	if (x.size() > 0) {
		if (fr_p.i == -1) {
			ok = false;
			return;
		}
		connect(fr_p.i, x.top());
		x.pop();
	}
	if (y.size() > 0) {
		if (to_p.i == -1) {
			ok = false;
			return;
		}
		connect(to_p.i, y.top());
		y.pop();
	}
}


void get_res() {
	ok = true;
	usd.resize(n, false);
	rusd.resize(m, false);
	for (int i = 0; i < n; ++i) {
		if (!usd[i]) {
			dfs(i, -1);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (!rusd[i]) {
			ok = false;
			return;
		}
	}
}


void print_res() {
	for (auto p : res) {
		int x = p.first;
		int y = p.second;
		cout << rbrs[x].v + 1 << " " << rbrs[x].to + 1 << " " << rbrs[y].v + 1 << " " << rbrs[y].to + 1 << "\n";
	}
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	rbrs.resize(m);
	t.resize(n);
	g.resize(n);
	rg.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		rb r(u, v, i);
		rbrs[i] = r;
		g[u].push_back(r);
		rg[v].push_back(r.reversed());
		t[u].push_back(r);
		t[v].push_back(r.reversed());
	}
	get_res();
	if (ok) {
		cout << "Yes" << "\n";
		print_res();
	}
	else {
		cout << "No" << "\n";
	}
	return 0;
}


/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/

/*
4 4
2 1
2 3
2 4
4 2
*/

/*
4 4
1 2
2 1
3 4
4 3
*/