#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 3e5 + 15;

vpi adj[MAXN];
int ans[MAXN];
int rang[MAXN], p[MAXN];

int GetPar(int v) {
    if (p[v] == -1) {
        return v;
    }
    return p[v] = GetPar(p[v]);
}

void Merge(int a, int b, int c) {
    a = GetPar(a);
    b = GetPar(b);
    if (a != b) {
        if (rang[a] > rang[b]) {
            swap(a, b);
        }
        rang[b] += rang[a];
        p[a] = b;
    }
}

void DFS(int v, int mn, int mx, int par = -1) {
    ans[v] = mn + mx;
    for (auto [to, cost] : adj[v]) {
        if (to != par) {
            DFS(to, min(mn, cost), max(mx, cost), v);
        }
    }
}

void Solve() {
    memset(p, -1, sizeof(p));
    forn(i, MAXN) {
        rang[i] = 1;
    }
    int n, m;
    cin >> n >> m;
    vector <tuple<int,int,int>> edges;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        edges.eb(c, a, b);
    }
    sort(all(edges));
    for (auto [c, a, b] : edges) {
        if (GetPar(a) != GetPar(b)) {
            adj[a].eb(b, c);
            adj[b].eb(a, c);
        }
        Merge(a, b, c);
    }
    DFS(1, INF, nINF);
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}