#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 3e5 + 15;

int ans[MAXN];
int rang[MAXN], p[MAXN];
vector <tuple<int,int,int>> edges;

int GetPar(int v) {
    if (p[v] == -1) {
        return v;
    }
    return GetPar(p[v]);
}

void Calc(int l, int r, vi who) {
    if (l > r) {return;}
    if (who.empty()) {return;}
    int m = l + (r - l) / 2;
    vector <tuple <int, int, int>> changes;
    int nowCost = 0;
    for (int i = l; i <= m; ++i) {
        auto[c, a, b] = edges[i];
        nowCost = c;
        a = GetPar(a);
        b = GetPar(b);
        if (a == b) {continue;}
        if (rang[a] > rang[b]) {
            swap(a, b);
        }
        changes.eb(a, p[a], rang[a]);
        changes.eb(b, p[b], rang[b]);
        p[a] = b;
        rang[b] += rang[a];
    }
    int one = GetPar(one);
    vi left, right;
    for (auto u : who) {
        if (GetPar(u) == one) {
            ans[u] = min(ans[u], nowCost);
            left.eb(u);
        } else {
            right.eb(u);
        }
    }
    Calc(m + 1, r, right);
    reverse(all(changes));
    for (auto [a, b, c] : changes) {
        p[a] = b;
        rang[a] = c;
    }
    Calc(l, m, left);
}

void Solve() {
    memset(ans, 127, sizeof(ans));
    memset(p, -1, sizeof(p));
    forn(i, MAXN) {
        rang[i] = 1;
    }
    int n, m;
    cin >> n >> m;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a == 1 || b == 1) {
            c = 0;
        }
        edges.eb(c, a, b);
    }
    sort(all(edges));
    vi all;
    for (int i = 2; i <= n; ++i) {
        all.eb(i);
    }
    Calc(0, m, all);
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] + (int)1e9 << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}