#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int maxpp = 13;
vector<int> pp(maxpp);

const int inf = 2 * 1e18;

int get(char c) {
	int t = c - 'A';
	int ret = pp[t / 2];
	if (t & 1) ret *= 5;
	return ret;
}

int count(string s) {
	int n = s.length();
	int mx = 0;
	int sum{};
	for (int i{ n - 1 }; i >= 0; --i) {
		int t = get(s[i]);
		if (t < mx) {
			sum -= t;
		}
		else {
			sum += t;
			mx = t;
		}
	}
	return sum;
}

void solve() {
	string s;
	cin >> s;
	int n = s.length();
	reverse(all(s));
	vector<vector<int>> dp(n, vector<int>(26, -inf));
	vector<vector<int>> pr(n, vector<int>(26, -inf));
	vector<vector<char>> lt(n, vector<char>(26, 'A'));
	if (s[0] != '?') {
		dp[0][s[0] - 'A'] = get(s[0]);
		lt[0][s[0] - 'A'] = s[0];
	}
	else {
		for (int i{}; i < 26; ++i) {
			dp[0][i] = get('A' + i);
			lt[0][i] = 'A' + i;
		}
	}

	for (int i{ 1 }; i < n; ++i) {
		for (int j{}; j < 26; ++j) {
			if (s[i] != '?' && s[i] - 'A' > j) continue;
			if (s[i] != '?') {
				if (j > s[i] - 'A') {
					if (dp[i][j] < dp[i - 1][j] - get(s[i]) && dp[i - 1][j] != -inf) {
						dp[i][j] = dp[i - 1][j] - get(s[i]);
						lt[i][j] = s[i];
						pr[i][j] = j;
					}
				}
				else {
					for (int k{}; k <= j; ++k) {
						if (dp[i][j] < dp[i - 1][k] + get(s[i]) && dp[i - 1][k] != -inf) {
							dp[i][j] = dp[i - 1][k] + get(s[i]);
							lt[i][j] = s[i];
							pr[i][j] = k;
						}
					}
				}
				continue;
			}

			for (int k{}; k <= j; ++k) {
				if (dp[i][j] < dp[i - 1][k] + get('A' + j) && dp[i - 1][k] != -inf) {
					dp[i][j] = dp[i - 1][k] + get('A' + j);
					lt[i][j] = 'A' + j;
					pr[i][j] = k;
				}
			}

		}
	}


	int mxi = 0;
	for (int i{}; i < 26; ++i) {
		if (dp[n - 1][i] > dp[n - 1][mxi]) mxi = i;
	}
	string ans{};
	int answ;
	answ = dp[n - 1][mxi];
	for (int i{ n - 1 }; i >= 0; --i) {
		ans += (char)(lt[i][mxi]);
		mxi = pr[i][mxi];
	}

	cout << answ << '\n' << ans << '\n';
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	pp[0] = 1;
	for (int i{ 1 }; i < maxpp; ++i) {
		pp[i] = pp[i - 1] * 10;
	}

	int t;
	cin >> t;
	for (int i{}; i < t; ++i) {
		solve();
	}

	return 0;
}

//#include <iostream>
//#include <string>
//#include <vector>
//#include <algorithm>
//#include <set>
//
//using namespace std;
//
//#define x first
//#define y second
//#define int long long
//#define all(v) v.begin(), v.end()
//#define rall(v) v.rbegin(), v.rend()
//
//const int inf = 1e9;
//
//int32_t main() {
//	cin.tie(NULL);
//	cout.tie(NULL);
//	ios::sync_with_stdio(false);
//
//	int n, q;
//	cin >> n >> q;
//	set<int> allx;
//	vector<pair<int, int>> a;
//	for (int i{}; i < n; ++i) {
//		int x, h;
//		cin >> x >> h;
//		allx.insert(x);
//		a.push_back({ x, h });
//	}
//
//	while (q) {
//		q--;
//		int l, r;
//		cin >> l >> r;
//		set<pair<int, int>> t;
//		for (int j{}; j < n; ++j) {
//			if (a[j].x > r) break;
//			if (a[j].x < l) continue;
//			t.insert({ a[j].y, a[j].x });
//		}
//
//		for (auto i : t) {
//			
//		}
//
//		for (auto i : t) {
//			allx.insert(i.y);
//		}
//	}
//
//	return 0;
//}