#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("fast-math")
#pragma GCC optimize ("unroll-loops")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <map>

using namespace std;

#define x first
#define y second
//#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

vector<int> fenv;
int n;

inline int F(int x) {
	return (x & (-x));
}

inline int _get(int i) {
	int ans = 0;
	while (i > 0) {
		ans += fenv[i];
		i -= F(i);
	}
	return ans;
}

inline void upd(int i) {
	while (i <= n) {
		fenv[i]++;
		i += F(i);
	}
}

int get(int l, int r) {
	return _get(r) - _get(l);
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int q;
	cin >> n >> q;

	fenv.resize(n + 1);
	
	vector<pair<int, int>> a(n);
	for (int i{}; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}

	vector<int> lt(n), rt(n);

	for (int i{}; i < n; ++i) {
		int x = (int)(lower_bound(all(a), make_pair(a[i].x + a[i].y, -1)) - a.begin());
		rt[i] = x - 1;
		x = (int)(lower_bound(all(a), make_pair(a[i].x - a[i].y + 1, -1)) - a.begin());
		lt[i] = x;
	}

	int mn = a[0].x, mx = a[n - 1].x;
	map<pair<int, int>, int> an;

	while (q) {
		q--;
		int l, r;
		cin >> l >> r;
		if (an.count({ l, r })) {
			cout << an[{l, r}] << '\n';
			continue;
		}

		for (int i{}; i <= n; ++i) fenv[i] = 0;
		
		l--;
		r--;

		vector<char> used(n, false);
		vector<char> used2(n, true);
		set<int> toch;
		set<int> is;
		queue<int> q;

		for (int i{ l }; i <= r; ++i) {
			q.push(i);
			is.insert(i);
		}

		int ans{};
		int tt{};
		
		
		
		
		while (!q.empty()) {
			tt++;
			auto i = q.front();
			used2[i] = false;
			q.pop();

			if (a[i].x - a[i].y >= mn) {
				if (lt[i] == i || get(lt[i], i) == i - lt[i]) {
					used[i] = true;
					upd(i + 1);
					++ans;

					is.erase(i);
					auto x = is.lower_bound(i);
					if (x != is.end() && !used2[*x]) {
						used2[*x] = true;
						q.push(*x);
					}
					if (x != is.begin()) {
						x = prev(x);
						if (!used2[*x]) {
							used2[*x] = true;
							q.push(*x);
						}
					}
					
				}
			}

			if (used[i]) continue;

			if (a[i].x + a[i].y <= mx) {
				if (rt[i] == i || get(i + 1, rt[i] + 1) == rt[i] - i) {
					used[i] = true;
					upd(i + 1);
					++ans;

					is.erase(i);
					auto x = is.lower_bound(i);
					if (x != is.end() && !used2[*x]) {
						used2[*x] = true;
						q.push(*x);
					}
					if (x != is.begin()) {
						x = prev(x);
						if (!used2[*x]) {
							used2[*x] = true;
							q.push(*x);
						}
					}
				}
			}


		}
		if (tt >= n + n + n) return 2;
		cout << ans << '\n';
		an[{l, r}] = ans;

	}

	return 0;
}


/*
3 3
1 3
3 1
4 2
2 3
*/

/*
5 3
1 5
3 1
4 2
5 3
6 1
*/