#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <set>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 300100;
vector<int> g[N], gr[N];
bool used[N];

vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<pair<int, int>> dfs(int v, int p = -1, int e = 0) {
	used[v] = true;

	set<int> ff, ss;
	for (auto u : g[v]) {
		if (u == p) continue;
		ff.insert(u);
	}
	for (auto u : gr[v]) {
		if (u == p) continue;
		ss.insert(u);
	}

	vector<pair<int, int>> res;
	for (auto u : g[v]) {
		if (u == p) continue;
		auto cur = dfs(u, v, 1 + 2 * (ss.find(u) != ss.end()));
		for (auto i : cur) res.push_back(i);
	}
	for (auto u : gr[v]) {
		if (u == p) continue;
		vector<pair<int, int>> cur;
		if (!used[u]) cur = dfs(u, v, 2 + (ff.find(u) != ff.end()));
		for (auto i : cur) res.push_back(i);
	}

	vector<pair<int, int>> f, s;
	for (auto i : res) {
		if (i.first == v) f.push_back(i);
		else s.push_back(i);
	}
	while (f.size() && s.size()) {
		ans.push_back(make_pair(f.back(), s.back()));
		f.pop_back();
		s.pop_back();
	}
	if (p != -1) {
		if ((e & 1) && f.size()) {
			ans.push_back(make_pair(make_pair(p, v), f.back()));
			e ^= 1;
			f.pop_back();
		}
		if ((e & 2) && s.size()) {
			ans.push_back(make_pair(make_pair(v, p), s.back()));
			e ^= 2;
			s.pop_back();
		}
	}

	res.clear();
	if (e & 1) res.push_back(make_pair(p, v));
	if (e & 2) res.push_back(make_pair(v, p));
	return res;
}

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	forn(i, m) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		gr[b].push_back(a);
	}

	forn(i, n) {
		if (!used[i]) {
			dfs(i);
		}
	}
	if (ans.size() != m / 2) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n";
		for (auto i : ans) {
			cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << '\n';
		}
	}
	return 0;
}