#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

struct Tree {
    int x, h;

    int l() const {
        return x - h;
    }

    int r() const {
        return x + h;
    }
};

const int N = (int) 5e5 + 10;

int used[N];
int timer;

int Go(int pos, const vector<Tree> &trees, int minL, int maxR) {
    int l = pos > 0 ? trees[pos - 1].x : trees[pos].x;
    int r = pos + 1 < sz(trees) ? trees[pos + 1].x : trees[pos].x;
    int ans = 1;
    int lPos = pos - 1, rPos = pos + 1;
    bool action = true;
    while (action) {
        action = false;
        if (lPos >= minL && (used[lPos] == timer || trees[lPos].r() <= r)) {
            ans += used[lPos] != timer;
            used[lPos] = timer;
            action = true;
            l = lPos > 0 ? trees[lPos - 1].x : trees[lPos].x;
            lPos--;
        }
        if (rPos <= maxR && (used[rPos] == timer || trees[rPos].l() >= l)) {
            ans += used[rPos] != timer;
            used[rPos] = timer;
            action = true;
            r = rPos + 1 < sz(trees) ? trees[rPos + 1].x : trees[rPos].x;
            rPos++;
        }
    }
    return ans;
}

void Solve() {
    int n, q;
    cin >> n >> q;
    vector<Tree> trees(n);
    for (auto&[x, h] : trees) {
        cin >> x >> h;
    }
    vector<int> starts;
    forn(i, n) {
        if (i > 0 && trees[i].l() >= trees[i - 1].x
            || i + 1 < n && trees[i].r() <= trees[i + 1].x) {
            starts.emplace_back(i);
        }
    }
    forn(query, q) {
        timer++;
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int i = int(lower_bound(all(starts), l) - starts.begin());
             i < sz(starts) && starts[i] <= r; i++) {
            if (used[starts[i]] == timer)
                continue;
            ans += Go(starts[i], trees, l, r);
        }
        cout << ans << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    forn(i, t) {
        Solve();
    }
}
