#include <bits/stdc++.h>

#define int ll
#undef INT_MAX
#undef INT_MIN
#define INT_MIN LLONG_MIN
#define INT_MAX LLONG_MAX

using namespace std;

#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma,popcnt,tune=native")

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = 21;


struct Edge {
    int u, v, t, id;

    int to(int from) const {
        return u ^ v ^ from;
    }
};

vector<Edge> g[N];
int ans[N];
bool used[N];

void DFS(int v, int mn = INT_MAX, int mx = INT_MIN) {
    minq(ans[v], mn + mx);
    for (auto& e : g[v]) {
        if (used[e.id])
            continue;
        used[e.id] = true;
        DFS(e.to(v), min(mn, e.t), max(mx, e.t));
        used[e.id] = false;
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    forn(i, m) {
        int u, v, t;
        cin >> u >> v >> t;
        u--, v--;
        Edge e = {u, v, t, i};
        g[u].emplace_back(e);
        g[v].emplace_back(e);
    }
    fill(ans, ans + N, INT_MAX);
    DFS(0);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    forn(i, t) {
        Solve();
    }
}
