#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>
#include <list>

using namespace std;


#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

signed main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}

const int MAXN = 3e5 + 10;
vector<pii> graph[MAXN];
int mins[MAXN];
int maxs[MAXN];
int n, m;


void treeDfs(int v, int p, int mn, int mx) {
    mins[v] = mn;
    maxs[v] = mx;
    for (auto [u, t] : graph[v]) {
        if (u == p) continue;
        treeDfs(u, v, min(mn, t), max(mx, t));
    }
}

vector<pair<pii, int>> edges;
int clrs[MAXN];
bool used[MAXN];
vector<int> tin;
void fRDS(int v) {
    used[v] = true;
    tin.push_back(v);
    for (auto&[u, t] : graph[v]) {
        if (used[u]) continue;
        fRDS(u);
        u = -1;
    }
}
void sRDS(int v, int clr) {
    clrs[v] = clr;
    for (auto[u, t] : graph[v]) {
        if (u == -1) continue;
        if (clrs[u]) continue;
        sRDS(u, clr);
    }
}
vector<pii> graphRDS[MAXN];
int minRDS[MAXN];
void treeDfsRDS(int v, int p, int mn) {
    minRDS[v] = mn = min(minRDS[v], mn);
    for (auto [u, t] : graphRDS[v]) {
        if (u == p) continue;
        treeDfsRDS(u, v, min(mn, t));
    }
}

vector<pair<pii, int>> anGraph[MAXN];

set<int> ue;
int ans[MAXN];

void go(int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (auto [p, t] : anGraph[v]) {
        auto[u, i] = p;
        if (ue.count(i)) continue;
        ue.insert(i);
        go(u, min(mn, t), max(mx, t));
        ue.erase(i);
    }
}

void solve() {
    cin >> n >> m;
    range(i, m) {
        int v, u, t; cin >> v >> u >> t; --v; --u;
        graph[v].pb({u, t});
        anGraph[v].pb({{u, i}, t});
        graph[u].pb({v, t});
        anGraph[u].pb({{v, i}, t});
        edges.push_back({{u, v}, t});
    }
    if (m == n - 1) {
        treeDfs(0, -1, 1e9, 0);
        prange(i, n - 1) {
            cout << mins[i] + maxs[i] << '\n';
        }
        return;
    }
    bool is2 = true;
    bool is3 = true;
    bool is6 = true;
    for (auto [u, t] : graph[0]) {
        if (t != 0) {
            is2 = false;
        }
        if (t != 1e9) {
            is3 = false;
        }
    }
    for (auto [p, t] : edges) {
        if (abs(p.fi - p.se) != 1) {
            is6 = false;
            break;
        }
    }
    if (is2) {
        set<pair<int, int>> q; // maxt, v
        vector<bool> used(n, false);
        range(i, n) {maxs[i] = 1e9;}
        maxs[0] = 0;
        q.insert({0, 0});
        while (!q.empty()) {
            int v = q.begin()->second;
            q.erase(q.begin());
            used[v] = true;
            for (auto[u, t] : graph[v]) {
                if (used[u]) continue;
                int tt = max(t, maxs[v]);
                if (tt < maxs[u]) {
                    q.erase({maxs[u], u});
                    maxs[u] = tt;
                    q.insert({maxs[u], u});
                }
            }
        }
        prange(i, n - 1) {
            cout << maxs[i] << '\n';
        }
        return;
    } else if (is3) {
        fRDS(0);
        int clr = 0;
        for (auto i : tin) {
            if (clrs[i]) continue;
            sRDS(i, ++clr);
        }
        fill(minRDS, minRDS + clr + 1, 1e9);
        for (auto [p, t] : edges) {
            auto [v, u] = p;
            int c1 = clrs[v], c2 = clrs[u];
            if (c1 == c2) {
                minRDS[c1] = min(minRDS[c1], t);
            } else {
                graphRDS[c1].pb({c2, t});
                graphRDS[c2].pb({c1, t});
            }
        }
        auto cc = clrs[0];
        treeDfsRDS(cc, -1, 1e9);
        prange(i, n - 1) {
            cout << (ll)(minRDS[clrs[i]] + (ll)1e9) << '\n';
        }
        return;
    } else if (is6) {
        vector<int> fGood(n - 1, -1);
        vector<int> sGood(n - 1, -1);
        for (auto [p, t] : edges) {
            auto[v, u] = p;
            if (v > u) swap(v, u);
            if (fGood[v] == -1 || t <= fGood[v]) {
                sGood[v] = fGood[v];
                fGood[v] = t;
            } else if (sGood[v] == -1 || t < sGood[v]) {
                sGood[v] = t;
            }
        }
        prange(i, n - 1) {
            int mn = 1e9;
            int mx = 0;
            range(j, i) {
                mn = min(mn, fGood[j]);
                mx = max(mx, fGood[j]);
            }
            int ans = mn + mx;
            for (int j = i; j < n - 1; ++j) {
                if (sGood[j] == -1) break;
                mn = min(mn, fGood[j]);
                mx = max(mx, sGood[j]);
                ans = min(ans, mn + mx);
            }
            cout << ans << '\n';
        }
    } else {
        range(i, n) {
            ans[i] = 2e9;
        }
        go(0, 1e9, 0);
        prange(i, n - 1) {
            cout << ans[i] << '\n';
        }
    }
}



