#include <iostream>

#include <algorithm>

#include <string>
#include <vector>

using namespace std;

typedef long long ll;

ll val[26];

ll get(string& s, int i) {
	char max_c = s[i];
	ll res = 0;
	for (int j = i; j >= 0; j--) {
		if (s[j] == '?')
			continue;

		if (s[j] >= max_c) {
			res += val[s[j] - 'A'];
		}
		else {
			res -= val[s[j] - 'A'];
		}

		max_c = max(max_c, s[j]);
	}

	return res;
}

ll solve1(string s) {
	int n = s.size();
	int cnt[26] = { 0 };

	for (int i = 0; i < n; i++) {
		if (s[i] != '?') {
			cnt[s[i] - 'A']++;
		}
		else {
			ll max_sum = 0, best_c = 'A';
			for (char c = 'A'; c <= 'Z'; c++) {
				s[i] = c;
				if (get(s, i) > max_sum) {
					max_sum = get(s, i);
					best_c = c;
				}
			}
			s[i] = best_c;
		}
	}

	return get(s, n - 1);
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	ll cur = 1;
	for (int i = 0; i < 26; i++) {
		val[i] = cur;
		if (i % 2 == 0)
			cur *= 5l;
		else
			cur *= 2l;
	}

	int t; cin >> t;
	while (t--) {
		string s; cin >> s;
		int n = s.size();

		vector<int> pos;
		for (int i = 0; i < n; i++) {
			if (s[i] == '?') {
				pos.push_back(i);
			}
		}

		char start = 'A';
		if (pos.size() > 0) {
			for (int i = 0; i < pos[0]; i++) {
				char c = s[i];
				if (c != '?')
					start = max(start, c);
			}
		}

		ll best_sum = -2e18;
		string ans = s;

		if (pos.size() == 0) {
			cout << get(s, n - 1) << '\n' << s << '\n';
		}
		else if (pos.size() == 1) {
			for (char c1 = start; c1 <= 'Z'; c1++) {
				s[pos[0]] = c1;

				if (get(s, n - 1) >= best_sum) {
					best_sum = get(s, n - 1);
					ans = s;
				}
			}

			cout << best_sum << '\n' << ans << '\n';
		}
		else if (pos.size() == 2) {
			for (char c1 = start; c1 <= 'Z'; c1++) {
				for (char c2 = 'A'; c2 <= c1; c2++) {
					s[pos[0]] = c1;
					s[pos[1]] = c2;

					if (get(s, n - 1) >= best_sum) {
						best_sum = get(s, n - 1);
						ans = s;
					}
				}
			}
			cout << best_sum << '\n' << ans << '\n';

		}
		else {
			for (char c1 = start; c1 <= 'Z'; c1++) {
				for (char c2 = 'A'; c2 <= c1; c2++) {
					for (char c3 = 'A'; c3 <= c2; c3++) {
						s[pos[0]] = c1;
						s[pos[1]] = c2;
						s[pos[2]] = c3;

						if (get(s, n - 1) >= best_sum) {
							best_sum = get(s, n - 1);
							ans = s;
						}
					}
				}
			}

			cout << best_sum << '\n' << ans << '\n';


		}
	}

	return 0;
}