#include <iostream>

#include <algorithm>

#include <vector>
#include <map>

using namespace std;

typedef long long ll;

struct p3 {
	int to, ind, t;

	p3() = default;
	p3(int to, int ind, int t) :to(to), ind(ind), t(t) {}
};

vector<vector<p3>> g;

vector<int> ans;

vector<bool> used;
vector<bool> used_e;

void dfs(int v, int a, int b) {
	used[v] = true;
	ans[v] = min(ans[v], a + b);
	
	for (auto to : g[v]) {
		if (!used_e[to.ind] && !used[to.to]) {
			used_e[to.ind] = true;
			dfs(to.to, min(a, to.t), max(b, to.t));
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c; cin >> v >> u >> c;
		v--; u--;

		g[v].push_back({ u, i, c });
		g[u].push_back({ v, i , c });
	}

	ans.assign(n, 2e9);
	used.assign(n, false);
	used_e.assign(m, false);
	dfs(0, 1e9, 0);

	for (int i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
	
	return 0;
}