#include <bits/stdc++.h>

using namespace std;

const int ALPHABET_SIZE = 26;
long long ones[ALPHABET_SIZE];

#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
#pragma GCC target("avx,sse,sse4.1,sse4.2")

long long get_one(char c) {
	return ones[c];
}


long long count_moscow_num(string &num, char max_on_suffix) {
	long long res = 0;
	for (auto it = num.rbegin(); it != num.rend(); ++it) {
		if (*it == '?') {
			continue;
		}
		if (*it >= max_on_suffix) {
			res += get_one(*it);
			max_on_suffix = *it;
		} else {
			res -= get_one(*it);
		}
	}
	return res;
}

const long long INF = 1000000000000000001;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	ones[0] = 1;
	for (int i = 1; i < ALPHABET_SIZE; ++i) {
		if (i & 1) {
			ones[i] = ones[i - 1] * 5;
		} else {
			ones[i] = ones[i - 1] * 2;
		}
	}
	while (t--) {
		string s;
		cin >> s;
		transform(s.begin(), s.end(), s.begin(), 
				[&](char c)->char {
					return (c != '?' ? c - 'A' : '?');
				});
		int n = s.size();
		vector<vector<long long>> dp(n + 1,
				vector<long long>(ALPHABET_SIZE, -INF));
		vector<vector<pair<char, char>>> prev(n + 1, vector<pair<char, char>> (ALPHABET_SIZE, {-1, -1}));
		for (char c = 0; c < ALPHABET_SIZE; ++c) {
			dp[n][c] = count_moscow_num(s, c);
		}
		vector<vector<vector<long long>>> vals(n + 1, vector<vector<long long>>(ALPHABET_SIZE, vector<long long>(ALPHABET_SIZE)));
		vector<vector<vector<long long>>> pisums(n + 1, vector<vector<long long>>(ALPHABET_SIZE, vector<long long>(ALPHABET_SIZE)));
		for (char c = 0; c < ALPHABET_SIZE; ++c) {
			for (char a = 0; a < ALPHABET_SIZE; ++a) {
				char max_on_suffix = c;
				for (int i = n - 1; i >= 0; --i) {
					if (s[i] != '?' && s[i] >= max_on_suffix) {
						if (s[i] < a) {
							vals[i][a][c] = get_one(s[i]);
						} else {
							vals[i][a][c] = 0;
						}
						max_on_suffix = s[i];
					}
				}
				for (int i = 0; i < n; ++i) {
					pisums[i + 1][a][c] = pisums[i][a][c] + vals[i][a][c];
				}
			}
		}
		for (int i = n; i > 0; --i) {
			for (char c = 0; c < ALPHABET_SIZE; ++c) {
				if (s[i - 1] != '?') {
					char new_next = max(s[i - 1], c);
					long long new_value = dp[i][c];
					if (new_value >= dp[i - 1][new_next]) {
						dp[i - 1][new_next] = new_value;
						prev[i - 1][new_next] = {s[i - 1], c};
					}
					continue;
				}
				for (char next = 0; next < ALPHABET_SIZE; ++next) {
					char new_next = max(c, next);
					long long new_value = dp[i][c];
					if (next >= c) {
						new_value += get_one(next);
					} else {
						new_value += get_one(c);
					}
					new_value -= 2 * pisums[i - 1][next][c];
					if (new_value >= dp[i - 1][new_next]) {
						prev[i - 1][new_next] = {next, c};
						dp[i - 1][new_next] = new_value;
					}
				}
			}
		}
		int c = max_element(dp[0].begin(), dp[0].end()) - dp[0].begin();
		int i = 0;
		cout << dp[0][c] << '\n';
		while (i < n) {
			cout << (char) ('A' + prev[i][c].first);
			c = prev[i][c].second;
			++i;
		}
		cout << '\n';
	}
}
