#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define int long long
using namespace std;

const int INF = 1e18;

int n, m;
vector <vector <pair <int, pair <int, int>>>> g;

vector <int> tin, fup;
vector <char> used;
int timer = 0;

void dfs1(int u, int p = -1) {
	fup[u] = tin[u] = timer++;
	used[u] = true;
	for (auto pp : g[u]) {
		int v = pp.second.first;
		if (p == pp.first)
			continue;
		if (used[v])
			fup[u] = min(fup[u], tin[v]);
		else {
			dfs1(v, u);
			fup[u] = min(fup[u], fup[v]);
		}
	}
}

vector <int> color;
vector <int> ans;
int colors = 1;

void dfs2(int u, int clr = 0) {
	color[u] = clr;
	for (auto p : g[u]) {
		int v = p.second.first;
		int w = p.second.second;
		if (color[v] != -1)
			continue;
		if (fup[v] > tin[u]) {
			ans.push_back(min(ans[clr], w));
			dfs2(v, colors++);
		}
		else {
			ans[clr] = min(ans[clr], w);
			dfs2(v, clr);
		}
	}
}

signed main() {
	//ios::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	cin >> n >> m;

	g.resize(n);
	used.resize(n);
	tin.resize(n);
	fup.resize(n);

	for (int i = 0; i < m; i++) {
		int u, v, t; cin >> u >> v >> t; u--, v--;
		g[u].push_back({ i, { v, t } });
		g[v].push_back({ i, { u, t } });
	}

	dfs1(0);
	color.resize(n, -1);
	ans.assign(1, 1e9);
	dfs2(0);

	for (int i = 1; i < n; i++) {
		cout << ans[color[i]] + 1000000000LL << endl;
	}

	return 0;
}

/*
4 4
1 2 1000000000
2 3 1
2 4 1
1 4 1000000000
*/