#include <iostream>
#include <vector>
#include <algorithm>

struct State {
    int64_t ans;
    int32_t prev;

    int32_t counts[26];
};

void solve2(std::string str, int32_t n, int64_t* values/*, int64_t true_ans, std::string true_str_ans*/) {
    //Compress
    std::string str2;
    int32_t max = -1;
    int32_t num_ques = 0;
    for(int32_t i = n - 1; i >= 0; i--) {
        if(str[i] == '?' || str[i] - 'A' >= max)
            str2.push_back(str[i]);

        if(str[i] != '?')
            max = std::max(max, str[i] - 'A');
        else
            num_ques++;
    }
    std::reverse(str2.begin(), str2.end());

    State** dp = new State*[num_ques + 1];
    //Start
    dp[0] = new State[26];
    for(int32_t i = 0; i < 26; i++) {
        dp[0][i].ans = 0;
        for (int j = 0; j < 26; j++)
            dp[0][i].counts[j] = 0;
    }

    //Loop
    int32_t counts[26];
    for(int32_t i = 0; i < 26; i++)
        counts[i] = 0;
    int32_t ques_cur = 1;
    for(int32_t i = 0; i < str2.size(); i++) {
        if(str2[i] != '?')
            counts[str2[i] - 'A']++;
        else {
            dp[ques_cur] = new State[26];

            int64_t cur_ans = 0;
            for(int32_t j = 0; j < 26; j++)
                cur_ans += counts[j] * values[j];
            for (int32_t j = 0; j < 26; j++) {
                dp[ques_cur][j].ans = -1'000'000'000'000'000'000ll;
                //recomp cur_ans
                if(j != 0)
                    cur_ans -= 2 * counts[j - 1] * values[j - 1];

                for (int32_t k = j; k < 26; k++) {
                    if(dp[ques_cur - 1][k].ans + cur_ans + values[j] > dp[ques_cur][j].ans) {
                        dp[ques_cur][j].ans = dp[ques_cur - 1][k].ans + cur_ans + values[j];
                        dp[ques_cur][j].prev = k;
                    }
                }
            }

            ques_cur++;
            for(int32_t j = 0; j < 26; j++)
                counts[j] = 0;
        }
    }

    std::vector<char> questions;
    int32_t  cur =0;
    for(int32_t i = 0; i < 26; i++)
        if(dp[num_ques][i].ans > dp[num_ques][cur].ans)
            cur  = i;

    for(int32_t i = 0 ; i < num_ques; i++) {
        questions.push_back('A' + cur);
        cur = dp[num_ques - i][cur].prev;
    }
    std::reverse(questions.begin(), questions.end());

    std::string str_ans;
    int32_t num_q = 0;
    for(int32_t i = 0; i < n; i++) {
        if(str[i] != '?') {
            str_ans.push_back(str[i]);
        } else {
            str_ans.push_back(questions[num_q++]);
        }
    }

    max = -1;
    int64_t answer = 0;
    for(int32_t i = n - 1; i >= 0; i--) {
        if(str_ans[i] - 'A' < max)
            answer -= values[str_ans[i] - 'A'];
        else
            answer += values[str_ans[i] - 'A'];
        max = std::max(max, str_ans[i] - 'A');
    }

    std::cout << answer << "\n";
    std::cout << str_ans << "\n";

    /*int x = 0;
    if(true_ans != answer) {
        int x = 0;
        if(str_ans != true_str_ans)
            x++;
        x++;
        exit(0);
    }*/
}

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    int64_t values[26];
    values[0] = 1;
    for(int32_t i = 1; i < 26; i++)
        if(i % 2 == 1)
            values[i] = values[i - 1] * 5;
        else
            values[i] = values[i - 1] * 2;

    for(int32_t t = 0 ;t < num_tests; t++) {
        std::string str;
        std::cin >> str;
        int32_t n = str.size();
        /*int32_t n = 30;
        for(int32_t i = 0 ;i < n; i++)
            str.push_back('A' + rand() % 26);
        str[rand() % n] = '?';
        str[rand() % n] = '?';
        str[rand() % n] = '?';

        int64_t true_ans = -1'000'000'000'000'000'000;
        std::string true_str_ans;
        for(int32_t a = 0; a < 26; a++)
            for(int32_t b = 0; b  <= a; b++)
                for(int32_t c = 0; c  <= b; c++) {
                    int32_t passed = 0;
                    std::string str_ans;
                    for (int32_t i = 0; i < n; i++) {
                        if (str[i] != '?') {
                            str_ans.push_back(str[i]);
                        } else {
                            if(passed == 0)
                                str_ans.push_back('A' + a);
                            else if(passed == 1)
                                str_ans.push_back('A' + b);
                            else
                                str_ans.push_back('A' + c);
                            passed++;
                        }
                    }

                    int32_t max = -1;
                    int64_t answer = 0;
                    for(int32_t i = n - 1; i >= 0; i--) {
                        if(str_ans[i] - 'A' < max)
                            answer -= values[str_ans[i] - 'A'];
                        else
                            answer += values[str_ans[i] - 'A'];
                        max = std::max(max, str_ans[i] - 'A');
                    }

                    if(answer > true_ans) {
                        true_ans = answer;
                        true_str_ans = str_ans;
                    }
                }

        std::cout << true_ans << "\n";
        std::cout << true_str_ans << "\n";

        int a = 0;
        if(t == 4)
            a++;*/
        solve2(str, n, values/*, true_ans, true_str_ans*/);
        std::cout << "\n";
    }
    return 0;
}