#include <iostream>

bool are_trees(int32_t left, int32_t right, bool* deactivated, int32_t n, std::pair<int32_t, int32_t>* arr) {
    if(right < left)
        return false;

    int32_t first = std::lower_bound(arr, arr + n, std::pair<int32_t, int32_t>(left, -1)) - arr;
    int32_t last = std::lower_bound(arr, arr + n, std::pair<int32_t, int32_t>(right + 1, -1)) - arr;
    for(int32_t i = first; i < last; i++)
        if(!deactivated[i] && arr[i].first >= left && arr[i].first <= right)
            return true;
    return false;
}

int main() {
    int32_t n, q;
    std::cin >> n >> q;

    std::pair<int32_t, int32_t>* arr = new std::pair<int32_t, int32_t>[n];
    for(int32_t i = 0; i < n; i++) {
        std::cin >> arr[i].first >> arr[i].second;
    }

    bool* deactivated = new bool[n];
    for(int32_t q1 = 0; q1 < q; q1++) {
        int32_t left, right;
        std::cin >> left >> right;
        left--;
        right--;

        for(int32_t i = 0; i < n; i++)
            deactivated[i] = false;

        int32_t ans = 0;
        for(int32_t i = 0; i < right - left + 1; i++) {
            int32_t cur = -1;
            for(int32_t j = left; j <= right; j++) {
                if(deactivated[j])
                    continue;

                //to left?
                bool ok = false;
                if(arr[j].first - arr[j].second >= arr[0].first) {
                    if(!are_trees(arr[j].first - arr[j].second + 1, arr[j].first - 1, deactivated, n, arr)) {
                        ok = true;
                    }
                }
                if(ok) {
                    cur = j;
                }

                //to right?
                if(arr[j].first + arr[j].second <= arr[n - 1].first) {
                    if(!are_trees(arr[j].first + 1, arr[j].first + arr[j].second - 1, deactivated, n, arr)) {
                        ok = true;
                    }
                }
                if(ok) {
                    cur = j;
                    break;
                }
            }
            if(cur == -1)
                break;
            else {
                ans++;
                deactivated[cur] = true;
            }
        }
        std::cout << ans << "\n";
    }

    return 0;
}