#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 3e5 + 100;
const int INFi = 2e9;

struct segment_tree {
    vector<int> tree{};
    int n{};

    void build(int k) {
        n = k;
        tree.resize(n * 4, INFi);
    }

    void upd(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            tree[v] = x;
            return;
        }
        int mid = (l + r) >> 1;
        if (i < mid) upd(v << 1, l, mid, i, x);
        else upd(v << 1 | 1, mid, r, i, x);
        tree[v] = max(tree[v << 1], tree[v << 1 | 1]);
    }
};


void solve() {
    int n, q; cin >> n >> q;
    vector<int> x(n), h(n);
    range(i, n) cin >> x[i] >> h[i];
    vector<int> lx(n), rx(n);
    range(i, n) {
        lx[i] = upper_bound(all(x), x[i] - h[i]) - x.begin();
        rx[i] = lower_bound(all(x), x[i] + h[i]) - x.begin();
        rx[i]--;
    }
    vector<int> dpl(n, -INFi), dpr(n, INFi);
    vector<bool> usl(n), usr(n);
    set<int> nl, nr;
    range(i, n) {
        nl.insert(i);
        nr.insert(i);
    }
    queue<int> q1;
    queue<int> q2;

    auto max_o = [&] (int l, int r) {
        int res = -INFi;
        for(int i = l; i < r; ++i) {
            if (dpl[i] != -INFi) continue;
            res = max(res, dpr[i]);
        }
        return res;
    };

    auto min_o = [&] (int l, int r) {
        int res = INFi;
        for(int i = l; i < r; ++i) {
            if (dpr[i] != INFi) continue;
            res = min(res, dpl[i]);
        }
        return res;

    };

    auto check = [&] (int i) {
        if (!usl[i] && x[i] - h[i] >= x[0]) {
            if (max_o(lx[i], i) <= x[i]) {
                usl[i] = true;
                q1.push(i);
            }
        }
        if (!usr[i] && x[i] + h[i] <= x[n - 1]) {
            if (min_o(i + 1, rx[i] + 1) >= x[i]) {
                usr[i] = true;
                q2.push(i);
            }
        }
    };
    range(i, n) {
        check(i);
    }
    while(!q1.empty() || !q2.empty()) {
        while(!q1.empty()) {
            int i = q1.front();
            q1.pop();
            nl.erase(i);
            int cur = x[i] - h[i];
            for(int j = i - 1; j >= 0; --j) {
                if (x[j] <= x[i] - h[i]) break;
                if (dpr[j] <= x[i]) continue;
                cur = min(cur, dpl[j]);
            }
            dpl[i] = max(dpl[i], cur);
            assert(dpl[i] != -INFi);
            auto it = nl.lower_bound(i);
            if (it != nl.end()) check(*it);
            if (it != nl.begin()) check(*prev(it));
            auto it2 = nr.lower_bound(i);
            if (it2 != nr.end()) check(*it2);
            if (it2 != nl.end()) check(*prev(it2));
        }

        while(!q2.empty()) {
            int i = q2.front();
            q2.pop();
            nr.erase(i);
            int cur = x[i] + h[i];
            for(int j = i + 1; j < n; ++j) {
                if (x[j] >= x[i] + h[i]) break;
                if (dpl[j] >= x[i]) continue;
                cur = max(cur, dpr[j]);
            }
            dpr[i] = min(dpr[i], cur);
            assert(dpr[i] != INFi);
            auto it = nl.lower_bound(i);
            if (it != nl.end()) check(*it);
            if (it != nl.begin()) check(*prev(it));
            auto it2 = nr.lower_bound(i);
            if (it2 != nr.end()) check(*it2);
            if (it2 != nl.end()) check(*prev(it2));
        }
    }
    /*
    range(_, n) {
        range(i, n) {
            if (x[i] - h[i] < x[0]) continue;
            if (dpl[i] != -INFi) continue;
            int cur = x[i] - h[i];
            for(int j = i - 1; j >= 0; --j) {
                if (x[j] <= x[i] - h[i]) break;
                if (dpr[j] <= x[i]) continue;
                cur = min(cur, dpl[j]);
            }
            dpl[i] = max(dpl[i], cur);
        }
        range(i, n) {
            if (x[i] + h[i] > x[n - 1]) continue;
            if (dpr[i] != INFi) continue;
            int cur = x[i] + h[i];
            for(int j = i + 1; j < n; ++j) {
                if (x[j] >= x[i] + h[i]) break;
                if (dpl[j] >= x[i]) continue;
                cur = max(cur, dpr[j]);
            }
            dpr[i] = min(dpr[i], cur);
        }
    }
    */
    range(_, q) {
        int l, r; cin >> l >> r;
        int x1;
        if (l == 1) {
            x1 = x[0];
        } else {
            x1 = x[l-2];
        }
        int x2;
        if (r == n) {
            x2 = x[n - 1];
        } else {
            x2 = x[r];
        }
        int ans = 0;
        for(int i = l - 1; i < r; ++i) {
            if (dpl[i] >= x1 || dpr[i] <= x2) ans++;
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}