#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
using namespace std;

const int maxN = 2e3 + 100;
const int INFi = 2e9;

struct dsu {
    vector<int> dsu{};
    vector<int> rnk{};
    int n{};

    void build(int k) {
        n = k + 10;
        dsu.resize(n);
        rnk.resize(n, 1);
        iota(all(dsu), 0);
    }

    int get_dsu(int a) {
        return dsu[a] == a ? a : dsu[a] = get_dsu(dsu[a]);
    }

    bool unio(int a, int b) {
        a = get_dsu(a);
        b = get_dsu(b);
        if (a == b) return false;
        if (rnk[a] > rnk[b]) swap(a, b);
        rnk[b] += rnk[a];
        dsu[a] = b;
        return true;
    }
};

vector<pair<int, int>> g1[maxN];
int dist[maxN][maxN];
int h1[maxN], mn1[maxN], mx1[maxN];

vector<ar<int, 3>> edges;
vector<pair<int, int>> g[maxN];
bool deleted[maxN];
int n, m;

void dfs1(int v, int p) {
    if (v != 1) {
        for(int i = 1; i <= n; ++i) dist[v][i] = INFi;
        dist[v][v] = 0;
        set<pair<int, int>> q;
        q.insert({0, v});
        while(!q.empty()) {
            auto [d, u] = *q.begin();
            q.erase(q.begin());
            for(auto &[u, i] : g[v]) {
                if (deleted[i]) continue;
                if (dist[v][u] > max(d, edges[i][0])) {
                    if (dist[v][u] != INFi) q.erase({dist[v][u], u});
                    dist[v][u] = max(d, edges[i][0]);
                    q.insert({dist[v][u], u});
                }
            }
        }
    }
    for(auto &[u, i] : g1[v]) {
        if (u == p) continue;
        h1[u] = h1[v] + 1;
        mn1[u] = min(mn1[v], edges[i][0]);
        mx1[u] = max(mx1[u], edges[i][0]);
        deleted[i] = true;
        dfs1(u, v);
        deleted[i] = false;
    }
}


void solve() {

    cin >> n >> m;
    edges.resize(m);
    vector<int> us(m);
    range(i, m) {
        cin >> edges[i][1] >> edges[i][2] >> edges[i][0];
        g[edges[i][1]].emplace_back(edges[i][2], i);
        g[edges[i][2]].emplace_back(edges[i][1], i);
    }
    sort(all(edges));
    {
        dsu D;
        D.build(n);
        int i = 0;
        for(auto &[w, a, b] : edges) {
            if (D.unio(a, b)) {
                g1[a].emplace_back(b, i);
                g1[b].emplace_back(a, i);
                us[i] = 1;
            }
            i++;
        }
    }
    mn1[1] = INFi;
    mx1[1] = -INFi;
    dfs1(1, -1);
    for(int k = 2; k <= n; ++k) {
        vector<int> cur(m, -1);
        int result = mn1[k] + mx1[k];
        range(i, m) {
            if (us[i] != 1) continue;
            int a = edges[i][1];
            int b = edges[i][2];
            if (h1[a] > h1[b]) swap(a, b);
            int mn = mn1[b];
            int mx = max(mx1[b], dist[b][k]);
            result = min(result, mn + mx);
        }
        cout << result << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}