#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e18) + 123;
const ll maxn = ll(3e5) + 5;

ll n, m;
set<ll> gr[maxn];
set<ll> tree[maxn];

vector<ll> used(maxn, 0);

ll dp[maxn][4]; /// in mask: 0 - edge needs to be used/ 1 - edge already used
/// first bit - edge to the parent

vector<vector<ll>> out;

ll convert(bool has_up, bool has_down) {
    ll res = 0;
    if(!has_up) {
        res += 2;
    }
    if(!has_down) {
        res += 1;
    }
    return res;
}

void dfs(ll v, ll par) {
    used[v] = true;

    ll cnt = 0;
    tree[v].erase(par); /// here
    for(auto i : tree[v]) {
        cnt++;

        dfs(i, v);
    }

    bool has_up = false;
    bool has_down = false;
    if(par != -1) {
        if(gr[v].find(par) != gr[v].end()) {
            has_up = true;
        }
        if(gr[par].find(v) != gr[par].end()) {
            has_down = true;
        }
    }

    if(cnt == 0) {
        dp[v][convert(has_up, has_down)] = 1;
    } else {
        // ll ups = 0, downs = 0;
        vector<pll> ups, downs;
        for(auto i : tree[v]) {
            bool was = false;
            for(ll j = 0; j < 4; j++) {
                if(dp[i][j] == 0) continue;

                was = true;
                if((j & 2) == 0) {
                    // ups++;
                    ups.pb({i, v});
                }
                if((j & 1) == 0) {
                    // downs++;
                    downs.pb({v, i});
                }
            }
            if(!was) {
                ups = {};
                downs = {{-1, -1}, {-1, -1}};
                break;
            }
        }

        ll state = convert(has_up, has_down);
        if(abs(ll(ups.size()) - ll(downs.size())) <= 1) {
            if(ups.size() == downs.size()) {
                dp[v][state] = 1;

                for(ll i = 0; i < ups.size(); i++) {
                    vector<ll> tmp;

                    tmp.pb(ups[i].first);
                    tmp.pb(ups[i].second);
                    tmp.pb(downs[i].first);
                    tmp.pb(downs[i].second);

                    out.pb(tmp);
                }
            } else if(ups.size() + 1 == downs.size()) {
                if(has_down) {
                    has_down = false;
                    state = convert(has_up, has_down);
                    dp[v][state] = 1;

                    ups.pb({par, v});

                    for(ll i = 0; i < ups.size(); i++) {
                        vector<ll> tmp;

                        tmp.pb(ups[i].first);
                        tmp.pb(ups[i].second);
                        tmp.pb(downs[i].first);
                        tmp.pb(downs[i].second);

                        out.pb(tmp);
                    }
                }
            } else {
                if(has_up) {
                    has_up = false;
                    state = convert(has_up, has_down);
                    dp[v][state] = 1;

                    downs.pb({v, par});

                    for(ll i = 0; i < ups.size(); i++) {
                        vector<ll> tmp;

                        tmp.pb(ups[i].first);
                        tmp.pb(ups[i].second);
                        tmp.pb(downs[i].first);
                        tmp.pb(downs[i].second);

                        out.pb(tmp);
                    }
                }
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].insert(u);

        tree[v].insert(u);
        tree[u].insert(v);
    }

    for(ll i = 0; i < n; i++) {
        if(used[i]) continue;

        dfs(i, -1);

        if(dp[i][3] == 0) {
            cout << "No\n";
            for(ll j = 0; j < n; j++) {
                for(ll c = 0; c < 4; c++) {
                    cout << dp[j][c] << " ";
                }
                cout << endl;
            }
            return;
        }
    }

    cout << "Yes\n";
    for(auto ar : out) {
        //sort(ar.begin(), ar.end());
        for(auto el : ar) {
            cout << el+1 << " ";
        }
        cout << "\n";
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
