#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(4e18) + 123;
const ll maxn = ll(3e5) + 5;

ll n, m;
vector<pll> gr[maxn];
ll matrix[20][20];

vector<pll> edges;
vector<ll> ts;

vector<ll> ans(maxn, 0);

void dfs_on_tree(ll v, ll par, ll mn, ll mx) {
    ans[v] = mn + mx;
    for(auto el : gr[v]) {
        if(el.first == par) continue;

        ll nw_mn = min(mn, el.second);
        ll nw_mx = max(mx, el.second);

        dfs_on_tree(el.first, v, nw_mn, nw_mx);
    }
}

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < m; i++) {
        ll v, u, t;
        cin >> v >> u >> t;
        v--;
        u--;
        gr[v].pb({u, t});
        gr[u].pb({v, t});
        edges.pb({v, u});
        ts.pb(t);

        if(n <= 20) {
            matrix[v][u] = 1;
            matrix[u][v] = 1;
        }
    }

    if(m == n - 1) {
        dfs_on_tree(0, -1, inf, -inf);
        for(ll i = 1; i < n; i++) {
            cout << ans[i] << "\n";
        }
        return;
    }

    if(n <= 20 && m <= 20) {
        ll dp[1 << m][n];
        ll mn[1 << m][n];
        ll mx[1 << m][n];
        for(ll msk = 0; msk < (1 << m); msk++) {
            for(ll v = 0; v < n; v++) {
                dp[msk][v] = 0;
                mn[msk][v] = inf;
                mx[msk][v] = -inf;
            }
        }
        dp[0][0] = 1;
        mn[0][0] = inf;
        mx[0][0] = -inf;

        ans.assign(n, inf);

        for(ll msk = 0; msk < (1 << m); msk++) {
            for(ll v = 0; v < n; v++) {
                if(dp[msk][v] == 0) continue;

                ans[v] = min(ans[v], mn[msk][v] + mx[msk][v]);

                for(ll i = 0; i < edges.size(); i++) {
                    if(msk & (1 << i)) continue;
                    if(edges[i].first != v && edges[i].second != v) continue;

                    ll u = v ^ edges[i].first ^ edges[i].second;

                    ll nw_msk = msk + (1 << i);

                    dp[nw_msk][u] = 1;
                    mn[nw_msk][u] = min(mn[msk][v], ts[i]);
                    mx[nw_msk][u] = max(mx[msk][v], ts[i]);
                }
            }
        }

        for(ll i = 1; i < n; i++) {
            cout << ans[i] << "\n";
        }
        return;
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
