#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <set>
using namespace std;

const int MAXN = 300020;
const int INF = 1e9;
vector<pair<int, int> > g[MAXN];

int mmax[MAXN];
int mmin[MAXN];
bool used[MAXN];

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u, t;
		cin >> v >> u >> t;
		--v; --u;
		g[v].push_back(make_pair(u, t));
		g[u].push_back(make_pair(v, t));
	}
	for (int i = 1; i < n; ++i) {
		mmax[i] = INF;
		mmin[i] = INF;
	}
	mmin[0] = INF;
	mmax[0] = 0;
	used[0] = true;
	for (int i = 0; i < 2 * n; ++i) {
		for (int v = 0; v < n; ++v) {
			if (!used[v]) continue;
			for (pair<int, int> e : g[v]) {
				int newMin = min(mmin[v], e.second);
				int newMax = max(mmax[v], e.second);
				if (newMin + newMax < mmin[e.first] + mmax[e.first]) {
					mmin[e.first] = newMin;
					mmax[e.first] = newMax;
					used[e.first] = true;
				}
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << mmin[i] + mmax[i] << "\n";
	}
}

/*
3 3
1 2 2
1 3 1
2 3 1
*/

/*
7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/