#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

const int INF = 1e9 + 10;

struct edge {
	int to, c;
	int num;
};

vector < edge > g[N];

int res[N];

bool used[N];
bool del_e[N];

set < pair < int, int > > s;

int n, m;

void dijkstra() {
	s.insert({ 0, 1 });
	res[0] = 0;
	for (int i = 2; i <= n; ++i) {
		res[i] = INF;
		s.insert({ INF, i });
	}
	while (!s.empty()) {
		int v = s.begin()->second;
		used[v] = true;
		s.erase(s.begin());
		for (auto t : g[v]) {
			int to = t.to;
			int c = t.c;
			if (used[to])
				continue;
			s.erase({ res[to], to });
			res[to] = min(res[to], max(res[v], c));
			s.insert({ res[to], to });
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	

	cin >> n >> m;

	for (int i = 1; i <= m; ++i) {
		int v, to, c;
		cin >> v >> to >> c;
		g[v].push_back({ to, c });
		g[to].push_back({ v, c });
	}

	dijkstra();

	for (int i = 2; i <= n; ++i) {
		cout << res[i] << '\n';
	}

}