#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()

void dfs(int i, vector<vector<int>> &graph, vector<int> &used){
    used[i] = 1;
    for (int el : graph[i])
        if (!used[el])
            dfs(el, graph, used);
}

void build_roots(vector<int> &roots, vector<vector<int>> &graph){
    int n = graph.size();
    vector<int> used(n);
    for (int i = 0; i < n; i++)
        if (!used[i]){
            roots.pb(i);
            dfs(i, graph, used);
        }
}

bool dfs2(int i, int par, vector<pair<pair<int, int>, pair<int, int>>> &lst, vector<vector<int>> &graph, set<pair<int, int>> &edges){
    vector<int> to;
    vector<int> from;

    for (int el : graph[i]){
        if (el == par)
            continue;
        if (!dfs2(el, i, lst, graph, edges))
            return false;
        if (edges.find({i, el}) != edges.end())
            from.pb(el);
        if (edges.find({el, i}) != edges.end())
            to.pb(el);
    }
    int a = to.size(), b = from.size();
    if (abs(a - b) >= 2)
        return false;
    if (a - b == 1){
        auto it = edges.find({i, par});
        if (it == edges.end())
            return false;
        edges.erase(it);
        from.pb(par);
    }
    else if (b - a == 1){
        auto it = edges.find({par, i});
        if (it == edges.end())
            return false;
        edges.erase(it);
        to.pb(par);
    }

    a = to.size();
    for (int k = 0; k < a; k++)
        lst.pb({{to[k], i}, {i, from[k]}});
    return true;
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    set<pair<int, int>> edges;
    vector<vector<int>> full(n);
    int a, b;
    for (int i = 0; i < m; i++){
        cin >> a >> b;
        a--; b--;
        edges.insert({a, b});
        full[a].pb(b);
        full[b].pb(a);
    }

    for (int i = 0; i < n; i++){
        sort(all(full[i]));
        full[i].resize(unique(all(full[i])) - full[i].begin());
    }

    vector<int> roots;
    build_roots(roots, full);

    vector<pair<pair<int, int>, pair<int, int>>> lst;
    for (int root : roots)
        if (!dfs2(root, root, lst, full, edges)){
            cout << "No";
            return 0;
        }

    cout << "Yes\n";
    for (auto p : lst){
        cout << p.ft.ft + 1 << " " << p.ft.sd + 1 << " " << p.sd.ft + 1 << " " << p.sd.sd + 1 << "\n";
    }
    return 0;
}