#include <iostream>
#include <vector>

using namespace std;

vector<int> pr;
vector<bool> used;
vector<bool> sec_used;
vector<vector<int> > g;
vector<pair<pair<int, int>, pair<int, int> > > ans;
vector<int> st;

void dfs(int v, int pred) {
    pr[v] = pred;
    used[v] = true;
    for (auto u: g[v]) {
        if (u != pred) {
            st[u]++;
        }
        if (!used[u]) {
            dfs(u, v);
        }
    }
}

void contain_ans(int v) {
    sec_used[v] = true;
    for (auto u: g[v]) {
        if (sec_used[u]) {
            continue;
        }
        if (!(used[v] && used[u]) && st[v] >= 2 && st[u] >= 2) {
            ans.push_back({{u, v}, {v, u}});
        }
        contain_ans(u);
    }
}

int main()
{
    int n, m;
    cin >> n;
    cin >> m;
    if (m != 2 * n - 4) {
        if (n == 5) {
            cout << "Yes\n";
        }
    }
    else {
        pr.resize(n);
        used.resize(n, false);
        sec_used.resize(n, false);
        g.resize(n);
        st.resize(n, 0);
        for (int i = 0; i < n; ++i) {
            st[i] = 0;
        }
        for (int i = 0; i < m; ++i) {
            int  v, u;
            cin >> v;
            cin >> u;
            v--;
            u--;
            g[v].push_back(u);
            g[u].push_back(v);
        }
        dfs(0, -1);
        int a, b;
        a = -1;
        /*for (auto i: st) {
            cout << i << ' ';
        }
        cout << '\n';*/
        for (int i = 0; i < n; ++i) {
            used[i] = false;
            if (st[i] % 2 == 1) {
                if (a == -1) {
                    a = i;
                }
                else {
                    b = i;
                }
            }
        }
        if (a == -1) {
            cout << "No\n";
            return 0;
        }
        int v = a;
        int LCA = -1;
        while (v != -1) {
            used[v] = true;
            v = pr[v];
        }
        v = b;
        while (!used[v]) {
            v = pr[v];
        }
        LCA = v;
        v = pr[v];
        while (v != -1) {
            used[v] = false;
            v = pr[v];
        }
        bool up = true;
        if (g[a].size() % 2 == 0) {
            up = false;
        }
        v = a;
        //cout << a << ' ' << b << '\n';
        while (pr[v] != LCA) {
            if (!up) {
                up = true;
                ans.push_back({{v, pr[v]}, {pr[v], pr[pr[v]]}});
            }
            else {
                up = false;
                ans.push_back({{pr[v], v}, {pr[pr[v]], pr[v]}});
            }
            v = pr[v];
        }
        bool in_lca = up;
        int after = v;
        up = true;
        if (g[b].size() % 2 == 0) {
            up = false;
        }
        v = b;
        while (pr[v] != LCA) {
            if (!up) {
                up = true;
                ans.push_back({{v, pr[v]}, {pr[v], pr[pr[v]]}});
            }
            else {
                up = false;
                ans.push_back({{pr[v], v}, {pr[pr[v]], pr[v]}});
            }
            v = pr[v];
        }
        if (up == in_lca) {
            cout << "No\n";
            return 0;
        }
        if (!up) {
            ans.push_back({{v, LCA}, {LCA, after}});
        }
        else {
            ans.push_back({{LCA, v}, {after, LCA}});
        }
        /*for (auto i: ans) {
            cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << '\n';
        }*/
        contain_ans(0);
        cout << "Yes\n";
        for (auto i: ans) {
            cout << i.first.first + 1 << ' ' << i.first.second + 1 << ' ' << i.second.first + 1 << ' ' << i.second.second + 1 << '\n';
        }
    }
    return 0;
}
