#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#define ll long long
#define u unsigned
#define frr(x,y) for(int y=0;y<int(x);y++)
#define fr(x) frr(x,i)
#define frin fr(n)

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <queue>
#include <vector>
#include <cassert>
#include <string>
#include <bitset>

using namespace std;

struct egg {
	int v, f, r;
	bool frt;
	egg(int a = 0, int b = 0, int c = 0,int d=0)
	{
		v = a, f = b, r = c,frt=d;
	}
};

ll n, m, k, t, x, y, z, a, b, c, d, l, r;
vector<ll>f, p, dp;

vector<pair<int, int>>edge;
vector<vector<int>>g;
vector<vector<egg>>dg;
vector<vector<int>>to;


bitset<300000>dola;
bitset<300000>used;

void mrb(int fr, int to)
{
	dg[fr].push_back(egg(to, 1, dg[to].size(),1));
	dg[to].push_back(egg(fr, 0, dg[fr].size() - 1,0));
}


void dfs(int v)
{
	used[v] = 1;
	for (auto& x : g[edge[v].second])
	{
		if (!used[x])
		{
			dola[x] = !dola[v];
			dfs(x);
		}
	}
	for (auto& x : to[edge[v].first])
	{
		if (!used[x])
		{
			dola[x] = !dola[v];
			dfs(x);
		}
	}
}

bool bfs()
{
	dp.assign(m + 2, 0);
	queue<int>q;
	q.push(0);
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (auto& x : dg[v])
		{
			if (x.v && !dp[x.v] && x.f)
			{
				dp[x.v] = dp[v] + 1;
				if (x.v == m + 1)
					return 1;
				q.push(x.v);
			}
		}
	}
	return 0;
}

bool dinitz(int v)
{
	if (v == m + 1)
		return 1;
	//used[v] = 1;
	for(auto& x:dg[v])
	{
		if (!used[x.v] && x.f && dp[v] + 1 == dp[x.v])
		{
			//used[x.v] = 1;
			if (dinitz(x.v))
			{
				x.f = 0;
				dg[x.v][x.r].f = 1;
				return 1;
			}
		}
	}
	return 0;
}

bool kuhn(int v)
{
	if (used[v])
		return 0;
	used[v] = 1;
	for (auto& x : g[edge[v].second])
	{
		assert(dola[x] != dola[v]);
		if (p[x] == -1 || kuhn(p[x]))
		{
			p[x] = v;
			return 1;
		}
	}
	for (auto& x : to[edge[v].first])
	{
		assert(dola[x] != dola[v]);
		if (p[x] == -1 || kuhn(p[x]))
		{
			p[x] = v;
			return 1;
		}
	}
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	cin >> n >> m;
	g.resize(n);
	to.resize(n);
	p.resize(m);
	fr(m)
	{
		cin >> a >> b;
		a--, b--;
		edge.push_back({ a,b });
		g[a].push_back(i);
		to[b].push_back(i);
	}
	fr(m)
		if(!used[i])
			dfs(i);
	used = 0;
	p.assign(m, -1);
	fr(m)
		l += dola[i];
	if (l * 2 != m)
	{
		cout << "No";
		return 0;
	}
	dg.resize(m + 2);
	fr(m)
	{
		if (!dola[i])
		{
			mrb(0, i + 1);
			for (auto& x : g[edge[i].second])
			{
				mrb(i + 1, x + 1);
			}
			for (auto& x : to[edge[i].first])
			{
				mrb(i + 1, x + 1);
			}
		}
		else
		{
			mrb(i + 1, m + 1);
		}
	}
	c = 0;
	while (bfs())
	{
		//used = 0;
		while(dinitz(0))
		c++;
	}
	if (c != m / 2)
	{
		cout << "No";
		return 0;
	}
	fr(m + 1)
	{
		if(i)
		if (!dola[i-1])
		{
			for (auto& x : dg[i])
			{
				if (x.frt && !x.f)
				{
					p[x.v-1] = i-1;
				}
			}
		}
	}
	cout << "Yes\n";
	fr(m)
	{
		if (dola[i])
		{
			if (edge[p[i]].second == edge[i].first)
				cout << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << " " << edge[i].first + 1 << " " << edge[i].second + 1 << "\n";
			else if (edge[i].second == edge[p[i]].first)
				cout << edge[i].first + 1 << " " << edge[i].second + 1 << " " << edge[p[i]].first + 1 << " " << edge[p[i]].second + 1 << "\n";
			else
				assert(false);
		}
	}

}
