#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <set>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 3e5 + 228;
const int INF = 1e9 + 228;

vector<array<int, 3>> G[N];
int tin[N], timer = 0, mx_up[N];
bool used[N];
bool most[N];

void dfs(int v, int id, int mx_val) {
	used[v] = 1;
	tin[v] = mx_up[v] = timer++;
	for (auto i : G[v]) {
		if (i[1] > mx_val)
			continue;
		if (used[i[0]]) {
			if (id != i[2])
				mx_up[v] = min(mx_up[v], tin[i[0]]);
		} else {
			dfs(i[0], i[2], mx_val);
			if (mx_up[i[0]] > tin[v])
				most[i[2]] = 1;
			mx_up[v] = min(mx_up[v], mx_up[i[0]]);
		}
	}
}

int who[N];
int val[N];

void dfs_cond(int v, int mx_val) {
	used[v] = 1, who[v] = timer;
	// cout << v << ' ' << timer << '\n';
	for (auto i : G[v]) {
		if (i[1] > mx_val)
			continue;
		if (!most[i[2]] && !used[i[0]]) {
			// cout << v + 1 << ' ' << i[0] + 1 << ' ' << i[2] << '\n';
			dfs_cond(i[0], mx_val);
		}
	}
}

vector<pair<int, int>> _G[N];

void dfs_solve(int v, int p) {
	used[v] = 1;
	for (auto i : _G[v]) {
		if (i.first == p)
			continue;
		val[i.first] = min(val[i.first], min(val[v], i.second));
		dfs_solve(i.first, v);
	}
}

int ans[N];

void solve(int n, int m, int mx_val) {
	fill(most, most + m, 0);
	fill(used, used + n, 0);

	timer = 0;
	for (int i = 0; i < n; ++i) {
		_G[i].clear();
	}
	dfs(0, -1, mx_val);

	fill(used, used + n, 0);
	timer = -1;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			timer++;
			dfs_cond(i, mx_val);
		}
	}
	fill(val, val + n, INF);
	for (int i = 0; i < n; ++i) {
		for (auto j : G[i]) {
			if (j[1] > mx_val)
				continue;
			if (most[j[2]]) {
				_G[who[i]].emplace_back(who[j[0]], j[1]);
			} else {
				val[who[i]] = min(val[who[i]], j[1]);
			}
		}
	}
	fill(used, used + n, 0);
	dfs_solve(0, 0);
	for (int i = 0; i < n; ++i) {
		if (used[who[i]]) {
			ans[i] = min(ans[i], val[who[i]] + mx_val);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int> z;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		z.emplace_back(t);
		G[a - 1].push_back({b - 1, t, i});
		G[b - 1].push_back({a - 1, t, i});
	}
	fill(ans, ans + n, 2 * INF);
	for (int i : z)
		solve(n, m, i);

	for (int i = 1; i < n; ++i)
		cout << ans[i] << '\n';
}