#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <unordered_map>

using namespace std;
int MAX = 2000000000;

struct edge {
	int other;
	int t;
	edge() {
		other = 0;
		t = 0;
	}
	edge(int other, int t) {
		this->t = t;
		this->other = other;
	}
};

vector<vector<edge>> graph;
vector<int> answers;

void get_ans(int v, int pred, int t1, int t2, int& Max, int& Min) {
	if (v < t1) {
		for (auto& other : graph[v]) {
			if (other.other == pred) continue;
			Max = max(Max, other.t);
			Min = min(Min, other.t);
			get_ans(other.other, v, t1, t2, Max, Min);
			return;
		}
	}
	else if (v >= t2) return;
	else {
		int t1 = MAX, t2 = MAX;
		int next = pred;
		for (auto& other : graph[v]) {
			if (other.other == pred) continue;
			if (t1 == MAX) t1 = other.t;
			else if (t2 == MAX) {
				t2 = other.t;
				break;
			}
			next = other.other;
		}
		Min = min(Min, t1);
		Max = max(Max, t2);
		get_ans(next, v, t1, t2, Max, Min);
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	graph = vector<vector<edge>>(n);
	for (int i = 0; i < m; i++) {
		int a, b, t;
		cin >> a >> b >> t;
		a--;
		b--;
		graph[a].push_back(edge(b, t));
		graph[b].push_back(edge(a, t));
	}
	for (int i = 0; i < n; i++) {
		sort(graph[i].begin(), graph[i].end(), [](edge& a, edge& b) {
			return a.t < b.t;
			});
	}
	
	answers = vector<int>(n, MAX);
	for (int i = 1; i < n; i++) {
		for (int stop_at = i; stop_at < n; stop_at++) {
			int Min = MAX, Max = 0;
			get_ans(0, -1, i, stop_at, Max, Min);
			answers[i] = min(answers[i], Min + Max);
		}
	}
	for (int i = 1; i < n; i++) cout << answers[i] << endl;
}