#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs(int v, int mn, int mx, int p = -1) {
    ans[v] = mn + mx;
    for (auto pp : g[v]) {
        if (pp.first != p) {
            dfs(pp.first, min(mn, pp.second), max(mx, pp.second), v);
        }
    }
}

const int MAXN = 300000 + 228;
int pa[MAXN];
int ra[MAXN];

void init() {
    iota(pa, pa + MAXN, 0);
    fill(ra, ra + MAXN, 0);
}

int get(int a) {
    if (pa[a] == a)
        return a;
    return pa[a] = get(pa[a]);
}

void merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b)
        return;
    if (ra[b] > ra[a])
        swap(a, b);
    pa[b] = a;
    if (ra[a] == ra[b])
        ra[a]++;
}

signed main() {
    init();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    vector<vector<int>> edges;
    int mn0 = 1e9, mx0 = 0;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >>  b >> c;
        a--;
        b--;
        edges.push_back({c, a, b});
        if (a == 0 || b == 0) {
            mn0 = min(mn0, c);
            mx0 = max(mx0, c);
        }
    }
    ans.resize(n);
    if (mx0 == 0 || m == n - 1) {
        sort(edges.begin(), edges.end());
        for (auto e : edges) {
            if (get(e[1]) != get(e[2])) {
                merge(e[1], e[2]);
                int a = e[1];
                int b = e[2];
                int c = e[0];
                g[b].push_back({a, c});
                g[a].push_back({b, c});
            }
        }
        dfs(0, 1e9, 0);
    } else if (mn0 == 1000000000) {
        sort(edges.rbegin(), edges.rend());
        for (auto e : edges) {
            if (get(e[1]) != get(e[2])) {
                merge(e[1], e[2]);
                int a = e[1];
                int b = e[2];
                int c = e[0];
                g[b].push_back({a, c});
                g[a].push_back({b, c});
            }
        }
        ans.resize(n);
        dfs(0, 1e9, 0);
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
}
