#include <iostream>
#include <vector>
#include <unordered_set>

#pragma GCC target("avx,avx2,sse,sse2,sse4.2")

using namespace std;

const int MAX_N = 10228;

int used[MAX_N];
int nextLink[MAX_N];
int prevLink[MAX_N];

struct Tree {
    explicit Tree() {
    }
    int x, h;
    Tree(int x_, int h_) : x(x_), h(h_) {

    }
};

Tree trees[MAX_N];

int timer = 1;

inline int answer(int l, int r) __attribute__((optimize("O3,unroll-loops")));
inline int answer(int l, int r) {
    int n = r - l + 1;
    timer++;
    used[0] = used[r - l] = timer;
    vector<int> extractable;
    for (int i = 0; i < n; ++i) {
        nextLink[i] = i + 1;
    }
    for (int i = 0; i < n; ++i) {
        prevLink[i] = i - 1;
    }
    for (int i = l + 1; i < r - 1; ++i) {
        if (trees[i].x + trees[i].h <= trees[nextLink[i - l] + l].x ||
            trees[i].x - trees[i].h >= trees[prevLink[i - l] + l].x) {
            used[i - l] = timer;
            extractable.push_back(i);
        }
    }
    int ans = 0;
    while (!extractable.empty()) {
        //Extract

        int i = extractable.back();
        extractable.pop_back();
        ans += 1;
        //used[i - l] = timer;

        // Determine trees to update
        int prv = prevLink[i - l];
        int nxt = nextLink[i - l];

        // Update links
        nextLink[prv] = nxt;
        prevLink[nxt] = prv;

        //Do stuff

        if (used[prv] != timer) {
            if (trees[prv + l].x + trees[prv + l].h <= trees[nxt + l].x) {
                extractable.push_back(prv + l);
                used[prv] = timer;
            }
        }
        if (used[nxt] != timer) {
            if (trees[nxt + l].x - trees[nxt + l].h >= trees[prv + l].x) {
                extractable.push_back(nxt + l);
                used[nxt] = timer;
            }
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q; cin >> n >> q;
    int x1, h1; cin >> x1 >> h1;
    trees[0] = Tree(x1, h1);
    trees[1] = Tree(x1, h1);
    for (int i = 1; i < n; ++i) {
        int x, h; cin >> x >> h;
        trees[i + 1] = Tree(x, h);
    }
    trees[n + 1] = trees[n];
    for (int i = 0; i < q; ++i) {
        int l, r; cin >> l >> r;
        //vector<Tree> query;
        //for (int i = l - 1; i <= r + 1; i++) {
           // query.emplace_back(trees[i]);
        //}
        cout << answer(l - 1, r + 1) << '\n';
    }
}
