#include <iostream>
#include <vector>

using namespace std;

struct Edge {
    int from, to, weight;
    Edge(int f, int t, int w): from(f), to(t), weight(w) {

    }
};

const int INF = 1e9 + 7;

const int MAX_N = 3e5 + 228;

int ans[MAX_N];

void dfs(vector<vector<Edge>> &graph, int v = 0, int p = -1, int mi = INF, int mx = -INF) {
    ans[v] = mi + mx;
    for (const Edge &e : graph[v]) {
        int u = e.to;
        int w = e.weight;
        if (u != p) {
            dfs(graph, u, v, min(mi, w), max(mx, w));
        }
    }
}

int main() {
    int n, m; cin >> n >> m;
    vector<vector<Edge>> graph(n);
    for (int i = 0; i < m; i++) {
        int f, t, w; cin >> f >> t >> w;
        f--; t--;
        graph[f].emplace_back(f, t, w);
        graph[t].emplace_back(t, f, w);
    }
    dfs(graph);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << endl;
    }
}
