#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 1329;
const int maxn = 3e5 + 1329;

struct edge {
    int from, to;
    int t;
    edge() {}
    edge(int from, int to, int t): from(from), to(to), t(t) {}
    bool operator< (const edge& other) const {
        return t < other.t;
    }
};

vector<vector<edge>> g (maxn);

int d [maxn];
edge pred [maxn];

bool bfs(int s, int f, int l, int r) {
    fill(d, d + maxn, inf);
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (edge e : g[u]) {
            if (e.t < l || r < e.t) continue;
            if (d[e.to] > d[e.from] + 1) {
                d[e.to] = d[e.from] + 1;
                pred[e.to] = e;
                q.push(e.to);
            }
        }
    }
    return d[f] < inf;
}

signed main() {
    int n, m; cin >> n >> m;
    if (n <= 10) {
        vector<edge> alle;
        for (int i = 0; i < m; ++i) {
            int u, v, tuv; cin >> u >> v >> tuv;
            alle.emplace_back(u, v, tuv);
        }
        vector<int> ans (n + 1, inf);
        vector<int> ord (m);
        for (int i = 0; i < m; ++i) ord[i] = i;
        do {
            int last = 1;
            int mi = 1e9, ma = 0;
            for (int i = 0; i < m; ++i) {
                if (alle[ord[i]].from == last) {
                    mi = min(mi, alle[ord[i]].t);
                    ma = max(ma, alle[ord[i]].t);
                    ans[alle[ord[i]].to] = min(ans[alle[ord[i]].to], mi + ma);
                    last = alle[ord[i]].to;
                } else if (alle[ord[i]].to == last) {
                    mi = min(mi, alle[ord[i]].t);
                    ma = max(ma, alle[ord[i]].t);
                    ans[alle[ord[i]].from] = min(ans[alle[ord[i]].from], mi + ma);
                    last = alle[ord[i]].from;
                } else {
                    break;
                }
            }
        } while (next_permutation(ord.begin(), ord.end()));
        for (int i = 2; i <= n; ++i) {
            cout << ans[i] << '\n';
        }
        return 0;
    }
    for (int i = 0; i < m; ++i) {
        int u, v, t; cin >> u >> v >> t;
        g[u].emplace_back(u, v, t);
        g[v].emplace_back(v, u, t);
    }
    if (m == n - 1) {
        bfs(1, n, 0, inf);
        set<pair<int, int>> q;
        for (int i = 1; i <= n; ++i) {
            q.emplace(d[i], i);
        }
        vector<int> mi (n + 1, inf);
        vector<int> ma (n + 1, 0);
        while (!q.empty()) {
            int u = (*q.begin()).second;
            q.erase(q.begin());
            if (u == 1) continue;
            mi[u] = min(mi[pred[u].from], pred[u].t);
            ma[u] = max(ma[pred[u].from], pred[u].t);
        }
        for (int i = 2; i <= n; ++i) {
            cout << mi[i] + ma[i] << '\n';
        }
        return 0;
    }
}