#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:2000000000")
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <set>
#include <numeric>

using namespace std;

const int INF = 1000000009;
const long long INFL = 1000000000000000009ll;
const int SIZE = 300010;

vector <pair <int, int> > g[SIZE];
int ans[SIZE];
bool used[SIZE];

void DFS(int v, int parent, int mi, int ma)
{
	ans[v] = mi + ma;
	for (pair <int, int> to : g[v])
	{
		if (to.first != parent)
		{
			DFS(to.first, v, min(mi, to.second), max(ma, to.second));
		}
	}
}

signed main()
{
	for (int i = 0; i < SIZE; ++i)
	{
		ans[i] = INF;
	}

	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		g[u].push_back({ v, t });
		g[v].push_back({ u, t });
	}

	if (m == n - 1)
	{
		DFS(0, -1, INF, -INF);
		for (int i = 1; i < n; ++i)
		{
			cout << ans[i] << '\n';
		}
		return 0;
	}

	int er = g[0][0].second;
	set <pair <int, int> > s;
	if (er != 0)
	{
		s.insert({ INF, 0 });
	}
	else
	{
		s.insert({ 0, 0 });
	}
	while (s.size())
	{
		int ind = (*s.begin()).second;
		int an = (*s.begin()).first;
		s.erase(s.begin());
		used[ind] = true;
		for (pair <int, int> to : g[ind])
		{
			if (!used[to.first])
			{
				s.erase({ ans[to.first], to.first });
				if (er == 0)
				{
					ans[to.first] = min(ans[to.first], max(an, to.second));
				}
				else
				{
					ans[to.first] = min(ans[to.first], min(an, to.second));
				}
				s.insert({ ans[to.first], to.first });
			}
		}
	}

	for (int i = 1; i < n; ++i)
	{
		cout << ans[i] + er << '\n';
	}

	return 0;
}