#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int v, u, t, i;

    bool operator<(const Edge &o) const {
        return t < o.t;
    }
};

int n, m;

vector<vector<Edge>> graph;
vector<int> ans;
const int MAXN = 3e5 + 100;
bitset<MAXN> used;
vector<Edge> edges;

void dfsTree(int v, int p, vector<int> &mxx, vector<int> &mnn, int mx, int mn) {
    mxx[v] = mx;
    mnn[v] = mn;
    for (auto &e : graph[v]) {
        if (e.u == p)
            continue;
        dfsTree(e.u, v, mxx, mnn, max(mx, e.t), min(mn, e.t));
    }
}

void solve1() {
    vector<int> mxx(n), mnn(n);
    dfsTree(0, -1, mxx, mnn, 0, 1e9);
    for (int i = 1; i < n; ++i) {
        cout << mxx[i] + mnn[i] << '\n';
    }
}

void solve2() {
    vector<int> dist(n, 1e9);
    dist[0] = 0;
    set<pair<int, int>> Q;
    Q.emplace(0, 0);
    while (!Q.empty()) {
        auto[d, v] = *Q.begin();
        Q.erase(Q.begin());
        for (auto &e : graph[v]) {
            int nd = max(d, e.t);
            if (dist[e.u] <= nd)
                continue;
            Q.erase(make_pair(dist[e.u], e.u));
            Q.emplace(nd, e.u);
            dist[e.u] = nd;
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << dist[i] << '\n';
    }
}

int upp[MAXN];
int heigh[MAXN];
bitset<MAXN> isbri;

void dfsbri(int v, int h, int epv) {
    used[v] = true;
    heigh[v] = h;
    int up = h;
    for (auto &e : graph[v]) {
        if (used[e.u]) {
            if (e.i != epv)
                up = min(up, heigh[e.u]);
            continue;
        }
        dfsbri(e.u, h + 1, e.i);
        up = min(up, upp[e.u]);
    }
    if (up == h && epv != -1) {
        isbri[epv] = true;
        up = h - 1;
    }
    upp[v] = up;
}

int colors[MAXN];

void dfspaint(int v, int col) {
    colors[v] = col;
    for (auto &e : graph[v]) {
        if (isbri[e.i])
            continue;
        if (colors[e.u] != 0)
            continue;
        dfspaint(e.u, col);
    }
}

vector<vector<Edge>> ngraph;
vector<int> minincol;


void dfsTreeCol(int v, int p, vector<int> &mxx, vector<int> &mnn, int mx, int mn) {
    mn = min(mn, minincol[v]);
    mxx[v] = mx;
    mnn[v] = mn;
    for (auto &e : ngraph[v]) {
        if (e.u == p)
            continue;
        dfsTreeCol(e.u, v, mxx, mnn, max(mx, e.t), min(mn, e.t));
    }
}

void solve3() {
    dfsbri(0, 0, -1);
    int mxcol = 0;
    for (int v = 0; v < n; ++v) {
        if (colors[v] == 0)
            dfspaint(v, ++mxcol);
    }
    int nn = mxcol + 1;
    ngraph.resize(nn);
    minincol.resize(nn, 1e9);
    for (int i = 0; i < m; ++i) {
        int v = edges[i].v;
        int u = edges[i].u;
        if (colors[v] == colors[u]) {
            minincol[colors[v]] = min(minincol[colors[v]], edges[i].t);
        } else {
            ngraph[colors[v]].push_back({colors[v], colors[u], edges[i].t, -1});
            ngraph[colors[u]].push_back({colors[u], colors[v], edges[i].t, -1});
        }
    }
    vector<int> mxx(nn, 0), mnn(nn, 1e9);
    dfsTreeCol(colors[0], -1, mxx, mnn, 0, 1e9);
    for (int i = 1; i < n; ++i) {
        int mx = 1e9;
        int mn = mnn[colors[i]];
        cout << mn + mx << '\n';
    }
}

bool bit(int mask, int i) {
    return (mask >> i) & 1;
}

int getpow(int mask, int v) {
    int r = 0;
    for (auto &e : graph[v]) {
        if (bit(mask, e.i))
            r++;
    }
    return r;
}

void solve45() {
    int fmask = 1 << m;
    for (int mask = 0; mask < fmask; ++mask) {
        if (getpow(mask, 0) % 2 == 0)
            continue;
        bool ok = true;
        int ne = -1;
        for (int i = 1; i < n; ++i) {
            if (getpow(mask, i) % 2 == 0)
                continue;
            if (ne == -1) {
                ne = i;
                continue;
            }
            ok = false;
            break;
        }
        ok &= ne != -1;
        if (!ok)
            continue;
        int mn = 1e9, mx = 0;
        for (int i = 0; i < m; ++i) {
            if (bit(mask, i)) {
                mx = max(mx, edges[i].t);
                mn = min(mn, edges[i].t);
            }
        }
        ans[ne] = min(ans[ne], mn + mx);
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}

void solve6() {
    vector<pair<int, int>> kek(n - 1, {-1, -1});
    for (int i = 0; i < n; ++i) {
        for (auto &e : graph[i]) {
            if (e.u < i)
                continue;
            if (kek[i].first == -1 || e.t < kek[i].first) {
                kek[i].second = kek[i].first;
                kek[i].first = e.t;
            } else if (kek[i].second == -1 || e.t < kek[i].second) {
                kek[i].second = e.t;
            }
        }
    }
    int mn = 1e9;
    int mx = 0;
    for (int i = 1; i < n; ++i) {
        mn = min(mn, kek[i - 1].first);
        mx = max(mx, kek[i - 1].first);
        int mn1 = mn, mx1 = mx;
        int res = mn + mx;
        for (int j = i + 1; j < n; ++j) {
            if (kek[j - 1].second == -1)
                break;
            mn1 = min(mn1, kek[j - 1].first);
            mx1 = max(mx1, kek[j - 1].second);
            res = min(res, mn1 + mx1);
        }
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    ans.resize(n, 2e9);
    graph.resize(n);
    edges.resize(m);
    bool is6 = true;
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        graph[v].push_back({v, u, w, i});
        graph[u].push_back({u, v, w, i});
        edges[i] = {v, u, w, i};
        is6 &= abs(v - u) == 1;
    }
//    if (is6) {
//        solve6();
//        return 0;
//    }
//    if (m == n - 1) {
//        solve1();
//        return 0;
//    }
//    int mx1 = max_element(graph[0].begin(), graph[0].end())->t;
//    int mn1 = min_element(graph[0].begin(), graph[0].end())->t;
//    if (mx1 == 0) {
//        solve2();
//        return 0;
//    }
//    if (mn1 == 1e9) {
//        solve3();
//        return 0;
//    }
    if (n <= 20) {
        solve45();
        return 0;
    }
}