#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <deque>
#include <cassert>
#include <set>
#include <functional>
#include <queue>
#include <unordered_set>

using namespace std;

#pragma GCC optimize("O2")
#pragma GCC target("avx,avx2")
#pragma GCC optimize("unroll-loops")

 int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> x(n);
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int left = x[0];
        int right = x.back();
        if (l != 0) {
            left = x[l - 1];
        }
        if (r != n - 1) {
            right = x[r + 1];
        }
        queue<int> q;
        vector<int> nextt(n, -1);
        vector<int> prevv(n, -1);
        for (int i = l; i + 1 <= r; ++i) {
            nextt[i] = i + 1;
        }
        for (int i = l + 1; i <= r; ++i) {
            prevv[i] = i - 1;
        }
        vector<bool> used(n, false);
        for (int i = l; i < r; ++i) {
            if (!used[i] && x[i] + h[i] <= x[i + 1]) {
                used[i] = true;
                q.push(i);
            }
        }
        if (!used[l] && x[l] - h[l] >= left) {
            used[l] = true;
            q.push(l);
        }
        if (!used[r] && x[r] + h[r] <= right) {
            used[r] = true;
            q.push(r);
        }
        for (int i = l + 1; i <= r; ++i) {
            if (!used[i] && x[i] - h[i] >= x[i - 1]) {
                q.push(i);
                used[i] = true;
            }
        }
        int ans = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            ++ans;
            int pr = left;
            int prev = -1;
            int next = -1;
            int nx = right;
            if (nextt[v] != -1) {
                next = nextt[v];
                nx = x[next];
            }
            if (prevv[v] != -1) {
                prev = prevv[v];
                pr = x[prev];
            }
            if (next != -1) {
                prevv[next] = prev;
            }
            if (prev != -1) {
                nextt[prev] = next;
            }
            if (next != -1 && !used[next] && x[next] - h[next] >= pr) {
                used[next] = true;
                q.push(next);
            }
            if (prev != -1 && !used[prev] && x[prev] + h[prev] <= nx) {
                used[prev] = true;
                q.push(prev);
            }
        }
        cout << ans << '\n';
    }
}
/*
 5 6
 1 2
 2 1
 1 5
 2 3
 2 4
 4 2


 4 4
 2 1
 2 3
 2 4
 4 2


 4 4
 1 2
 2 1
 3 4
 4 3
 */