#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,inline,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,popcnt,abm")
#endif
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1.5e5;
const int MAXM = 3e5;

mt19937 rnd(241345135114);
vector<pair<int, int>> edges;
vector<int> graph[MAXM];
vector<int> in[MAXN];
int res[MAXM];
int color[MAXM];
int used[MAXM];

void dfs1(int v, int c) {
  color[v] = c;
  for (auto u : graph[v]) {
    if (color[u] == 3 - c)
      continue;
    dfs1(u, 3 - c);
  }
}

bool khun(int v, int c) {
  if (used[v] == c)
    return false;
  used[v] = c;
  for (auto u : graph[v]) {
    if (res[u] == -1) {
      res[u] = v;
      return true;
    }
  }
  for (auto u : graph[v]) {
    if (khun(res[u], c)) {
      res[u] = v;
      return true;
    }
  }
  return false;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int v, u;
    cin >> v >> u;
    v--;
    u--;
    edges.emplace_back(v, u);
    in[u].push_back(i);
  }
  for (int i = 0; i < n; i++) {
    shuffle(in[i].begin(), in[i].end(), rnd);
  }
  for (int i = 0; i < m; i++) {
    for (int j = 0; j < min(in[edges[i].first].size(), 4'000UL); j++) {
      graph[i].push_back(in[edges[i].first][j]);
      graph[in[edges[i].first][j]].push_back(i);
    }
  }
  // check biparity
  for (int i = 0; i < m; i++) {
    if (color[i])
      continue;
    dfs1(i, 1);
  }

  fill(res, res + MAXM, -1);
  int c = 1;
  for (int i = 0; i < m; i++) {
    if (color[i] != 1) {
      continue;
    }
    if (khun(i, c))
      c++;
  }
  int cnt = 0;
  for (int i = 0; i < m; i++) {
    if (color[i] == 1)
      continue;
    if (res[i] != -1)
      cnt++;
  }
  if (cnt != m / 2) {
    cout << "No";
    return 0;
  }
  cout << "Yes\n";
  for (int i = 0; i < m; i++) {
    if (color[i] == 1)
      continue;
    cout << edges[i].first + 1 << ' ' << edges[i].second + 1 << ' ' << edges[res[i]].first + 1 << ' '
         << edges[res[i]].second + 1 << '\n';
  }
  return 0;
}