#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int ALPHA = 27;
const int INF = 2e18 + 228;

string s;
int n;

int dp[N][ALPHA];
int cost[26];
pair<int, int> take[N][ALPHA];

void solve() {
	cin >> s;

	n = (int)s.size();

	s = " " + s;

	for (int i = 0; i <= n + 1; ++i) {
		for (int c = 0; c < ALPHA; ++c) {
			dp[i][c] = -INF;
			take[i][c] = {0, 0};
		}
	}

	dp[n + 1][0] = 0;

	for (int i = n + 1; i > 1; --i) {
		for (int mx = 0; mx < 26; ++mx) {
			if (dp[i][mx] > -INF) {
				for (int c = 0; c < 26; ++c) {
					if (s[i - 1] != '?' && s[i - 1] != char('A' + c)) continue;
					int cur = -INF;
					if (c >= mx) {
						cur = dp[i][mx] + cost[c];
					} else {
						cur = dp[i][mx] - cost[c];
					}
					int new_mx = max(mx, c);

					if (cur > dp[i - 1][new_mx]) {
						dp[i - 1][new_mx] = cur;
						take[i - 1][new_mx] = {c, mx};
					}
				}
			}
		}
	}


	int opt_c = 0;
	for (int c = 0; c < 26; ++c) {
		if (dp[1][c] > dp[1][opt_c]) {
			opt_c = c;
		}
	}

	string ans = "";
	int val = dp[1][opt_c];
	int i = 1;
	int mx = opt_c;
	while (i <= n) {
		ans += char('A' + take[i][mx].first);
		mx = take[i][mx].second;
		++i;
	}
	cout << val << '\n';
	cout << ans << '\n';
}

void pre() {
	cost[0] = 1;
	for (int i = 1; i < 26; ++i) {
		if (i % 2 == 1) {
			cost[i] = cost[i - 1] * 5LL;
		} else {
			cost[i] = cost[i - 1] * 2LL;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int T;
	cin >> T;
	pre();
	while(T--) {
		solve();
	}
	return 0;
}