#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;

struct edge {
    int to, id, t;
    edge() {}
    edge(int to, int id, int t) : to(to), id(id), t(t) {}
};

vector<vector<edge>> g;

void dfs_tree(int v, int p, vector<int> &ans, int mx, int mn) {
    if (v != 0) ans[v] = mx + mn;
    for (auto &e : g[v]) {
        if (e.to == p) continue;
        dfs_tree(e.to, v, ans, max(mx, e.t), min(mn, e.t));
    }
}

vector<int> usd;

void dfs(int v, vector<int> &a, int mask) {
    usd[v] = 1;
    a.pb(v);
    for (auto &e : g[v]) {
        if ((mask & (1 << e.id)) && !usd[e.to]) dfs(e.to, a, mask);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    bool gr2 = 1;
    vector<int> val(m);
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        val[i] = t;
        a--; b--;
        g[a].pb(b, i, t);
        g[b].pb(a, i, t);
        if (a == 0 || b == 0) {
            if (t != 0) gr2 = 0;
        }
    }
    if (m == n - 1) {
        vector<int> ans(n);
        dfs_tree(0, -1, ans, 0, INF);
        for (int i = 1; i < n; i++) cout << ans[i] << "\n";
        return 0;
    }
    if (gr2) {
        vector<int> dist(n, INF);
        dist[0] = 0;
        set<pii> s;
        s.insert({0, 0});
        while (s.size()) {
            int v = s.begin()->se;
            s.erase(s.begin());
            for (auto &e : g[v]) {
                if (dist[e.to] > max(dist[v], e.t)) {
                    s.erase({dist[e.to], e.to});
                    dist[e.to] = max(dist[v], e.t);
                    s.insert({dist[e.to], e.to});
                }
            }
        }
        for (int i = 1; i < n; i++) cout << dist[i] << "\n";
        return 0;
    }
    vector<int> ans(n, 2 * INF);
    for (int mask = 0; mask < (1 << m); mask++) {
        //cout << '!' << " " << mask << endl;
        vector<int> deg(n);
        for (int v = 0; v < n; v++) {
            for (auto &e : g[v]) {
                if (mask & (1 << e.id)) deg[v]++;
            }
        }
        if (deg[0] % 2 == 0) continue;
        vector<int> a;
        for (int v = 1; v < n; v++) {
            if (deg[v] % 2 == 1) a.pb(v);
        }
        if ((int)a.size() != 1) continue;
        int k = a[0];
        int cnt = 0;
        usd.assign(n, 0);
        //cout << '!' << endl;
        for (int v = 0; v < n; v++) {
            if (!usd[v]) {
                vector<int> now;
                dfs(v, now, mask);
                cnt += (int)now.size() >= 2;
            }
        }
        if (cnt != 1) continue;
        int mn = INF, mx = 0;
        for (int i = 0; i < m; i++) {
            if (mask & (1 << i)) {
                mn = min(mn, val[i]);
                mx = max(mx, val[i]);
            }
        }
        ans[k] = min(ans[k], mn + mx);
    }
    for (int i = 1; i < n; i++) cout << ans[i] << "\n";
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
*/
