#include <iostream>
#include <vector>
#include <sstream>
#include <set>
#include <map>
#include <assert.h>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long LL;
typedef unsigned long long ULL;

int getNextNotCut(vector<int>& neighbours, int id) {
	if (id == neighbours.size() || id == -1) {
		return id;
	}
	if (neighbours[id] == id) {
		return id;
	}

	int answer = getNextNotCut(neighbours, neighbours[id]);
	neighbours[id] = answer;
	return answer;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, q;
	cin >> n >> q;

	vector<pair<int, int>> trees(n);

	vector<bool> canFall(n);

	for (int i = 0; i < n; i++)
	{
		int x, h;
		cin >> x >> h;

		if (i > 0) {
			if (x - h >= trees[i - 1].first) {
				canFall[i] = true;
			}
			if (trees[i - 1].first + trees[i - 1].second <= x) {
				canFall[i - 1] = true;
			}
		}

		trees[i] = { x, h };
	}

	for (int i = 0; i < q; i++)
	{
		int l, r;
		cin >> l >> r;
		l--;

		vector<bool> isCut(r - l, false);
		vector<bool> isInQueue(r - l, false);
		vector<int> cutQueue;

		vector<int> rightNotCut(r-l), leftNotCut(r-l);


		int cutCnt = 0;
		for (int j = l; j < r; j++)
		{
			rightNotCut[j - l] = j - l;
			leftNotCut[j - l] = j - l;
			if (canFall[j]) {
				cutQueue.push_back(j);
				isInQueue[j - l] = true;
			}
		}

		while (cutQueue.size() > 0) {
			int current = cutQueue.back();
			cutQueue.pop_back();
			isInQueue[current - l] = false;
			cutCnt++;

			isCut[current - l] = true;
			int nextId = current + 1;
			int prevId = current - 1;

			nextId = getNextNotCut(rightNotCut, current + 1 - l);
			prevId = getNextNotCut(leftNotCut, current - 1 - l);

			leftNotCut[current - l] = prevId;
			rightNotCut[current - l] = nextId;

			prevId += l;
			nextId += l;

			if (nextId != r) {
				int minX = prevId == -1 ? trees[0].first : trees[prevId].first;

				if (trees[nextId].first - trees[nextId].second >= minX) {
					if (!isInQueue[nextId - l]) {
						cutQueue.push_back(nextId);
						isInQueue[nextId - l] = true;
					}
				}
			}
			if (prevId != l - 1) {
				int maxX = nextId == n ? trees.back().first : trees[nextId].first;

				if (trees[prevId].first + trees[prevId].second <= maxX) {
					if (!isInQueue[prevId - l]) {
						cutQueue.push_back(prevId);
						isInQueue[prevId - l] = true;
					}
				}
			}
		}

		cout << cutCnt << endl;
	}


	return 0;
}