#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

int n, m;
vec<vec<int>> g;
vec<char> used;
set<pair<int, int>> edges;
vec<int> pr;
vec<int> dep;
vec<int> in, out;
bool ok = 1;
vec<int> type;
vec<ar<int, 4>> ans;

inline void resize_all() {
	g.resize(n);
	used.resize(n);
	pr.resize(n);
	dep.resize(n);
	in.resize(n);
	out.resize(n);
	type.resize(n);
}

void dfs1(int v, int par) {
	used[v] = 1;
	pr[v] = par;
	if (par != v) {
		g[v].erase(find(all(g[v]), par));
	}
	for (auto u : g[v]) {
		dep[u] = dep[v] + 1;
		dfs1(u, v);
	}
}

void dfs2(int v) {
	used[v] = 1;
	ar<vec<int>, 3> types;
	for (auto u : g[v]) {
		dfs2(u);
		if (!ok) {
			return;
		}
		types[type[u]].push_back(u);
	}
	auto solve = [&]() {
		assert(len(types[1]) == len(types[2]));
		for (int i = 0; i < len(types[1]); i++) {
			ans.push_back({types[2][i], v, v, types[1][i]});
		}
	};
	if (!in[v] && !out[v]) {
		if (len(types[1]) != len(types[2])) {
			ok = 0;
			return;
		}
		type[v] = 0;
		solve();
		return;
	}
	if (in[v] && out[v]) {
		{ // 0-type
			if (len(types[1]) == len(types[2])) {
				type[v] = 0;
				ans.push_back({v, pr[v], pr[v], v});
				solve();
				return;
			}
		}
		{ // 1-type
			if (len(types[2]) == len(types[1]) + 1) {
				type[v] = 1;
				ans.push_back({types[2].back(), v, v, pr[v]});
				types[2].pop_back();
				solve();
				return;
			}
		}
		{ // 2-type
			if (len(types[1]) == len(types[2]) + 1) {
				type[v] = 2;
				ans.push_back({pr[v], v, v, types[1].back()});
				types[1].pop_back();
				solve();
				return;
			}
		}
		ok = 0;
		return;
	}
	if (in[v]) {
		{ // 0-type
			if (len(types[1]) == len(types[2]) + 1) {
				type[v] = 0;
				ans.push_back({pr[v], v, v, types[1].back()});
				types[1].pop_back();
				solve();
				return;
			}
		}
		{ // 1-type
			if (len(types[1]) == len(types[2])) {
				type[v] = 1;
				solve();
				return;
			}
		}
		ok = 0;
		return;
	}
	if (out[v]) {
		{ // 0-type
			if (len(types[2]) == len(types[1]) + 1) {
				type[v] = 0;
				ans.push_back({types[2].back(), v, v, pr[v]});
				types[2].pop_back();
				solve();
				return;
			}
		}
		{ // 2-type
			if (len(types[1]) == len(types[2])) {
				type[v] = 1;
				solve();
				return;
			}
		}
		ok = 0;
		return;
	}
	assert(false);
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	cin >> n >> m;
	resize_all();
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		edges.emplace(v, u);
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (auto &v : g) {
		sort(all(v));
		v.resize(unique(all(v)) - v.begin());
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs1(i, i);
		}
	}
	for (auto [u, v] : edges) {
		if (dep[u] < dep[v]) {
			in[v] = 1;
		} else {
			out[u] = 1;
		}
	}
	fill(all(used), 0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs2(i);
		}
	}
	if (ok && len(ans) == m / 2) {
		cout << "Yes\n";
		for (auto [a, b, c, d] : ans) {
			cout << a + 1 << ' ' << b + 1 << ' ' << c + 1 << ' ' << d + 1 << '\n';
		}
	} else {
		cout << "No\n";
	}
}
