#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 3e5 + 5, inf = 1e9;


int n, m, q;

struct edge {
  int u, v, t;
};

vector<edge> e;
bool brid[N];
vector<int> g[N];

bool used[N];
int tin[N], upmn[N], tmr = 1;

void find_bridges(int v, int pr = -1, int nle = -1) {
  used[v] = true;
  tin[v] = upmn[v] = tmr++;
  for (int ne : g[v]) {
    if (ne == nle)
      continue;
    int to = (v ^ e[ne].u ^ e[ne].v);
    if (used[to])
      upmn[v] = min(upmn[v], tin[to]);
    else {
      find_bridges(to, v, ne);
      if (upmn[to] > tin[v])
        brid[ne] = true;
      upmn[v] = min(upmn[v], upmn[to]);
    }
  }
}

int num_of_comp[N], mx_comp[N], mn_comp[N];

void paint(int v, int col) {
  num_of_comp[v] = col;
  for (int ne : g[v]) {
    if (brid[ne])
      continue;
    int to = (e[ne].v ^ e[ne].u ^ v);
    mx_comp[col] = max(mx_comp[col], e[ne].t);
    mn_comp[col] = min(mn_comp[col], e[ne].t);
    if (num_of_comp[to])
      continue;
    paint(to, col);
  }
}


int res_mn_comps[N], res_mx_comps[N];
vector<pair<int, int>> gc[N];
bool used_comps[N];

void dfs_comps(int v, int vlmn = inf, int vlmx = 0) {
  used_comps[v] = true;
  res_mn_comps[v] = vlmn = min(vlmn, mn_comp[v]);
  res_mx_comps[v] = vlmx = max(vlmx, mx_comp[v]);
  for (auto &u : gc[v])
    if (!used_comps[u.first])
      dfs_comps(u.first, min(vlmn, u.second), max(vlmx, u.second));
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n >> m;
  e.resize(m);
  for (int i = 0; i < m; ++i) {
    int u, v, t;
    cin >> u >> v >> t;
    u--, v--;
    e[i] = {u, v, t};
    g[v].push_back(i);
    g[u].push_back(i);
  }

  find_bridges(0);

  int cnt_comp = 1;
  for (int i = 0; i < n; ++i) {
    if (!num_of_comp[i])
      paint(i, cnt_comp++);
  }

  for (int i = 0; i < n; ++i) {
    for (int ne : g[i]) {
      int to = (e[ne].v ^ e[ne].u ^ i);
      if (num_of_comp[i] != num_of_comp[to]) {
        gc[num_of_comp[i]].emplace_back(num_of_comp[to], e[ne].t);
        gc[num_of_comp[to]].emplace_back(num_of_comp[i], e[ne].t);
      }
    }
  }

  dfs_comps(1);

  for (int i = 1; i < n; ++i) {
    cout << res_mx_comps[num_of_comp[i]] + res_mn_comps[num_of_comp[i]] << '\n';
  }

}
