#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 3e5 + 5, inf = 1e9;


int n, m;

struct edge {
  int u, v, t;
};

vector<edge> e;
vector<int> g[N];


struct dsu {
  int size;
  vector<int> p, col, metka;
  vector<vector<int>> vl;

  dsu(int sz) : size(sz) {
    p.resize(size);
    vl.resize(size);
    col.resize(size, -1);
    metka.resize(size);
    metka[0] = 1;
    iota(p.begin(), p.end(), 0);
    for (int i = 0; i < size; ++i)
      vl[i].push_back(i);
  }

  int gp(int x) {
    if (p[x] == x) return x;
    return p[x] = gp(p[x]);
  }

  void merge(int x, int y, int t) {
    x = gp(x), y = gp(y);
    if (x == y)
      return;
    if (metka[x])
      swap(x, y);
    if (vl[x].size() <= vl[y].size()) {
      for (int a : vl[x]) {
        if (metka[y])
          col[a] = t;
        vl[y].push_back(a);
      }
      p[x] = y;
    } else {
      if (metka[y]) {
        for (int a : vl[x])
          col[a] = t;
      }
      for (int a : vl[y]) {
        vl[x].push_back(a);
      }
      metka[x] = 1;
      p[y] = x;
    }
  }
};

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n >> m;


  e.resize(m);
  for (int i = 0; i < m; ++i) {
    int u, v, t;
    cin >> u >> v >> t;
    u--, v--;
    e[i] = {u, v, t};
  }

  sort(e.begin(), e.end(), [&](edge &a, edge &b) {
    return a.t < b.t;
  });

  dsu D(n);
  for (int i = 0; i < m; ++i) {
    D.merge(e[i].v, e[i].u, e[i].t);
  }
  for (int i = 1; i < n; ++i) {
    assert(D.col[i] != -1);
    cout << D.col[i] << '\n';
  }

}
