from functools import lru_cache


d = {'A': 1, 'B': 5,
     'C': 10, 'D': 50,
     'E': 100, 'F': 500,
     'G': 10 ** 3, 'H': 5 * 10 ** 3,
     'I': 10 ** 4, 'J': 5 * 10 ** 4,
     'K': 10 ** 5, 'L': 5 * 10 ** 5,
     'M': 10 ** 6, 'N': 5 * 10 ** 6,
     'O': 10 ** 7, 'P': 5 * 10 ** 7,
     'Q': 10 ** 8, 'R': 5 * 10 ** 8,
     'S': 10 ** 9, 'T': 5 * 10 ** 9,
     'U': 10 ** 10, 'V': 5 * 10 ** 10,
     'W': 10 ** 11, 'X': 5 * 10 ** 11,
     'Y': 10 ** 12, 'Z': 5 * 10 ** 12}

def score(s, rpl=''):
    res = 0
    mxch = 'A'
    i = 0
    for ch in reversed(s):
        if ch == '?':
            ch = rpl[i]
            i += 1
        if ch < mxch:
            res -= d[ch]
        else:
            mxch = ch
            res += d[ch]
    return res


@lru_cache
def get_all(n):
    if n == 1:
        return [ch for ch in d.keys() if ch >= 'O']
    prev = get_all(n - 1)
    res = []
    for el in prev:
        res.extend([ch + el for ch in d.keys() if ch >= el[0]])
    return res


def solve(s):
    if '?' not in s:
        return [score(s), s]
    vs = get_all(s.count('?'))
    res = ['', -10**30]
    for el in vs:
        sp = s
        for ch in el:
            sp = sp.replace('?', ch, 1)
        scp = score(sp)
        if scp > res[1]:
            res = [sp, scp]
    return res[::-1]

rs = []
for _ in range(int(input())):
    rs.extend(solve(input()))
print(*rs, sep='\n')
