#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef pair <bool, unsigned long long> lnum;

lnum add (lnum a, lnum b);
lnum sub (lnum a, lnum b);

vector <lnum> a(26);

int ord(char c) {
    return (int) c - (int) 'A';
}

lnum read(string s) {
    lnum a;
    if (s[0] == '-') {
        a.first = false;
        s = s.substr(1, s.length()-1);
    } else {
        a.first = true;
    }
    a.second = stoull(s);
    return a;
}

void print(lnum a) {
    if (!a.first && a.second != 0) {
        cout << '-';
    }
    cout << a.second;
}

lnum mos_to_dec(string s) {
    lnum ans = read("0");
    vector <char> st = {};
    for (int i = 0; i < s.length(); i++) {
        while (st.size() && st.back() < s[i]) {
            ans = sub(ans, a[ord(st.back())]);
            st.pop_back();
        }
        st.push_back(s[i]);
    }
    for (int i = 0; i < st.size(); i++) {
        ans = add(ans, a[ord(st[i])]);
    }
    return ans;
}

lnum add(lnum a, lnum b) {
    if (a.first == b.first) {
        return make_pair(a.first, a.second+b.second);
    } else if (!a.first) {
        a.first = !a.first;
        return sub(b, a);
    } else {
        b.first = !b.first;
        return sub(a, b);
    }
}

lnum sub(lnum a, lnum b) {
    if (a.first == b.first) {
        if (a.second < b.second) {
            return make_pair(!a.first, b.second - a.second);
        } else {
            return make_pair(a.first, a.second - b.second);
        }
    } else {
        b.first = !b.first;
        return add(a, b);
    }
}

int main() {
    string q = "1";
    for (int i = 0; i < 26; i++) {
        a[i] = read(q);
        if (q[0] == '1') {
            q[0] = '5';
        } else {
            q[0] = '1';
            q += "0";
        }
    }
    int t;
    cin >> t;
    vector <lnum> ansl(t);
    vector <string> anss(t);
    for (int i = 0; i < t; i++) {
        cin >> anss[i];
        ansl[i] = mos_to_dec(anss[i]);
    }
    for (int i = 0; i < t; i++) {
        print(ansl[i]);
        cout << endl << anss[i] << endl;
    }
    return 0;
}
