#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e18;
const ll MOD = 228228227;

map <char, ll> alphabet;

inline void solve() {
    string str_s;
    cin >> str_s;

    vector <char> s(str_s.begin(), str_s.end());

    int n = s.size();
    deque <pair <ll, int>> maxdq;
    for (int i = 0; i < n; i++) {
        if (s[i] == '?') continue;
        while (!maxdq.empty() && alphabet[s[i]] > maxdq.back().first)
            maxdq.pop_back();

        maxdq.push_back({alphabet[s[i]], i});
    }

    vector <bool> sign(n);

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        if (!maxdq.empty() && maxdq.front().second == i)
            maxdq.pop_front();

        if (s[i] == '?') {
            ll current_change, new_change = -INF, new_ch = '-';
            for (char c = 'A'; c <= 'Z'; c++) {
                current_change = alphabet[c];
                for (int j = 0; j < i; j++) {
                    if (sign[j] && c > s[j]) {
                        current_change -= alphabet[s[j]] * 2;
                    }
                }

                if (current_change > new_change) {
                    new_change = current_change;
                    new_ch = c;
                }
            }

            s[i] = new_ch;
            answer += new_change;
        } else {
            if (!maxdq.empty() && maxdq.front().first > alphabet[s[i]]) {
                answer -= alphabet[s[i]];
            } else {
                answer += alphabet[s[i]];
            }
        }

        if (!maxdq.empty() && maxdq.front().first > alphabet[s[i]]) {
            sign[i] = false;
        } else {
            sign[i] = true;
        }
    }

    cout << answer << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    alphabet['A'] = 1;
    for (char c = 'B'; c <= 'Z'; c++) {
        alphabet[c] = alphabet[(char)(c - 1)] * ((c - 'A') % 2 == 0 ? 2 : 5);
    }

    int t;
    cin >> t;

    while (t--)
    solve();
}
