#pragma  GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

struct Edge {
    int id, dest, w;
    Edge (int id, int dest, int w): id(id), dest(dest), w(w) {}
};

void dfs(vector <vector <Edge>> &graph, vector <bool> &discovered, vector <bool> &fucked_edges, vector <int> &mins, vector <int> &maxs, int v, int pedge) {
    discovered[v] = true;

    for (const auto &edge: graph[v]) {
        if (fucked_edges[edge.id]) continue;
        if (edge.id == pedge) continue;

        mins[edge.dest] = min(mins[v], edge.w);
        maxs[edge.dest] = max(maxs[v], edge.w);

        if (discovered[edge.dest]) continue;
        dfs(graph, discovered, fucked_edges, mins, maxs, edge.dest, edge.id);
        return;
    }
}

inline void solve() {
    int n, m;
    cin >> n >> m;

    int u, v, w;
    vector <vector  <Edge>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> w;
        u--; v--;

        graph[u].emplace_back(i, v, w);
        graph[v].emplace_back(i, u, w);
    }

    auto cmp = [] (const Edge &a, const Edge &b) {
        return a.w < b.w;
    };

    for (int i = 0; i < n; i++) {
        sort(graph[i].begin(), graph[i].end(), cmp);
    }

    vector <bool> discovered, fucked_edges(n);
    vector <int> mins, maxs, answer(n, INF);

    for (int mask = 0; mask < (1 << m); mask++) {
        mins.assign(n, INF * 2);
        maxs.assign(n, -INF);
        discovered.assign(n, false);

        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                fucked_edges[i] = true;
            } else {
                fucked_edges[i] = false;
            }
        }

        dfs(graph, discovered, fucked_edges, mins, maxs, 0, -1);
        for (int i = 1; i < n; i++)
            answer[i] = min(answer[i],  mins[i] + maxs[i]);
    }

    for (int i = 1; i < n; i++)
        cout << answer[i] << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
