#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define maxN 300000

struct Edge {
	long long u, v, w;
	bool used;
};

long long n, m, u, v, t, ans[maxN];
Edge edges[maxN];
std::vector<long long> gr[maxN];

void dfs(long long u, long long min, long long max) {
	ans[u] = std::min(ans[u], min + max);
	for (long long v : gr[u]) {
		if (!edges[v].used) {
			edges[v].used = true;
			if (edges[v].u == u) {
				dfs(edges[v].v, std::min(min, edges[v].w), std::max(max, edges[v].w));
			}
			else {
				dfs(edges[v].u, std::min(min, edges[v].w), std::max(max, edges[v].w));
			}
			edges[v].used = false;
		}
	}
	return;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> m;
	for (long long i = 0; i < n; i++) {
		ans[i] = 2000000001;
	}
	for (long long i = 0; i < m; i++) {
		std::cin >> u >> v >> t;
		edges[i] = { --u, --v, t, false };
		gr[u].push_back(i);
		gr[v].push_back(i);
	}
	dfs(0, 1000000001, -1);
	for (long long i = 1; i < n; i++) {
		std::cout << ans[i] << "\n";
	}
	return 0;
}