#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

const int N = 3e5 + 5;

typedef pair <int, int> pii;

vector <int> white_edges;
int partner_right[2 * N];
int tim = 0;
bool has_partner_left[2 * N];
pii ind_to_edge[2 * N];
int used[2 * N];
vector <pii> g[N];
vector <pii> g2[N];
mt19937 rng(2);
int color[N];

void ddfs(int v, int c)
{
    color[v] = c;
    for (pii el : g[v])
        if (!color[el.x])
            ddfs(el.x, 3 - c);
    for (pii el : g2[v])
        if (!color[el.x])
            ddfs(el.x, 3 - c);

}

bool dfs(int v)
{
    used[v] = tim;
    for (auto el : g[ind_to_edge[v].y]) //edges ind_to_edge[v].y -> left_side
    {
        if (partner_right[el.y] == -1 || (used[partner_right[el.y]] < tim && dfs(partner_right[el.y])))
        {
            partner_right[el.y] = v;
            has_partner_left[v] = true;
            return true;
        }
    }
    for (auto el : g2[ind_to_edge[v].x]) //edges ind_to_edge[v].y -> left_side
    {
        if (partner_right[el.y] == -1 || (used[partner_right[el.y]] < tim && dfs(partner_right[el.y])))
        {
            partner_right[el.y] = v;
            has_partner_left[v] = true;
            return true;
        }
    }
    return false;
}

int32_t main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        g[--a].emplace_back(--b, i);
        g2[b].emplace_back(a, i);
        ind_to_edge[i] = {a, b};
    }
    for (int i = 0; i < n; ++i)
        if (!color[i])
            ddfs(i, 1);
    white_edges.reserve(m);
    for (int i = 0; i < n; ++i)
    {
        if (color[i] == 2)
            continue;
        for (auto el : g[i])
            white_edges.push_back(el.y);
    }
    fill(partner_right, partner_right + 2 * N, -1);
    bool did = true;
    for (int i = 0; i < n; ++i)
    {
        shuffle(g[i].begin(), g[i].end(), rng);
        shuffle(g2[i].begin(), g2[i].end(), rng);
    }
    while (did)
    {
        did = false;
        ++tim;
        for (int white_edge : white_edges)
            if (used[white_edge] < tim && !has_partner_left[white_edge])
                if (dfs(white_edge))
                {
//                    cout << ind_to_edge[white_edge].x << ' ' << ind_to_edge[white_edge].y << " Good" << endl;
                    did = true;
                }
    }
    for (int white_edge : white_edges)
    {
        if (!has_partner_left[white_edge])
        {
            cout  << "No\n";
            exit(0);
        }
    }
    for (int i = 0; i < m; ++i)
    {
        if (color[ind_to_edge[i].x] == 2)
        {
            if (partner_right[i] == -1)
            {
                cout << "No\n";
                exit(0);
            }
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < m; ++i)
        if (color[ind_to_edge[i].x] == 2)
            cout << ind_to_edge[i].x + 1 << ' ' << ind_to_edge[i].y + 1 << ' ' << ind_to_edge[partner_right[i]].x + 1 << ' '<< ind_to_edge[partner_right[i]].y + 1 << '\n';
    return 0;
}