#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Tree {
    long long x = 0, h = 0, ind = 0;

    Tree(long long x = 0, long long h = 0, long long i = 0) {
        this->x = x;
        this->h = h;
        ind = i;
    }

    inline bool operator<(Tree other) const {
        return x < other.x;
    }
};

vector<Tree> trees;
set<Tree> temp;
long long taken[5001], launch = 1;
long long n, x, h, qr, l, r, left_border, right_border;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> qr;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.emplace_back(x, h, i);
    }

    queue<Tree> q;
    Tree cur;
    long long count;

    while (qr--) {
        launch++;
        cin >> l >> r;
        temp.clear();

        if (l == 1) left_border = trees[l - 1].x;
        else left_border = trees[l - 2].x;
        if (r == n) right_border = trees[r - 1].x;
        else right_border = trees[r].x;

        for (long long i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].x - trees[i - 1].x >= trees[i].h) {
                q.push(trees[i]);
                taken[trees[i].ind] = launch;
            } else if (i < n - 1 and trees[i + 1].x - trees[i].x >= trees[i].h) {
                q.push(trees[i]);
                taken[trees[i].ind] = launch;
            }
            temp.insert(trees[i]);
        }

        count = 0;
        while (!q.empty()) {
            cur = q.front();
            auto right = temp.upper_bound(cur), left = temp.lower_bound(cur);
            if (right != temp.end() and left != temp.begin()) {
                left--;
                if (right->x - left->x >= right->h) {
                    if (taken[right->ind] != launch) {
                        q.push(*right);
                        taken[right->ind] = launch;
                    }
                }
                if (right->x - left->x >= left->h) {
                    if (taken[left->ind] != launch) {
                        q.push(*left);
                        taken[left->ind] = launch;
                    }
                }
            } else if (right != temp.end()) {
                if (right->h <= right->x - left_border) {
                    if (taken[right->ind] != launch) {
                        q.push(*right);
                        taken[right->ind] = launch;
                    }
                }
            } else if (left != temp.begin()) {
                left--;
                if (left->h <= right_border - left->x) {
                    if (taken[left->ind] != launch) {
                        q.push(*left);
                        taken[left->ind] = launch;
                    }
                }
            }
            temp.erase(cur);
            count++;
            q.pop();
        }
        cout << count << '\n';
    }
}