#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

int n, q;
int solve() {
    if (!(cin >> n >> q))
        return 1;
    vector<int> xs(n), hs(n);
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        xs[i] = x; hs[i] = h;
    }

    for (int _ = 0; _ < q; ++_) {
        int l, r;
        cin >> l >> r;
        l--;
        vector<int> left_tree_ind(n), right_tree_ind(n), left_free_space(n), right_free_space(n);
        vector<bool> alive(n);
        for (int i = l; i < r; ++i) {
            left_tree_ind[i] = i - 1;
            right_tree_ind[i] = i + 1;
            alive[i] = true;
            if (i != 0) {
                left_free_space[i] = xs[i] - xs[i - 1];
            }
            if (i != n - 1) {
                right_free_space[i] = xs[i + 1] - xs[i];
            }
        }

        int cnt = 0;
        bool changed = true;
        while (changed) {
            changed = false;
            for (int i = l; i < r; ++i) {
                if (!alive[i]) continue;
                if (hs[i] <= left_free_space[i] || hs[i] <= right_free_space[i]) {
                    alive[i] = false;
                    changed = true;
                    cnt++;
                    if (left_tree_ind[i] != -1) {
                        right_tree_ind[left_tree_ind[i]] = right_tree_ind[i];
                        right_free_space[left_tree_ind[i]] += right_free_space[i];
                    }
                    if (right_tree_ind[i] != n) {
                        left_tree_ind[right_tree_ind[i]] = left_tree_ind[i];
                        left_free_space[right_tree_ind[i]] += left_free_space[i];
                    }
                }
            }
        }
        cout << cnt << '\n';
    }
    return 0;
}


int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}
