#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()

// #define int long long

const int N = 5e5 + 7;

int n, nq;
int x[N], h[N];
pair<pair<int, int>, int> q[N];
int lx[N], rx[N];

bool used[N];

bool ok_left(int i) {
  if (x[i] - h[i] < x[0]) {
    return false;
  }
  for (int j = 0; j < i; ++j) {
    if (!used[j] && x[j] > x[i] - h[i]) {
      return false;
    }
  }
  return true;
}

bool ok_right(int i) {
  if (x[i] + h[i] > x[n - 1]) {
    return false;
  }
  for (int j = i + 1; j >= 0; --j) {
    if (!used[j] && x[j] < x[i] + h[i]) {
      return false;
    }
  }
  return true;
}

int get(int l, int r) {
  fill(used, used + n, false);
  int res = 0;
  while (true) {
    bool flag = false;
    for (int i = l; i <= r; ++i) {
      if (ok_left(i) || ok_right(i)) {
        used[i] = true;
        flag = true;
        ++res;
      }
    }
    if (!flag) {
      break;
    }
  }
  return res;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> n >> nq;
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> h[i];
  }
  for (int i = 0; i < nq; ++i) {
    int l, r;
    cin >> l >> r;
    --l, --r;
    q[i] = {{l, r}, i};
  }
  for (int i = 0; i < n; ++i) {
    lx[i] = x[i] - h[i];
    int j = i - 1;
    int last = i;
    while (j >= 0 && x[j] > lx[i]) {
      if (x[j] + h[j] > x[last]) {
        lx[i] = min(lx[i], x[j] - h[j]);
        last = j;
      }
      --j;
    }
  }
  for (int i = 0; i < n; ++i) {
    rx[i] = x[i] + h[i];
    int j = i + 1;
    int last = i;
    while (j < n && x[j] < rx[i]) {
      if (x[j] - h[j] < x[last]) {
        rx[i] = max(rx[i], x[j] + h[j]);
        last = j;
      }
      ++j;
    }
  }
  for (int i = 0; i < nq; ++i) {
    int l = q[i].first.first, r = q[i].first.second;
    int clx = (l == 0 ? x[l] : x[l - 1]), crx = (r == n - 1 ? x[r] : x[r + 1]);
    int res = 0;
    for (int j = l; j <= r; ++j) {
      res += (lx[j] >= clx || rx[j] <= crx);
    }
    // cout << res << '\n';
    cout << get(l, r) << '\n';
  }
  return 0;
}
