#include <algorithm>
#include <cassert>
#include <iostream>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()
#define ALL(c) c.begin(), c.end()

// #define int long long

const int N = 3e5 + 7;
const int M = 3e5 + 7;
const int INF = 1e9;

int n, m;
vector<pair<int, int>> g[N];
struct Edge {
  int v, u, w;
} edges[M];

void scan() {
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int v, u, w;
    cin >> v >> u >> w;
    --v, --u;
    g[v].push_back({u, w});
    g[u].push_back({v, w});
    edges[i] = {v, u, w};
  }
}

vector<int> g2[N];

bool used[N];

void dfs(int v) {
  used[v] = true;
  for (int u : g2[v]) {
    if (!used[u]) {
      dfs(u);
    }
  }
}

int f(int mask) {
  for (int v = 0; v < n; ++v) {
    g2[v].clear();
  }
  for (int i = 0; i < m; ++i) {
    if (mask >> i & 1) {
      g2[edges[i].v].push_back(edges[i].u);
      g2[edges[i].u].push_back(edges[i].v);
    }
  }
  fill(used, used + n, false);
  dfs(0);
  vector<int> arr;
  for (int v = 0; v < n; ++v) {
    if (SZ(g2[v]) % 2) {
      arr.push_back(v);
    }
    if (!g2[v].empty() && !used[v]) {
      return -1;
    }
  }
  if (SZ(arr) != 2 || arr[0] != 0 && arr[1] != 0) {
    return -1;
  } else {
    return arr[0] ^ arr[1];
  }
}

int ans[N];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  scan();
  fill(ans, ans + N, 2 * INF);
  for (int mask = 1; mask < (1 << m); ++mask) {
    int v = f(mask);
    if (v != -1) {
      int cur_min = INF, cur_max = 0;
      for (int i = 0; i < m; ++i) {
        if (mask >> i & 1) {
          cur_min = min(cur_min, edges[i].w);
          cur_max = max(cur_max, edges[i].w);
        }
      }
      ans[v] = min(ans[v], cur_min + cur_max);
    }
  }
  for (int v = 1; v < n; ++v) {
    cout << ans[v] << '\n';
  }
  return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
*/
