#include<bits/stdc++.h>

using namespace std;

const int MAXN = 5e5;
const int INF = 1e9;

struct seg_tree{
    int n;
    vector<int> t;
    seg_tree() {}
    seg_tree(int _n) {
        n = _n;
        t.resize(4 * n + 4);
    }
    void _update(int i, int l, int r, int q_i, int x) {
        if (r <= q_i || q_i < l) {
            return;
        }
        if (l + 1 == r) {
            t[i] += x;
            //cout << "new " << l << " " << r << ": " << t[i] << endl;
            return;
        }
        int m = (r + l) / 2;
        _update(2 * i + 1, l, m, q_i, x);
        _update(2 * i + 2, m, r, q_i, x);
        t[i] = t[2 * i + 1] + t[2 * i + 2];
    }
    void update(int q_i, int x) {
        _update(0, 0, n, q_i, x);
    }
    int _get_seg(int i, int l, int r, int q_l, int q_r) {
        if (q_l <= l && r <= q_r) {
            //cout << "return " << l << " " << r << ": " << t[i] << endl;
            return t[i];
        }
        if (r <= q_l || q_r <= l) {
            //cout << "return " << l << " " << r << ": " << 0 << endl;
            return 0;
        }
        int m = (r + l) / 2;
        int x = _get_seg(2 * i + 1, l, m, q_l, q_r) + _get_seg(2 * i + 2, m, r, q_l, q_r);
        //cout << "return " << l << " " << r << ": " << x << endl;
        return x;
    }
    int get_seg(int q_l, int q_r) {
        return _get_seg(0, 0, n, q_l, q_r);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<vector<int> > sp(n, vector<int>(2));
    for (int i = 0; i < n; ++i) {
        cin >> sp[i][0] >> sp[i][1];
    }
    vector<int> lft(n, -1);
    ///try fall left;
    for (int i = 0; i < n; ++i) {
        if (i == 0) {
            lft[i] == -1;
            continue;
        }
        vector<vector<int> > st;
        st.push_back(sp[i]);
        ///cout << "OK!" << endl;
        for (int j = i - 1; j >= 0; --j) {
            while(st.size() != 0) {
                if (sp[j][0] <= st.back()[0] - st.back()[1]) {
                    st.pop_back();
                }
                else {
                    break;
                }
            }
            if (st.size() == 0) {
                lft[i] = j + 1;
                break;
            }
            if (sp[j][0] + sp[j][1] > st.back()[0]) {
                st.push_back(sp[j]);
            }
        }
    }
/**
    for (int i = 0; i < n; ++i) {
        cout << lft[i] << " ";
    }
    cout << endl;
**/
    vector<int> rig(n, n);
    ///try fall right;
    for (int i = n - 1; i >= 0; --i) {
        if (i == n - 1) {
            lft[i] == n;
            continue;
        }
        vector<vector<int> > st;
        st.push_back(sp[i]);
        ///cout << "OK!" << endl;
        for (int j = i + 1; j < n; ++j) {
            while(st.size() != 0) {
                if (st.back()[0] + st.back()[1] <= sp[j][0]) {
                    st.pop_back();
                }
                else {
                    break;
                }
            }
            if (st.size() == 0) {
                rig[i] = j - 1;
                break;
            }
            if (st.back()[0] > sp[j][0] - sp[j][1]) {
                st.push_back(sp[j]);
            }
        }
    }
/**
    for (int i = 0; i < n; ++i) {
        cout << rig[i] << " ";
    }
    cout << endl << endl;
**/
    seg_tree sm(n);
    vector<vector<int> > act;
    int l, r;
    for (int i = 0; i < q; ++i) {
        cin >> l >> r;
        --l;
        --r;
        //act.push_back({l, r, i});
        act.push_back({r, i, l});
    }
    for (int i = 0; i < n; ++i) {
        if (lft[i] != -1) {
            //act.push_back({lft[i], i, -1});
            act.push_back({i, -1, lft[i]});
        }
        if (rig[i] != n) {
            //act.push_back({i, rig[i], -1});
            act.push_back({rig[i], -3, i});
            if (lft[i] != -1) {
                act.push_back({i, -2, lft[i]});
            }
        }
    }
    sort(act.begin(), act.end());
    vector<int> ans(q);
    int ind;
    for (auto vec : act) {
        //cout << vec[2] << " " << vec[0] << " with type = " << vec[1] << endl;
        l = vec[2];
        r = vec[0];
        ind = vec[1];
        if (ind == -3) {
            //cout << "ADD: " << l << endl;
            sm.update(l, 1);
        }
        else if (ind == -2) {
            //cout << "DELETE: " << r << endl;
            sm.update(l, -1);
        }
        else if (ind == -1) {
            //cout << "ADD: " << r << endl;
            sm.update(l, 1);
        }
        else {
            ans[ind] = sm.get_seg(l, r + 1);
        }
    }
    for (auto el : ans) {
        cout << el << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    ///cin >> tests;
    while(tests--) {
        solve();
    }
}
