#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using edge = tuple<int, int, int>;

struct dsu {
    vector<int> p;
    vector<int> sz;

    explicit dsu(int n) : p(n, -1), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int find(int x) { return p[x] = (p[x] == x ? x : find(p[x])); }

    void unite(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return;
        if (sz[x] < sz[y]) {
            p[x] = y;
            sz[y] += sz[x];
        } else {
            p[y] = x;
            sz[x] += sz[y];
        }
    }

    bool connected(int x, int y) { return find(x) == find(y); }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        edges.emplace_back(u, v, t);
    }
    sort(edges.begin(), edges.end(), [](auto e1, auto e2) { return get<2>(e1) < get<2>(e2); });
    dsu kruskal(n);
    vector<vector<pair<int, int>>> mst(n);
    vector<edge> other;
    for (auto[u, v, t] : edges) {
        if (kruskal.connected(u, v)) {
            other.emplace_back(u, v, t);
            continue;
        }
        kruskal.unite(u, v);
        mst[u].emplace_back(v, t);
        mst[v].emplace_back(u, t);
    }
    vector<vector<pair<int, int>>> b(20, vector<pair<int, int>>(n));
    vector<int> root_max(n);
    int t = 0;
    vector<int> tin(n), tout(n);
    vector<int> depth(n);
    function<void(int, int, int, int)> dfs = [&](int cur, int prev, int max, int d) {
        tin[cur] = t++;
        depth[cur] = d;
        root_max[cur] = max;
        for (auto[next, t] : mst[cur]) {
            if (next == prev) {
                b[0][cur] = {next, t};
            } else {
                dfs(next, cur, ::max(max, t), d + 1);
            }
        }
        tout[cur] = t++;
    };
    dfs(0, 0, -1, 0);
    b[0][0] = {0, (int) 1e9};
    for (int l = 1; l < 20; ++l) {
        for (int i = 0; i < n; ++i) {
            b[l][i] = {b[l - 1][b[l - 1][i].first].first,
                       min(b[l - 1][b[l - 1][i].first].second, b[l - 1][i].second)};
        }
    }
    vector<int> ans(n);
    auto ancestor = [&](int parent, int son) {
        return tin[parent] <= tin[son] && tout[son] <= tout[parent];
    };
    for (int i = 0; i < n; ++i) ans[i] = root_max[i] + b[19][i].second;
    auto path = [&](int x, int y) -> pair<int, int> {
        int mn = 1e9;
        auto jump = [&](int z, int i) {
            mn = min(mn, b[i][z].second);
            return b[i][z].first;
        };
        for (int i = 19; i >= 0; --i)
            if (depth[b[i][x].first] >= depth[y]) x = jump(x, i);
        for (int i = 19; i >= 0; --i)
            if (depth[b[i][y].first] >= depth[x]) y = jump(y, i);
        if (x == y) return {x, mn};
        for (int i = 19; i >= 0; --i)
            if (b[i][x].first != b[i][y].first) {
                x = jump(x, i);
                y = jump(y, i);
            }
        jump(x, 0);
        jump(y, 0);
        return {x, mn};
    };
    auto min_on_path = [&](int x, int y) { return path(x, y).second; };
    auto lca = [&](int x, int y) { return path(x, y).first; };
    for (auto[u, v, t] : other) {
        int mnu = b[19][u].second;
        int mnv = b[19][v].second;
        int mx = t;
        for (int i = 0; i < n; ++i) {
            if (ancestor(u, v)) {
                if (ancestor(u, i)) {
                    ans[i] = min(ans[i], min_on_path(i, v) + mx);
                }
            } else if (ancestor(v, u)) {
                if (ancestor(v, i)) {
                    ans[i] = min(ans[i], min_on_path(i, u) + mx);
                }
            } else {
                if ((ancestor(i, v) || ancestor(v, i)) && (!ancestor(i, u) || i == lca(u, v))) {
                    ans[i] = min(ans[i], mnu + mx);
                }
                if ((ancestor(i, u) || ancestor(u, i)) && (!ancestor(i, v) || i == lca(u, v))) {
                    ans[i] = min(ans[i], mnv + mx);
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << ans[i] << '\n';
}