#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

//#define GLIBCXX_DEBUG

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while(t--)
        solve();
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();

    vector<ll> values = {1, 5};
    while (values.size() < 26) {
        values.push_back(values.back() * 2);
        values.push_back(values.back() * 5);
    }
    assert(values.size() == 26);

    vector<ll> sParsed(n);
    int ma = 0;
    for (int i = n - 1; i >= 0; i--) {
        int ch = s[i] - 'A';
        if (s[i] == '?')
            sParsed[i] = 0;
        else if (ch < ma)
            sParsed[i] = -values[ch];
        else
            sParsed[i] = values[ch];
        ma = max(ma, ch);
    }


    vector<vector<ll>> prefs(26, vector<ll>(n + 1));
    for (int ch = 0; ch < 26; ch++) {
        prefs[ch][0] = 0;
        for (int i = 0; i < n; i++) {
            prefs[ch][i + 1] = prefs[ch][i];
            if (s[i] - 'A' < ch && sParsed[i] > 0)
                prefs[ch][i + 1] -= 2 * values[s[i] - 'A'];
        }
    }

    vector<vector<ll>> dp(26, vector<ll>(n + 1, -1e18));
    int prevQuestion = -1;
    for (int i = 0; i < 26; i++)
        dp[i][0] = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] != '?')
            continue;
        int miAns = -1;
        ll mi = -1e18;
        for (int ch = 25; ch >= 0; ch--) {
            ll destroyed = prefs[ch][i + 1] - prefs[ch][prevQuestion + 1];
            ll score = destroyed + values[ch];
            if (dp[ch][prevQuestion + 1] > mi) {
                mi = dp[ch][prevQuestion + 1];
                miAns = ch;
            }
            dp[ch][i + 1] = mi + score;
        }
        prevQuestion = i;
    }

    int curCh = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] != '?')
            continue;
        ll mi = -1e18;
        int miAns = -1;
        for (int ans = curCh; ans < 26; ans++) {
            ll res = dp[ans][i + 1];
            if (res >= mi) {
                mi = res;
                miAns = ans;
            }
        }
        s[i] = 'A' + miAns;
        curCh = miAns;
    }

//     recovery
    ll answer = 0;
    ma = 0;
    for (int i = n - 1; i >= 0; i--) {
        int ch = s[i] - 'A';
        if (ch < ma)
            answer -= values[ch];
        else
            answer += values[ch];
        ma = max(ma, ch);
    }
    cout << answer << '\n' << s << '\n';
}