#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const ll INFL = 2e18;

struct tree {
    int x, h;

    bool operator<(const tree &a) const {
        return h < a.h || h == a.h && x < a.x;
    }
};

int main() {
    input();
    int n, q;
    cin >> n >> q;
    vector<tree> forest(n);
    for (int i = 0; i < n; i++) {
        cin >> forest[i].x >> forest[i].h;
    }
    for (int _ = 0; _ < q; _++) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        vector<int> used(n);
        set<int> inds, del;
        for (int i = l; i <= r; i++)
            inds.insert(i);
        for (int i = l; i <= r; i++) {
            int j = i - 1;
            if (j == -1)
                j++;
            if (forest[i].x - forest[i].h >= forest[j].x) {
                used[i] = 1;
                inds.erase(i);
                del.insert(i);
                continue;
            }
            j = i + 1;
            if (j == n)
                --j;
            if (forest[i].x + forest[i].h <= forest[j].x) {
                used[i] = 1;
                inds.erase(i);
                del.insert(i);
            }
        }
        while (!del.empty()) {
            auto it = del.begin();
            auto left = inds.lower_bound(*it);
            if (left != inds.begin()) {
                int mid1;
                if (left == inds.end())
                    mid1 = min(r + 1, n - 1);
                else
                    mid1 = *left;
                --left;
                if (forest[*left].x + forest[*left].h <= forest[mid1].x) {
                    del.insert(*left);
                    used[*left] = 1;
                    inds.erase(left);
                }
            }
            auto right = inds.upper_bound(*it);
            if (right != inds.end()) {
                int mid1;
                if (right == inds.begin()) {
                    mid1 = max(0, l - 1);
                } else {
                    mid1 = *prev(right);
                }
                if (forest[*right].x - forest[*right].h >= forest[mid1].x) {
                    del.insert(*right);
                    used[*right] = 1;
                    inds.erase(right);
                }
            }
            del.erase(it);
        }
        int ans = 0;
        for (int i = l; i <= r; i++)
            ans += used[i];
        cout << ans << "\n";
    }
    return 0;
}