#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ios>
using namespace std;
#define int long long

const int MAX_N = 300000;
int dp[MAX_N + 1][26];
int parent[MAX_N + 1][26];
const int INF = 2e18;

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	vector<int> values;
	int cur_value = 1;
	for (int i = 0; i < 26; i += 2) {
		values.push_back(cur_value);
		cur_value *= 5;
		values.push_back(cur_value);
		cur_value *= 2;
	}

	map<int, char> to_letter;
	for (int i = 0; i < 26; i++) {
		to_letter[values[i]] = 'A' + i;
	}

	int t;
	cin >> t;

	while (t--) {
		string s;
		cin >> s;
		for (char& c : s)
			c -= 'A';
		char question = '?' - 'A';
		int n = s.size();
		
		dp[0][0] = 0;
		for (int i = 1; i < 26; i++)
			dp[0][i] = -INF;

		for (int i = 1; i <= n; i++) {
			for (int new_max = 0; new_max < 26; new_max++) {
				dp[i][new_max] = -INF;
				for (int prev_max = 0; prev_max < 26; prev_max++) {
					char c = s[n - i];

					if (prev_max > new_max)
						continue;
					if (dp[i - 1][prev_max] == -INF)
						continue;
					if (prev_max == new_max && c == question) {
						for (int new_c = 0; new_c <= new_max; new_c++) {
							int value = values[new_c];
							if (new_c < prev_max)
								value = -value;
							int new_sum = dp[i - 1][prev_max] + value;
							if (dp[i][new_max] < new_sum) {
								dp[i][new_max] = new_sum;
								parent[i][new_max] = prev_max;
							}
						}
					}
					else {
						if (c == question)
							c = new_max;
						int actual_max = max<int>(prev_max, c);
						if (actual_max != new_max)
							continue;
						int value = values[c];
						if (c < prev_max)
							value = -value;
						int new_sum = dp[i - 1][prev_max] + value;
						if (dp[i][new_max] < new_sum) {
							dp[i][new_max] = new_sum;
							parent[i][new_max] = prev_max;
						}
					}
				}
			}
		}

		int max_max;
		int max_sum = -INF;
		for (int i = 0; i < 26; i++) {
			int ans = dp[n][i];
			if (ans > max_sum) {
				max_sum = ans;
				max_max = i;
			}
		}
		cout << dp[n][max_max] << "\n";
		for (int i = n; i > 0; i--) {
			int prev = parent[i][max_max];
			int diff = abs(dp[i][max_max] - dp[i - 1][prev]);
			cout << to_letter[diff];
			max_max = prev;
		}
		cout << "\n";
	}
}