#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<vector<int>> edges;
vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<bool> vis;
map<pair<int, int>, int> isEdge;

bool check = true;

void dfs(int u, int pr = -1) {
	vis[u] = true;
	vector<int> vin;
	vector<int> vout;
	for (auto v : edges[u]) {
		if (v != pr) {
			dfs(v, u);
			int a = isEdge[{u, v}];
			int b = isEdge[{v, u}];
			if (a && b) {
				isEdge[{u, v}]--, isEdge[{v, u}]--;
				ans.push_back({ {u, v}, {v, u} });
			} else if (a) {
				vin.push_back(v);
			} else if (b) {
				vout.push_back(v);
			}
		}
	}
	for (int i = 0; i < min(vin.size(), vout.size()); i++) {
		ans.push_back({ {vout[i], u}, {u, vin[i]} });
		isEdge[{vout[i], u}]--;
		isEdge[{u, vin[i]}]--;
	}
	//cout << "this is " << u << endl;
	for (int i = 0; i < vin.size(); i++) {
	//	cout << vin[i] << " vin ";
	}
	//cout << endl;
	for(int i = 0; i < vout.size(); i++) {
	//	cout << vout[i] << " vout ";
	}
	if (vin.size() == vout.size()) {
		return;
	}
	if (abs((int)vin.size() - (int)vout.size()) >= 2) {
		check = false;
		return;
	}
	if (vin.size() < vout.size() && isEdge[{u, pr}]) {
		isEdge[{vout[vout.size() - 1], u}]--;
		isEdge[{u, pr}]--;
		ans.push_back({ {vout[vout.size() - 1], u}, {u, pr} });
	} else if (vin.size() < vout.size()) {
		check = false;
		return;
	}
	if (vin.size() > vout.size() && isEdge[{pr, u}]) {
		isEdge[{u, vin[vin.size() - 1]}]--;
		isEdge[{pr, u}]--;
		ans.push_back({ {pr, u}, {u, vin[vin.size() - 1]} });
	}
	else if (vin.size() > vout.size()) {
		check = false;
		return;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	edges.resize(n);
	vis.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		isEdge[{a, b}]++;
		if (!isEdge[{ b, a }]) {
			edges[a].push_back(b);
			edges[b].push_back(a);
		}
	}

	for (int i = 0; i < n; i++) {
		if (!vis[i]) {
			dfs(i);
		}
	}

	if (!check || ans.size() != m / 2) {
		cout << "No" << endl;
		/*for (int i = 0; i < ans.size(); i++) {
			cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " "
				<< ans[i].second.first + 1 << " " << ans[i].second.second + 1 << endl;
		}*/
	} else {
		cout << "Yes" << endl;
		for (int i = 0; i < m / 2; i++) {
			cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " 
				<< ans[i].second.first + 1 << " " << ans[i].second.second + 1 << endl;
		}
	}
	cin >> n;
	return 0;
}




/*

5 6
1 2
2 1
1 5
2 3
2 4
4 2

*/