#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll LINF = 1e18;

ll Bonus(char c) {
	c -= 'A';
	return pow(10, c / 2) * (c % 2 ? 5 : 1);
}

void Test() {
	string s;
	cin >> s;
	s = '?' + s;
	
	vector <int> qs;

	vector <int> rightest(26, 0);

	for (size_t i = 0; i < s.size(); i++)
	{
		if (s[i] == '?') continue;
		rightest[s[i] - 'A'] = i;
	}

	for (int i = 0; i < s.size(); i++)
		if (s[i] == '?')
			qs.push_back(i);
		
	vector <vector <ll>> dp(26, vector <ll>(qs.size(), -LINF));
	vector <vector <ll>> how(26, vector <ll>(qs.size(), -2));
	dp[25][0] = 0;


	int startPos = 0;
	for (int j = 25; j >= 0; j--) {
		vector <ll> res(s.size());
		for (int i = 0; i < s.size(); i++) {
			if (s[i] == '?') continue;
			if (s[i] < j + 'A') res[i] = -Bonus(s[i]);
			else res[i] = Bonus(s[i]);
		}
		partial_sum(res.begin(), res.end(), res.begin());
		for (int i = 0; i < qs.size(); i++) {
			if (j != 25) {
				dp[j][i] = dp[j + 1][i];
				how[j][i] = -1;
			}
			for (int t = i - 1; t >= 0; t--) {
				if (qs[i] >= startPos && i && dp[j][t] + res[qs[i]] - res[qs[t]] + Bonus('A' + j) >= dp[j][i]) {
					dp[j][i] = dp[j][t] + res[qs[i]] - res[qs[t]] + Bonus('A' + j);
					how[j][i] = t;
				}
			}
		}
		startPos = max(startPos, rightest[j]);
	}

	int ps = 0;
	for (int i = qs.size() - 1; i >=0; i--) {
		while (how[ps][i] == -1) ps++;
		int t = how[ps][i];
		if (t == -2) break;
		while (i > t) {
			s[qs[i]] = ps + 'A';
			i--;
		}
		i++;
	}
	s = s.substr(1);

	if (s.find('?') != string::npos) exit(-1);

	char mx = 0;
	ll ans = 0;
	for (int i = s.size() - 1; i >= 0; i--)
	{
		if (s[i] >= mx) ans += Bonus(s[i]);
		else ans -= Bonus(s[i]);
		mx = max(mx, s[i]);
	}
	cout << ans << "\n" << s << '\n';
}

void Solve() {
	int t;
	cin >> t;
	while (t--) Test();
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}