#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


vector<set<int>> g;
set<pair<int, int>> edges;
vector<bool> isLeaf;
set<int> cool;
vector<int> par, haveLeafs;
vector<vector<int>> answer;


void dfs(int v, int pr) {
    isLeaf[v] = true;
    par[v] = pr;
    bool allLeafs = true;
    for (auto u : g[v]) {
        if (u == pr or (edges.count({v, u}) == 0 and edges.count({u, v}) == 0)) {
            continue;
        }
        isLeaf[v] = false;
        dfs(u, v);
        allLeafs &= isLeaf[u];
        if (isLeaf[u]) {
            haveLeafs[v]++;
        }
    }
    if (allLeafs and !isLeaf[v]) {
        cool.insert(v);
    }
}


void die() {
    cout << "No\n";
    exit(0);
}


void checkCool(int v) {
    if (par[v] == v and haveLeafs[v] == g[v].size()) {
        cool.insert(v);
    }
    if (par[v] != v and haveLeafs[v] + 1 == g[v].size()) {
        cool.insert(v);
    }
}


void makeLeaf(int v) {
    if (par[v] == v) {
        return;
    }
    haveLeafs[par[v]]++;
    checkCool(par[v]);
}


void collapse(int v) {
    vector<int> in, out;
    for (int u : g[v]) {
        if (u == par[v]) {
            continue;
        }
        if (edges.count({v, u})) {
            out.pb(u);
        }
        if (edges.count({u, v})) {
            in.pb(u);
        }
    }
    while (!in.empty() and !out.empty()) {
        answer.pb({in.back(), v, v, out.back()});
        edges.erase({in.back(), v});
        edges.erase({v, out.back()});
        in.pop_back();
        out.pop_back();
    }
    if (in.size() > 1 or out.size() > 1) {
        die();
    }
    if (!in.empty()) {
        int x = in.back();
        if (edges.count({v, par[v]})) {
            answer.pb({x, v, v, par[v]});
            edges.erase({x, v});
            edges.erase({v, par[v]});
        } else {
            die();
        }
    } else if (!out.empty()) {
        int x = out.back();
        if (edges.count({par[v], v})) {
            answer.pb({par[v], v, v, x});
            edges.erase({v, x});
            edges.erase({par[v], v});
        } else {
            die();
        }
    }
    makeLeaf(v);
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    isLeaf.resize(n);
    par.resize(n, -1);
    haveLeafs.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].insert(u);
        g[u].insert(v);
        edges.insert({v, u});
    }
    for (int i = 0; i < n; i++) {
        if (par[i] == -1) {
            dfs(i, i);
            while (!cool.empty()) {
                auto x = *cool.begin();
                cool.erase(x);
                collapse(x);
            }
//            do {
//                cool.clear();
//                dfs(i, i);
//                for (auto v : cool) {
//                    collapse(v);
//                }
//            } while (!cool.empty());
        }
    }
    cout << "Yes\n";
    for (auto &p : answer) {
        for (auto x : p) {
            cout << x + 1 << " ";
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
