#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


struct tree {
    int x, h;
};


bool canCutL(tree l, tree r) { // can cut left tree
    assert(l.x <= r.x);
    return r.x - l.x >= l.h;
}


bool canCutR(tree l, tree r) { // can cut right tree
    assert(l.x <= r.x);
    return r.x - l.x >= r.h;
}


vector<tree> merge(vector<tree> stay, vector<tree> r, tree prev, tree nxt) { // in l
    for (auto t : r) {
        stay.pb(t);
        while (!stay.empty() and
               (canCutL(stay.back(), nxt) or
                (stay.size() == 1 and canCutR(prev, stay.back())) or
                (stay.size() > 1 and canCutR(stay[stay.size() - 2], stay.back())))) {
            stay.pop_back();
        }
    }
    while (!stay.empty() and canCutL(stay.back(), nxt)) {
        stay.pop_back();
    }
    return stay;
}


struct stree {
    vector<vector<tree>> t;
    vector<tree> arr;

    stree(vector<tree> &x) {
        int n = x.size();
        arr = x;
        t.resize(4 * n);
        build(1, 1, n - 2);
    }

    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = merge({}, {arr[l]}, arr[l - 1], arr[r + 1]);
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2, l, mid);
        build(v * 2 + 1, mid + 1, r);
        t[v] = merge(t[v * 2], t[v * 2 + 1], arr[l - 1], arr[r + 1]);
    }

    vector<tree> query(int v, int l, int r, int ql, int qr) {
        if (l >= ql and r <= qr) {
            return t[v];
        }
        if (l > qr or r < ql) {
            return {};
        }
        int mid = (l + r) / 2;
        if (ql <= mid and mid <= qr) {
            auto x1 = query(v * 2, l, mid, ql, qr), x2 = query(v * 2 + 1, mid + 1, r, ql, qr);
            return merge(x1, x2, arr[l - 1], arr[r + 1]);
        } else if (qr <= mid) {
            return query(v * 2, l, mid, ql, qr);
        } else {
            return query(v * 2 + 1, mid + 1, r, ql, qr);
        }
    }
};


void solve() {
    int n, q;
    cin >> n >> q;
    vector<tree> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].h;
    }
    arr.insert(arr.begin(), arr[0]);
    arr.pb(arr.back());
//    vector<vector<int>> answer(n + 1, vector<int>(n + 1));
//    for (int i = 1; i <= n; i++) {
//        vector<tree> stay;
//        for (int j = i; j <= n; j++) {
//            stay.pb(arr[j]);
//            while (!stay.empty() and
//                  (canCutL(stay.back(), arr[j + 1]) or
//                  (stay.size() == 1 and canCutR(arr[i - 1], stay.back())) or
//                  (stay.size() > 1 and canCutR(stay[stay.size() - 2], stay.back())))) {
//                stay.pop_back();
//            }
//            answer[i][j] = (j - i + 1) - stay.size();
//        }
//    }
    stree t(arr);
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << (r - l + 1) - t.query(1, 1, n, l, r).size() << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
