#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()

vector<pair<int, int>> edges;
vector<vector<int>> graph;
vector<int> l;
vector<int> r;
vector<bool> visited;
int m;
vector<int> matched;


void dfs1(int v, bool q = false) {
    visited[v] = true;

    if (q) {
        l.push_back(v);
    } else {
        r.push_back(v);
    }

    for (int u : graph[v]) {
        if (!visited[u]) {
            dfs1(u, !q);
        }
    }
}


bool dfs2(int v, int in_left = true) {
    if (visited[v]) return false;
    visited[v] = true;

    for (int u : graph[v]) {
        if (in_left) {
            if (matched[u] == -1 || dfs2(u, false)) {
                matched[v] = u;
                matched[u] = v;
                return true;
            }
        } else {
            if (dfs2(u, true)) {
                return true;
            }
        }
    }
    return false;
}


void kuhn() {
    for (int v : l) {
        visited.assign(m, false);
        if (matched[v] != -1) continue;
        dfs2(v);
    }
}


void solve() {
    int n;
    cin >> n >> m;
    edges.resize(m);
    matched.assign(m, -1);
    graph.assign(m, vector<int>());
    visited.assign(m, false);
    l.clear();
    r.clear();
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        edges[i] = {v, u};
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            if (edges[i].second == edges[j].first) {
                if (edges[i].first == edges[j].second) {
                    if (edges[i].first > edges[i].second) continue;
                }

                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }
    for (int v = 0; v < m; ++v) {
        if (!visited[v])
            dfs1(v);
    }

    kuhn();
    if (count(all(matched), -1) != 0) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";

    for (int v : r) {
        int u = matched[v];
        if (edges[v].second != edges[u].first) swap(v, u);
        cout << edges[v].first + 1 << " " << edges[v].second + 1 << " " <<
        edges[u].first + 1 << " " << edges[u].second + 1 << "\n";
    }

    cout << "\n";


}


int main() {
#if ELT
    freopen("../B.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
        solve();
#endif
    return 0;
}
