#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define INF 4000000000000000000

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int main() {
	int t, n;
	string s;
	cin >> t;
	vector<ll> decrypt = { 1, 5 };
	for (int i = 0; i < 12; i++) {
		decrypt.push_back(decrypt[2 * i] * 10);
		decrypt.push_back(decrypt[2 * i + 1] * 10);
	}
	while (t--) {
		cin >> s;
		n = s.size();
		vector<vector<ll>> dp(n, vector<ll>(26));
		vector<int> suf(n);
		if (s[n - 1] != '?')
			suf[n - 1] = s[n - 1] - 'A';
		for (int i = n - 2; i >= 0; i--)
			if (s[i] != '?')
				suf[i] = max(suf[i + 1], s[i] - 'A');
			else
				suf[i] = suf[i + 1];
		if (s[0] == '?')
			s[0] = 'Z';
		int p = s[0] - 'A';
		ll cur = decrypt[p];
		for (int i = 0; i <= p; i++) {
			if (suf[0] <= p)
				dp[0][i] = cur;
			else
				dp[0][i] = -cur;
		}
		for (int i = p + 1; i < 26; i++)
			dp[0][i] = -cur;
		for (int i = 1; i < n; i++) {
			if (s[i] == '?') {
				ll best, val = -INF;
				for (int j = 0; j < 26; j++)
					if (dp[i - 1][j] + decrypt[j] > val) {
						if (suf[i] <= j)
							val = dp[i - 1][j] + decrypt[j];
						else
							val = dp[i - 1][j] - decrypt[j];
						best = j;
					}
				s[i] = 'A' + best;
			}
			int a = s[i] - 'A';
			ll cur = decrypt[a];
			for (int j = 0; j <= a; j++) {
				if (suf[i] <= a)
					dp[i][j] = dp[i - 1][a] + cur;
				else 
					dp[i][j] = dp[i - 1][a] - cur;
			}
			for (int j = a + 1; j < 26; j++)
				dp[i][j] = dp[i - 1][j] - cur;
		}
		ll mx = -INF;
		for (int i = 0; i < 26; i++)
			mx = max(mx, dp[n - 1][i]);
		cout << mx << "\n" << s << "\n";
	}
}