#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll cst = (ll)3e5 + 50;
const ll inf = (ll)1e18 + 228;

ll cost[26];

void solve() {
	string s;
	cin >> s;
	reverse(all(s));
	vector<vector<ll>> dp(26, vector<ll>(s.size() + 1));
	vector<vector<ll>> pr(26, vector<ll>(s.size() + 1, -1));
	for (ll i = 1; i <= 25; i++) dp[i][0] = -inf;
	for (ll i = 1; i <= s.size(); i++) {
		for (ll c = 0; c <= 25; c++) {
			dp[c][i] = -inf;
			if (s[i - 1] != '?') {
				if (c + 'A' < s[i - 1]) dp[c][i] = -inf;
				else if (c + 'A' == s[i - 1]) {
					for (ll c2 = 0; c2 <= c; c2++) {
						if (dp[c][i] < dp[c2][i - 1] + cost[c]) {
							dp[c][i] = dp[c2][i - 1] + cost[c];
							pr[c][i] = c2;
						}
					}
				}
				else {
					dp[c][i] = dp[c][i - 1] - cost[s[i - 1] - 'A'];
					pr[c][i] = c;
				}
			}
			else {
				for (ll c2 = 0; c2 <= c; c2++) {
					if (dp[c][i] < dp[c2][i - 1] + cost[c]) {
						dp[c][i] = dp[c2][i - 1] + cost[c];
						pr[c][i] = c2;
					}
					
				}
			}
		}
	}
	ll answ = -inf;
	ll ansi = -1;
	for (ll i = 0; i < 26; i++) {
		if (dp[i][s.size()] > answ) {
			answ = dp[i][s.size()];
			ansi = i;
		}
	}
	cout << answ << endl;
	ll n = s.size();
	while (n) {
		if (s[n - 1] == '?') s[n - 1] = 'A' + ansi;

		ansi = pr[ansi][n];
		n--;
	}
	reverse(all(s));
	cout << s;
}

ll n;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cost[0] = 1;
	for (ll i = 1; i < 26; i++) {
		if (i % 2) cost[i] = 5 * cost[i - 1];
		else cost[i] = 2 * cost[i - 1];
	}
	cin >> n;
	while (n--) {
		solve();
		cout << endl;
	}
	return 0;
}