#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 3e5 + 10;

int n, m;
vector<pii> g[N];
int d[N], used[N];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].pb({v, w});
		g[v].pb({u, w});
	}
	for (int i = 0; i < n; i++) {
		d[i] = INF;
	}
	d[0] = INF;
	set<pii> q;
	q.insert({INF, 0});
	while (!q.empty()) {
		int v = (*q.begin()).second;
		q.erase(q.begin());
		// dbg(v);
		// dbg(used[v]);
		if (used[v]) continue;
		used[v] = 1;
		for (auto[u, w] : g[v]) {
			if (chkmin(d[u], min(d[v], w))) {
				q.insert({d[u], u});
			}
		}
	}
	for (int i = 1; i < n; i++) {
		cout << d[i] + 1000000000ll << "\n";
	}
}
/*
4 4 
1 2 1000000000
1 3 1000000000
2 3 2 
3 4 3

*/