#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct dsu{
	void resize(int n){
		sz.assign(n, 1);
		rt.resize(n);
		for(int i = 0; i < n; ++i)
			rt[i] = i;
	}

	void gst(int i){
		if(rt[i] == i)
			return i;
		return rt[i] = gst(rt[i]);
	}

	void unite(int i, int j){
		i = gst(i);
		j = gst(j);
		if(sz[i] > sz[j]){
			rt[j] = i;
			sz[i] += sz[j];
		} else {
			rt[i] = j;
			sz[j] += sz[i];
		}
	}
private:
	vector<int> rt;
	vector<int> sz;
};

const int MAXN = 3e5 + 123;
vector<pair<int, int>> edg[MAXN];
int ans[MAXN];

void g2(int v, int rt, int vl){
	ans[v] = vl;
	for(auto [u, c] : edg[v]){
		if(u != rt){
			g2(u, v, max(vl, c));
		}
	}
}

signed main(){
	int n, m;
	cin >> n >> m;
	vector<pair<int, pair<int, int>> e(m);
	for(int i = 0; i < m; ++i){
		cin >> e[i].second.first >> e[i].second.second >> e[i].first;
		--e[i].second.first, --e[i].second.second;
	}
	sort(e.begin(), e.end());
	dsu su;
	su.resize(n);
	for(int i = 0; i < m; ++i){
		auto [u, v] = e[i].second;
		if(su.gst(u) != st.gst(v)){
			su.unite(u, v);
			edg[u].push_back({v, e[i].first});
			edg[v].push_back({u, e[i].first});
		}
	}
	for(int i = 1; i < n; ++i){
		cout << ans[i] << endl;
	}
}	
