#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;
v<bool> was;
v<v<pa<ll, ll>>> children;
v<bool> dpv[4];
v<ll> parent;
v<v<pa<pa<ll, ll>, pa<ll, ll>>>> ans[4];
v<v<ll>> childmask[4];
v<bool> dp_was[4];

void build_tree(ll vert, ll cparent) {
	if (!was[vert]) {
		was[vert] = true;
		parent[vert] = cparent;
		for (auto [overt, mask] : graph[vert]) {
			if (overt != cparent) {
				children[vert].push_back({ overt, mask });
				build_tree(overt, vert);
			}
		}
	}
}

ll get_reverse_mask(ll mask) {
	ll rmask = 0;
	if (mask & 1) {
		rmask |= 2;
	}
	if (mask & 2) {
		rmask |= 1;
	}
	return rmask;
}

bool dp(ll vert, ll mask) {
	if (dp_was[mask][vert]) {
		return dpv[mask][vert];
	}
	else {
		dp_was[mask][vert] = true;
		childmask[mask][vert] = v<ll>(children[vert].size());
		map<ll, ll> v2c;
		for (ll i = 0; i < children[vert].size(); ++i) {
			v2c[children[vert][i].first] = i;
		}
		v<ll> from, to, both;
		if (mask != 0) {
			ll rmask = get_reverse_mask(mask);
			if (rmask & 1) {
				from.push_back(parent[vert]);
			}
			else if (rmask & 2) {
				to.push_back(parent[vert]);
			}
		}
		for (auto [overt, omask] : children[vert]) {
			bool can_wo;
			bool can_both;
			if (omask == 3) {
				can_wo = false;
				can_both = dp(overt, 0);
			}
			else {
				can_wo = dp(overt, omask);
				can_both = false;
			}
			bool can_from;
			if (omask & 1) {
				can_from = dp(overt, omask ^ 1);
			}
			else {
				can_from = false;
			}
			bool can_to;
			if (omask & 2) {
				can_to = dp(overt, omask ^ 2);
			}
			else {
				can_to = false;
			}
			if (!can_wo && !can_both && !can_from && !can_to) {
				return dpv[mask][vert] = false;
			}
			else if (can_both) {
				ans[mask][vert].push_back({ {overt, vert}, {vert, overt} });
				childmask[mask][vert][v2c[overt]] = 0;
			}
			else if (!can_wo) {
				if (can_from && can_to) {
					both.push_back(overt);
				}
				else if (can_from) {
					from.push_back(overt);
				}
				else if (can_to) {
					to.push_back(overt);
				}
			}
			else {
				childmask[mask][vert][v2c[overt]] = omask;
			}
		}
		if (from.size() > to.size()) {
			ll diff = from.size() - to.size();
			if (both.size() >= diff) {
				bool can = dpv[mask][vert] = ((both.size() - diff) & 1) == 0;
				if (can) {
					for (ll i = 0; i < to.size(); ++i) {
						ans[mask][vert].push_back({ {to[i], vert}, {vert, from[i]} });
						if (from[i] != parent[vert]) {
							childmask[mask][vert][v2c[from[i]]] = children[vert][v2c[from[i]]].second ^ 1;
						}
						if (to[i] != parent[vert]) {
							childmask[mask][vert][v2c[to[i]]] = children[vert][v2c[to[i]]].second ^ 2;
						}
					}
					for (ll i = 0; i < diff; ++i) {
						ans[mask][vert].push_back({ {both[i], vert}, {vert, from[to.size() + i]} });
						if (from[to.size() + i] != parent[vert]) {
							childmask[mask][vert][v2c[from[to.size() + i]]] = children[vert][v2c[from[to.size() + i]]].second ^ 1;
						}
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i]]] = children[vert][v2c[both[i]]].second ^ 2;
						}
					}
					for (ll i = diff; i < both.size(); i += 2) {
						ans[mask][vert].push_back({ {both[i], vert}, {vert, both[i + 1]} });
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i]]] = children[vert][v2c[both[i]]].second ^ 2;
						}
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i + 1]]] = children[vert][v2c[both[i + 1]]].second ^ 1;
						}
					}
				}
				return can;
			}
			else {
				return false;
			}
		}
		else {
			ll diff = to.size() - from.size();
			if (both.size() >= diff) {
				bool can = dpv[mask][vert] = ((both.size() - diff) & 1) == 0;
				if (can) {
					for (ll i = 0; i < from.size(); ++i) {
						ans[mask][vert].push_back({ {to[i], vert}, {vert, from[i]} });
						if (from[i] != parent[vert]) {
							childmask[mask][vert][v2c[from[i]]] = children[vert][v2c[from[i]]].second ^ 1;
						}
						if (to[i] != parent[vert]) {
							childmask[mask][vert][v2c[to[i]]] = children[vert][v2c[to[i]]].second ^ 2;
						}
					}
					for (ll i = 0; i < diff; ++i) {
						ans[mask][vert].push_back({ {to[from.size() + i], vert}, {vert, both[i]} });
						if (to[from.size() + i] != parent[vert]) {
							childmask[mask][vert][v2c[to[from.size() + i]]] = children[vert][v2c[to[from.size() + i]]].second ^ 2;
						}
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i]]] = children[vert][v2c[both[i]]].second ^ 1;
						}
					}
					for (ll i = diff; i < both.size(); i += 2) {
						ans[mask][vert].push_back({ {both[i], vert}, {vert, both[i + 1]} });
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i]]] = children[vert][v2c[both[i]]].second ^ 2;
						}
						if (both[i] != parent[vert]) {
							childmask[mask][vert][v2c[both[i + 1]]] = children[vert][v2c[both[i + 1]]].second ^ 1;
						}
					}
				}
				return can;
			}
			else {
				return false;
			}
		}
	}
}

v<pa<pa<ll, ll>, pa<ll, ll>>> ansres;

void build_ans(ll vert, ll mask) {
	for (pa<pa<ll, ll>, pa<ll, ll>> p : ans[mask][vert]) {
		ansres.push_back(p);
	}
	for (ll i = 0; i < children[vert].size(); ++i) {
		build_ans(children[vert][i].first, childmask[mask][vert][i]);
	}
}

int main() {
	ll n, m;
	cin >> n >> m;
	map<pa<ll, ll>, bool> edges;
	for (ll i = 0; i < m; ++i) {
		ll ui, vi;
		cin >> ui >> vi;
		--ui;
		--vi;
		if (edges.find({ vi, ui }) == edges.end()) {
			edges[{ui, vi}] = false;
		}
		else {
			edges[{vi, ui}] = true;
		}
	}
	graph = v<v<pa<ll, ll>>>(n);
	for (auto [edg, has_opposite] : edges) {
		auto [a, b] = edg;
		ll mask = 1;
		if (has_opposite) {
			mask = 3;
		}
		graph[a].push_back({ b, mask });
		ll rmask = 2;
		if (has_opposite) {
			rmask = 3;
		}
		graph[b].push_back({ a, rmask });
	}
	children = v<v<pa<ll, ll>>>(n);
	parent = v<ll>(n);
	was = v<bool>(n);
	v<ll> roots;
	for (ll i = 0; i < n; ++i) {
		if (!was[i]) {
			roots.push_back(i);
			build_tree(i, -1);
		}
	}
	fill(dpv, dpv + 4, v<bool>(n));
	fill(ans, ans + 4, v<v<pa<pa<ll, ll>, pa<ll, ll>>>>(n));
	fill(childmask, childmask + 4, v<v<ll>>(n));
	fill(dp_was, dp_was + 4, v<bool>(n));
	bool can = true;
	for (ll i = 0; i < roots.size(); ++i) {
		if (!dp(roots[i], 0)) {
			can = false;
			break;
		}
	}
	if (can) {
		cout << "Yes\n";
		for (ll i = 0; i < roots.size(); ++i) {
			build_ans(roots[i], 0);
		}
		for (ll i = 0; i < ansres.size(); ++i) {
			auto [x, y] = ansres[i];
			auto [xa, xb] = x;
			auto [ya, yb] = y;
			cout << (xa + 1) << ' ' << (xb + 1) << ' ' << (ya + 1) << ' ' << (yb + 1) << '\n';
		}
	}
	else {
		cout << "No";
	}
}