#pragma GCC optimeze("Ofast")
#pragma GCC target("avx2")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;

v<ll> res;

void dfs(ll vert, ll parent, ll L = -1, ll R = -1) {
	if (L != -1) {
		res[vert] = L + R;
	}
	for (auto [overt, t] : graph[vert]) {
		if (overt != parent) {
			ll nL, nR;
			if (L == -1) {
				nL = nR = t;
			}
			else {
				nL = min(L, t);
				nR = max(R, t);
			}
			dfs(overt, vert, nL, nR);
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	graph = v<v<pa<ll, ll>>>(n);
	for (ll i = 0; i < n; ++i) {
		ll ui, vi, ti;
		cin >> ui >> vi >> ti;
		--ui;
		--vi;
		graph[ui].push_back({ vi, ti });
		graph[vi].push_back({ ui, ti });
	}
	res = v<ll>(n);
	//dfs(0, -1);
	for (ll i = 1; i < n; ++i) {
		cout << res[i] << '\n';
	}
}