#pragma GCC optimeze("Ofast")
#pragma GCC target("avx2")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>

using namespace std;

using ll = int;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;

v<ll> res;

void dfs(ll vert, ll parent, ll L = -1, ll R = -1) {
	if (L != -1) {
		res[vert] = L + R;
	}
	for (auto [overt, t] : graph[vert]) {
		if (overt != parent) {
			ll nL, nR;
			if (L == -1) {
				nL = nR = t;
			}
			else {
				nL = min(L, t);
				nR = max(R, t);
			}
			dfs(overt, vert, nL, nR);
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	graph = v<v<pa<ll, ll>>>(n);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi, ti;
		cin >> ui >> vi >> ti;
		--ui;
		--vi;
		graph[ui].push_back({ vi, ti });
		graph[vi].push_back({ ui, ti });
	}
	v<bool> was(n);
	v<ll> dist(n);
	priority_queue<pa<ll, ll>, v<pa<ll, ll>>, greater<pa<ll, ll>>> q;
	q.push({ 0, 0 });
	while (!q.empty()) {
		auto [ma, vert] = q.top();
		q.pop();
		if (!was[vert]) {
			was[vert] = true;
			dist[vert] = ma;
			for (auto [overt, t] : graph[vert]) {
				ll nma = max(ma, t);
				q.push({ nma, overt });
			}
		}
	}
	for (ll i = 1; i < n; ++i) {
		cout << dist[i] << '\n';
	}
}