#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

long long n, m;
vector<vector<pair<long long, long long>>> graph;

int main()
{
	cin >> n >> m;
	graph.resize(n);
	
	vector<long long> T;
	for (long long i = 0; i < m; ++i)
	{
		long long a, b, t; cin >> a >> b >> t; --a; --b;
		graph[a].emplace_back(b, t);
		graph[b].emplace_back(a, t);
		T.push_back(t);
	}
	sort(T.begin(), T.end());
	T.erase(unique(T.begin(), T.end()), T.end());

	for (auto& i : graph)
		for (auto& j : i)
			j.second = lower_bound(T.begin(), T.end(), j.second) - T.begin();

	long long k = T.size();

	vector<vector<long long>> res(n, vector<long long>(k, -1));
	res[0][k - 1] = 0;

	for (long long i = 1; i < n; ++i)
	{
		for (auto&j: graph[i])
			if (j.first == i - 1)
			{
				long long t = j.second;
				for (long long l = 0; l < k; ++l)
					if (res[i - 1][l] != -1)
					{
						long long vala = min(l, t), valb = max(res[i - 1][l], t);
						if (res[i][vala] == -1) res[i][vala] = valb;
						res[i][vala] = min(res[i][vala], valb);
					}
			}
	}

	for (long long i = 1; i < n; ++i)
	{
		long long ress = 2 * (long long)(1e9) + 2;
		for (long long j = 0; j < k; ++j)
			if (res[i][j] != -1)
				ress = min(ress, T[j] + T[res[i][j]]);
		cout << ress << '\n';
	}

	return 0;
}