#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <functional>
#include <map>
#include <bitset>
#include <utility>
#include <cstring>
#include <algorithm>
#include <chrono>
#include <random>

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define mp make_pair
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define ppb pop_back()
#define all(x) x.begin(),x.end()
#define siz(x) (int)x.size()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;


template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef vector<int> vi;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<char> vch;
typedef vector<pii> vpii;
typedef vector<vi> vvi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int K = 26;
const int INF = 4e18;
int pw[14];

int val(int i) {
	if (i & 1) return val(i - 1) * 5;
	return pw[i / 2];
}

void solve() {
	str s;
	cin >> s;
	int n = s.size();
	reverse(all(s));
	//dbg(s);
	vvi dp(n, vi(K, -INF));
	vvi pr(n, vi(K, -1));
	vvi lol(n, vi(K, -1));

	for (int f = 0; f < K; ++f) {
		if (s[0] == '?' || s[0] == char(f + 'A')) {
			dp[0][f] = val(f);
			lol[0][f] = f;
		}
	}
	//dbg(dp[0][2]);
	for (int i = 1; i < n; ++i) {
		//dbg(i);
		for (int f = 0; f < K; ++f) {
			if (s[i] != '?' && s[i] != char(f + 'A')) continue;
			//dbg(f);
			int vf = val(f);
			for (int s = 0; s < K; ++s) {
				if (s > f) {
					if (dp[i][s] < dp[i - 1][s] - vf) {
						dp[i][s] = dp[i - 1][s] - vf;
						pr[i][s] = s;
						lol[i][s] = f;
					}
				} else {	
					if (dp[i][f] < dp[i - 1][s] + vf) {
						dp[i][f] = dp[i - 1][s] + vf;
						pr[i][f] = s;
						lol[i][f] = f;
					}
				}
			}
		}
	}
	//fi(0, n) //dbg(dp[i][2]);
	int from = 0;
	for (int i = 0; i < K; ++i) {
		if (dp[n - 1][i] > dp[n - 1][from]) {
			from = i;
		}
	}
	str ans;
	cout << dp[n - 1][from] << '\n';
	for (int i = n - 1; i >= 0; --i) {
		ans += char('A' + lol[i][from]);
		from = pr[i][from];
	}	
	cout << ans << '\n';
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	pw[0] = 1;
	fi(1, 14) pw[i] = 10 * pw[i - 1];  
	int t;
	cin >> t;
	while (t--) solve();
}
