#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>
#include <queue>
#include <set>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll n, m;
vector<vector<pair<ll, ll>>> gr;

bool used[SZ];
ll ans[SZ];
ll dist[SZ][2];

void dfs(int v, pair<int, int> vl = make_pair(INF, -INF)) {
	used[v] = 1;

	ans[v] = vl.first + vl.second;
	for (auto to : gr[v]) {
		if (!used[to.first]) {
			pair<int, int> nw = vl;
			nw.first = min(nw.first, to.second);
			nw.second = max(nw.second, to.second);
			dfs(to.first, nw);
		}
	}
}

const ll KST = 1000000000;

signed main() {
	fastInp;

	cin >> n >> m;

	gr.resize(n);
	for (int i = 0; i < m; i++) {
		ll u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		gr[u].push_back({ v, t });
		gr[v].push_back({ u, t });
	}

	set<tuple<ll, ll, ll>> st;
	for (int k = 0; k < 2; k++) {
		for (int i = 1; i < n; i++) dist[i][k] = INF;
		dist[0][1] = INF;
		for (int i = 0; i < n; i++) st.insert({ dist[i][k], i, k });
	}

	while (!st.empty()) {
		tuple<ll, ll, ll> cur = (*st.begin());
		ll v = get<1>(cur), k = get<2>(cur), dst = get<0>(cur);
		st.erase(st.begin());

		if (k == 0) {
			for (auto to : gr[v]) {
				if (dist[to.first][0] > dst) {
					st.erase({ dist[to.first][0], to.first, 0 });
					dist[to.first][0] = dst;
					st.insert({ dist[to.first][0], to.first, 0 });
				}
			}

			for (auto to : gr[v]) {
				if (dist[to.first][1] > dst + to.second) {
					st.erase({ dist[to.first][1], to.first, 1 });
					dist[to.first][1] = dst + to.second;
					st.insert({ dist[to.first][1], to.first, 1 });
				}
			}
		}
		else {
			for (auto to : gr[v]) {
				if (dist[to.first][1] > dst) {
					st.erase({ dist[to.first][1], to.first, 1 });
					dist[to.first][1] = dst;
					st.insert({ dist[to.first][1], to.first, 1 });
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		cout << dist[i][1] + KST << "\n";
	}

	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/