#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
#pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> X(n), H(n);
    for (int i = 0; i < n; ++i) {
        cin >> X[i] >> H[i];
    }
    //
    vector<vector<int>> G(n);
    vector<int> l_cnt(n, 0), r_cnt(n, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (j < i && X[j] > X[i] - H[i]) {
                G[j].push_back(i);
                ++l_cnt[i];
            }
            if (j > i && X[j] < X[i] + H[i]) {
                G[j].push_back(i);
                ++r_cnt[i];
            }
        }
    }
    //
    for (int _ = 0; _ < q; ++_) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        queue<int> Q;
        vector<int> used(n, 0);
        vector<int> l_cnt2(n, 0), r_cnt2(n, 0);
        for (int i = l; i <= r; ++i) {
            if (l_cnt[i] == 0 && X[i] - H[i] >= X[0]) {
                Q.push(i);
                used[i] = 1;
            } else if (r_cnt[i] == 0 && X[i] + H[i] <= X[n - 1]) {
                Q.push(i);
                used[i] = 1;
            }
        }
        //
        while (!Q.empty()) {
            int i = Q.front();
            Q.pop();
            for (int j : G[i]) {
                if (used[j] || j < l || r < j) {
                    continue;
                }
                if (i < j) {
                    ++l_cnt2[j];
                    if (l_cnt2[j] == l_cnt[j] && X[j] - H[j] >= X[0]) {
                        Q.push(j);
                        used[j] = 1;
                    }
                } else {
                    ++r_cnt2[j];
                    if (r_cnt2[j] == r_cnt[j] && X[j] + H[j] <= X[n - 1]) {
                        Q.push(j);
                        used[j] = 1;
                    }
                }
            }
        }
        cout << accumulate(used.begin(), used.end(), 0) << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}