#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXM = 10;
pair<int, int> E[MAXM];
int T[MAXM];
vector<int> res(MAXM, inf * 2);


void f(vector<int> order) {
    int last = 0;
    int mn = inf, mx = 0;
    for (int i : order) {
        mn = min(mn, T[i]);
        mx = max(mx, T[i]);
        if (E[i].first == last) {
            last = E[i].second;
        } else if (E[i].second == last) {
            last = E[i].first;
        } else {
            return;
        }
        res[last] = min(res[last], mn + mx);
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> E[i].first >> E[i].second >> T[i];
        --E[i].first;
        --E[i].second;
    }
    vector<int> order(m);
    iota(order.begin(), order.end(), 0);
    do {
        f(order);
    } while (next_permutation(order.begin(), order.end()));
    for (int v = 1; v < n; ++v) {
        cout << res[v] << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}