#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int inf = 1e9;

vector < long long > x;
vector < long long > fall;

bool comp(int i, int j) {
	if (fall[i] == fall[j]) return x[i] < x[j];
	return fall[i] < fall[j];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;
	x.assign(n, 0);
	vector < long long > h(n);
	for (int i = 0; i < n; i++) cin >> x[i] >> h[i];

	if (n == 1) {
		for (int i = 0; i < q; i++) {
			int l, r;
			cin >> l >> r;
			cout << "0\n";
		}
		return 0;
	}

	vector < int > left(n);
	vector < int > right(n);
	for (int i = 0; i < n; i++) {
		int id = i;
		while (id > 0 && x[i] - x[id - 1] < h[i]) id--;
		left[i] = id;
		id = i;
		while (id < n - 1 && x[id + 1] - x[i] < h[i]) id++;
		right[i] = id;
	}

	for (int j = 0; j < q; j++) {
		int l, r;
		cin >> l >> r;
		l--; r--;

		vector < int > ln(n);
		vector < int > rn(n);
		for (int i = 0; i < n; i++) {
			ln[i] = rn[i] = i;
			if (i > 0) ln[i] = i - 1;
			if (i < n - 1) rn[i] = i + 1;
		}

		int res = 0;
		vector < bool > used(n, false);

		for (int t = 1; t <= r - l + 1; t++) {
			for (int i = l; i <= r; i++) {
				if (used[i]) continue;
				if (left[i] >= l) {
					if (x[i] - x[ln[i]] >= h[i]) {
						res++;
						used[i] = true;
						ln[rn[i]] = ln[i];
						rn[ln[i]] = rn[i];
					}
				}
				else if (right[i] <= r) {
					if (x[rn[i]] - x[i] >= h[i]) {
						res++;
						used[i] = true;
						ln[rn[i]] = ln[i];
						rn[ln[i]] = rn[i];
					}
				}
			}
		}
		cout << res << "\n";
	}
}
