#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 2001;

vi g[N];
vi t[N];
int ans[N];

set <pii> br;

int up[N], d[N];
bool was[N], used[N];
pair <pii, int> e[N];

void find_bridges(int v, int p) {
    d[v] = d[p] + 1;
    used[v] = true;
    up[v] = d[v];
    int cnt = 0;

    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];
        if (u == p) {
            cnt++; continue;
        }
        if (used[u]) {
            up[v] = min(up[v], d[u]);
        } else {
            find_bridges(u, v);
            up[v] = min(up[u], up[v]);
        }
    }

    //cout << "v: " << v << " " << d[v] << " " << up[v] << endl;

    if (up[v] == d[v] && cnt == 1 && p != 0)
        br.insert(mp(p, v));
}

int clr[N];

void paint(int v, int c) {
    was[v] = true;
    clr[v] = c;
    for (int i : g[v]) {
        if (!was[i] && br.find(mp(v, i)) == br.end() && br.find(mp(i, v)) == br.end())
            paint(i, c);
    }
}

vi g2[N];
vi t2[N];
int cans[N];

void dfs2(int v, int p, int mn) {
    cans[v] = min(cans[v], mn);
    for (int i = 0; i < g2[v].size(); i++) {
        int u = g2[v][i], c = t2[v][i];
        if (u == p) continue;
        dfs2(u, v, min(cans[v], c));
    }
}

void solve_for_mx(int n, int m, int C) {
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        t[i].clear();
        g2[i].clear();
        t2[i].clear();
    }
    br.clear();

    for (int i = 0; i < m; i++) {
        int x = e[i].fi.fi, y = e[i].fi.se, tt = e[i].se;
        g[x].pb(y); t[x].pb(tt);
        g[y].pb(x); t[y].pb(tt);
        e[i] = mp(mp(x, y), tt);
    }

    fill(used, used + N, false);
    find_bridges(1, 0);

    int cc = 0;
    fill(was, was + N, false);
    for (int i = 1; i <= n; i++) {
        if (!was[i] && used[i]) {
            cc++;
            paint(i, cc);
        }
    }

    fill(cans, cans + N, 2e9);
    for (int i = 0; i < m; i++) {
        auto p = e[i];
        if (!used[p.fi.fi] || !used[p.fi.se]) continue;
        if (clr[p.fi.fi] == clr[p.fi.se]) {
            cans[clr[p.fi.fi]] = min(cans[clr[p.fi.fi]], p.se);
        } else {
            g2[clr[p.fi.fi]].pb(clr[p.fi.se]);
            t2[clr[p.fi.fi]].pb(p.se);
            g2[clr[p.fi.se]].pb(clr[p.fi.fi]);
            t2[clr[p.fi.se]].pb(p.se);
        }
    }

    dfs2(1, 0, 2e9);

    //for (auto p : br)
    //    cout << p.fi << ' ' << p.se << endl;

    for (int i = 2; i <= n; i++) {
        if (used[i])
            ans[i] = min(ans[i], cans[clr[i]] + C);
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x, y, tt; cin >> x >> y >> tt;
        e[i] = mp(mp(x, y), tt);
    }

    sort(e, e + m, [](pair <pii, int> i, pair <pii, int> j) {
        return (i.se < j.se);
    });
    fill(ans, ans + N, 2e9 + 100);

    for (int i = 0; i < m; i++) {
        solve_for_mx(n, i + 1, e[i].se);
        if (br.empty()) break;
    }

    for (int i = 2; i <= n; i++)
        cout << ans[i] << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
