#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

void dfs(int u, int par, vector <int>& used, vector <vector <int>>& w, vector <pair <int, int>>& eg, vector <int>& h, int depth) {
	h[u] = depth;
	used[u] = true;
	for (auto ind : w[u]) {
		int v = (eg[ind].first == u ? eg[ind].second : eg[ind].first);
		if (v == par) continue;
		dfs(v, u, used, w, eg, h, depth + 1);
	}
}

bool kunh(int u, vector <vector <int>>& w, vector <int>& used, vector <int>& mt) {
	if (used[u]) {
		return false;
	}
	used[u] = true;
	for (int v : w[u]) {
		if (mt[v] == -1 || kunh(mt[v], w, used, mt)) {
			mt[v] = u;
			return true;
		}
	}
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <pair <int, int>> eg(m);
	for (int i = 0; i < m; ++i) {
		cin >> eg[i].first >> eg[i].second;
		--eg[i].first;
		--eg[i].second;
	}
	vector <vector <int>> egIn(n), egOut(n);
	for (int i = 0; i < m; ++i) {
		egIn[eg[i].first].push_back(i);
		egOut[eg[i].second].push_back(i);
	}
	vector <int> used1(n);
	vector <int> h(n);
	for (int i = 0; i < n; ++i) {
		if (used1[i] == 0) dfs(i, i, used1, egIn, eg, h, 0);
	}
	vector <vector <int>> w2(m);
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			if (h[eg[i].first] % 2 == 0 && h[eg[j].first] % 2 == 1 && (eg[i].second == eg[j].first || eg[j].second == eg[i].first)) {
				w2[i].push_back(j);
			}
		}
	}
	vector <int> used(m, 0), mt(m, -1);
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		bool ok = true;
		for (int j = 0; j < m; ++j) {
			if (mt[j] == i) ok = false;
		}
		if (ok) {
			used.assign(m, 0);
			if (kunh(i, w2, used, mt)) ++ans;
		}
	}
	if (ans == m / 2) {
		cout << "Yes\n";
		for (int j = 0; j < m; ++j) {
			if (mt[j] != -1) {
				int u2 = eg[j].first;
				int v2 = eg[j].second;
				int i = mt[j];
				int u1 = eg[i].first;
				int v1 = eg[i].second;
				cout << u1 + 1 << " " << v1 + 1 << " " << u2 + 1 << " " << v2 + 1 << "\n";
			}
		}
	}
	else {
		cout << "No\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}