#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

void dfs(int u, int par, vector <vector <int>>& w, vector <int>& p) {
	p[u] = par;
	for (int v : w[u]) {
		if (v != par) {
			dfs(v, u, w, p);
		}
	}
}

int getLCA(int u, int v, vector <int> p) {
	set <int> st;
	int i = u;
	for (; p[i] != i; i = p[i]) {
		st.insert(i);
	}
	for (int j = v; j != 0; j = p[j]) {
		if (st.find(j) != st.end()) {
			return j;
		}
	}
	return i;
}


void solve() {
	int n, m;
	cin >> n >> m;
	vector <pair <int, int>> eg(m);
	vector <vector <int>> w(n);
	map <pair <int, int>, int> mp;
	for (int i = 0; i < m; ++i) {
		cin >> eg[i].first >> eg[i].second;
		--eg[i].first;
		--eg[i].second;
		mp[{eg[i].first, eg[i].second}] = i;
		w[eg[i].first].push_back(eg[i].second);
		w[eg[i].second].push_back(eg[i].first);
	}
	vector <int> unpair;
	for (int i = 0; i < m; ++i) {
		if (mp.find({ eg[i].second, eg[i].first }) == mp.end()) {
			unpair.push_back(i);
		}
	}
	if (unpair.empty()) {
		cout << "Yes\n";
		set <pair <int, int>> printed;
		for (int i = 0; i < m; ++i) {
			if (printed.find(eg[i]) == printed.end()) {
				cout << eg[i].first + 1 << " " << eg[i].second + 1 << " " << eg[i].second + 1 << " " << eg[i].first + 1 << "\n";
				printed.insert(eg[i]);
				printed.insert({ eg[i].second, eg[i].first });
			}
		}
		return;
	}
	vector <int> p(n);
	dfs(0, 0, w, p);
	auto v1 = eg[unpair[0]];
	auto v2 = eg[unpair[1]];
	if (p[v2.first] == v2.second) {
		swap(v1, v2);
	}
	dfs(v1.first, v1.first, w, p);
	bool rev = p[v2.second] != v2.first;
	vector <int> path1;
	for (int i = (p[v2.second] == v2.first ?v2.second : v2.first); i != v1.first; i = p[i]) {
		path1.push_back(i);
	}
	path1.push_back(v1.first);
	reverse(path1.begin(), path1.end());
	if (path1.size() < 3 || rev == 0 && path1.size() % 2 == 0 || rev == 1 && path1.size() % 2 == 1) {
		cout << "No\n";
		return;
	}
	for (int i = 0; i + 2 < path1.size(); ++i) {
		if (rev == 0 || i % 2 == 0) {
			if (mp.find({ path1[i], path1[i + 1] }) == mp.end() || mp.find({ path1[i + 1], path1[i + 2] }) == mp.end() || path1.size() < 3) {
				cout << "No\n";
				return;
			}
		}
		else {
			if (mp.find({ path1[i + 1], path1[i] }) == mp.end() || mp.find({ path1[i + 2], path1[i + 1] }) == mp.end() || path1.size() < 3) {
				cout << "No\n";
				return;
			}
		}
	}
	cout << "Yes\n";
	set <pair <int, int>> printed;
	for (int i = 0; i + 2 < path1.size(); ++i) {
		if (rev && i % 2 == 1) {
			cout << path1[i + 2] + 1 << " " << path1[i + 1] + 1 << " " << path1[i + 1] + 1 << path1[i] + 1 << "\n";

		}
		else {
			cout << path1[i] + 1 << " " << path1[i + 1] + 1 << " " << path1[i + 1] + 1 << " " << path1[i + 2] + 1 << "\n";
		}
		printed.insert({ path1[i], path1[i + 1] });
		printed.insert({ path1[i + 1], path1[i + 2] });
		printed.insert({ path1[i + 2], path1[i + 1] });
		printed.insert({ path1[i + 1], path1[i] });
	}
	for (int i = 0; i < m; ++i) {
		if (printed.find(eg[i]) == printed.end()) {
			cout << eg[i].first + 1 << " " << eg[i].second + 1 << " " << eg[i].second + 1 << " " << eg[i].first + 1 << "\n";
			printed.insert(eg[i]);
			printed.insert({ eg[i].second, eg[i].first });
		}
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}