#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long
const int INF = 1e10;
struct base {
	int u, v, cost;
	base() { u = 0, v = 0, cost = 0; }
	base(int u, int v, int cost) : u(u), v(v), cost(cost) {};
};

int get(int u, vector <int>& p) {
	return p[u] == u ? u : p[u] = get(p[u], p);
}

void unite(int u, int v, vector <int>& p, vector <int>& sz, vector <vector <int>>& mnozh) {
	u = get(u, p);
	v = get(v, p);
	if (u == v) return;
	if (sz[u] > sz[v]) {
		swap(u, v);
	}
	p[u] = v;
	for (auto i : mnozh[u]) {
		mnozh[v].push_back(i);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <base>> w(n);
	vector <base> eg(m);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].emplace_back(u, v, cost);
		w[v].emplace_back(v, u, cost);
		eg[i] = base(u, v, cost);
	}
	sort(eg.begin(), eg.end(), [](base lhs, base rhs) { return lhs.cost < rhs.cost; });
	set <pair <int, int>> st;
	vector <int> ans(n, INF);
	ans[0] = 0;
	st.insert({ 0, 0 });
	while (!st.empty()) {
		int u = (*st.begin()).second;
		st.erase(st.begin());
		for (auto vt : w[u]) {
			int nd = max(ans[u], vt.cost);
			if (ans[vt.v] > nd) {
				st.erase({ ans[vt.v], vt.v });
				ans[vt.v] = nd;
				st.insert({ ans[vt.v], vt.v });
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}