#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

#define err(x) cerr << "["#x"]  " << (x) << '\n';
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::

struct dsu {
    int n;
    vector<int> p, sz;

    dsu(int n) : n(n), p(n), sz(n, 1) {
        iota(p.begin(), p.end(), 0);
    }

    int find(int v) {
        return p[v] == v ? v : (p[v] = find(p[v]));
    }

    bool unite(int a, int b) {
        a = find(a);
        b = find(b);
        if (a != b) {
            if (sz[a] < sz[b])
                swap(a, b);
            sz[a] += sz[b];
            p[b] = a;
        }
        return a != b;
    }
};

const int N = 3e5 + 3, INF = 1e9 + 7;

int t[N], res[N];
vector<pair<int, int>> graph[N], tr[N];

void dfs(int v, int mn, int mx, int p = -1) {
    res[v] = mn + mx;
    for (auto [to, i] : tr[v]) {
        if (to == p) continue;

        dfs(to, min(mn, t[i]), max(mx, t[i]), v);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector<tuple<int, int, int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        --x; --y;

        t[i] = w;
        graph[x].emplace_back(y, i);
        graph[y].emplace_back(x, i);
        edges.emplace_back(w, x, y, i);
    }
    sort(edges.begin(), edges.end());

    dsu uni(n);
    for (int i = 0; i < m; ++i) {
        auto [w, x, y, ind] = edges[i];
        if (uni.unite(x, y)) {
            tr[x].emplace_back(y, ind);
            tr[y].emplace_back(x, ind);
        }
    }

    dfs(0, INF, -INF);
    for (int i = 1; i < n; ++i)
        cout << res[i] << ' ';
    cout << '\n';
}

/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

