#include <bits/stdc++.h>
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define mp std::make_pair
typedef long long ll;
const int N = 2000 + 10, K = 26, INF = 1e9, M = 3e5 + 100;
struct edge
{
    int from;
    int to;
    int cost;
    int i;
};
std::vector<edge> g[N];
int h[N];
bool isBridge[M];
int used[N];
void findBridge(int v, int p = -1) {
    used[v] = 1;
    for (auto e : g[v]) {
        if (!used[e.to]) {
            findBridge(e.to, e.i);
            h[v] += h[e.to];
        }
        else if (used[e.to] == 1 && e.i != p) {
            // debug(v + 1 << ' ' << e.to + 1 << ' ' << e.i)
            h[v]++;
            h[e.to]--;
        }
    }
    if (h[v] == 0 && p != -1) {
        isBridge[p] = 1;
    }
    // debug(v + 1 << ' ' << h[v])
    used[v] = 2;
}
int cycCount = 0;
int inCyc[N];
std::vector<edge> compressedEdges[N];
void compress(int v) {
    used[v] = 1;
    // debug(v << ' ' << cycCount)
    inCyc[v] = cycCount;
    for (auto e : g[v]) {
        if (!isBridge[e.i] && !used[e.to]) {
            compress(e.to);
        }
    }
}
ll minCompress[N];
int minCyc[N];
void findMinCompress(int v, int p = -1) {
    minCompress[v] = std::min(minCompress[v], (ll)minCyc[v]);
    for (auto e : compressedEdges[v]) {
        if (e.to == p) continue;
        minCompress[e.to] = std::min(minCompress[v], (ll)e.cost);
        findMinCompress(e.to, v);
    }
}
void findMinCyc(int v) {
    used[v] = 1;
    for (auto e : g[v]) {
        if (!isBridge[e.i] && !used[e.to]) {
            findMinCyc(e.to);
        }
        if (!isBridge[e.i]) {
            minCyc[inCyc[v]] = std::min(minCyc[inCyc[v]], e.cost);
        }
    }
}
ll answ[N];
int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int n, m;
    std::cin >> n >> m;
    std::vector<edge> edges;
    FOR(i, m) {
        int a, b, c;
        std::cin >> a >> b >> c;
        --a; --b;
        // g[a].pb({a, b, c, i});
        // g[b].pb({b, a, c, i});
        edges.pb({a, b, c, i});
    }
    std::sort(edges.begin(), edges.end(), [](auto e1, auto e2) {
        return e1.cost < e2.cost;
    }); 
    FOR(i, n) {
        inCyc[i] = i;
    }
    memset(answ, 0x3f, sizeof(answ));
    FOR(EDGE, m) {
        if (inCyc[edges[EDGE].from] == inCyc[edges[EDGE].to]) {
            debug("SKIp")
            continue;
        }
        g[edges[EDGE].from].pb(edges[EDGE]);
        g[edges[EDGE].to].pb({edges[EDGE].to, edges[EDGE].from, edges[EDGE].cost, edges[EDGE].i});
        memset(h, 0, sizeof(h));
        memset(used, 0, sizeof(used));
        memset(isBridge, 0, sizeof(isBridge));
        cycCount = 0;
        FOR(i, n) {
            compressedEdges[i].clear();
        }
        FOR(i, n) {
            if (!used[i])
                findBridge(i);
        }
        memset(used, 0, sizeof(used));
        FOR(i, n) {
            if (!used[i]) {
                compress(i);
                cycCount++;
            }
        }
        FOR(i, n) {
            for (auto e : g[i]) {
                if (isBridge[e.i]) {
                    compressedEdges[inCyc[i]].pb({inCyc[i], inCyc[e.to], e.cost, e.i});
                }
            }
        }
        memset(minCompress, 0x3f, sizeof(minCompress));
        memset(minCyc, 0x3f, sizeof(minCyc));
        memset(used, 0, sizeof(used));
        FOR(i, n) {
            if (!used[i]) {
                findMinCyc(i);
            }
        }
        findMinCompress(0);
        for (int i = 1; i < n; ++i) {
            // debug(inCyc[i])
            // debug(minCompress[inCyc[i]])
            // debug(minCyc[inCyc[i]])
            answ[i] = std::min(answ[i], minCompress[inCyc[i]] + (int)edges[EDGE].cost);
        }
    }
    FOR(i, n - 1) {
        std::cout << answ[i + 1] << '\n';
    }
}