#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <array>
#include <list>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;
const int inf=2e9;

struct dsu {
	vector<int> p, h;
	vector<bool> act;
	vector<list<int>> l;
	dsu(int n = 0) {
		p.resize(n);
		h.assign(n,0);
		act.assign(n,0);
		l.resize(n);
		for (int i=0; i<n; ++i) {
			p[i]=i; l[i]={i};
		}
	}
	inline int get(int a) {
		return p[a]=(p[a]==a?a:get(p[a]));
	}
	inline void unite(int a, int b) {
		a=get(a); b=get(b);
		act[a]=act[b]=1;
		if (a==b) return;
		if (h[a] > h[b]) {
			l[a].splice(l[a].end(),l[b]);
			p[b]=a;
			h[a]=max(h[a],h[b]+1);
		}
		else {
			l[b].splice(l[b].begin(),l[a]);
			p[a]=b;
			h[b]=max(h[b],h[a]+1);
		}
	}
};

int n, q;
vector<ar<int,2>> a, b;

void solve() {
	cin >> n >> q;
	a.resize(n); b=a;
	for (int i = 0; i < n; ++i) {
		cin >> b[i][0] >> b[i][1];
	}
	for (int i = 0; i < n; ++i) {
		int l=i, r=n;
		while (l + 1 < r) {
			int m=(l+r)/2;
			if (b[m][0]-b[i][0]>=b[i][1]) r=m;
			else l=m;
		}
		a[i][1]=r-i-1;
		if (i==n-1) a[i][1]=inf;
		l=i, r=-1;
		while (l - 1 > r) {
			int m=(l+r)/2;
			if (b[i][0]-b[m][0]>=b[i][1]) r=m;
			else l=m;
		}
		a[i][0]=i-r-1;
		if (i==0) a[i][0]=inf;
		if (!a[i][0] || !a[i][1]) a[i]={0,0};
	}
	vector<int> used(n,0);
	int timer=0;
	for (int i = 0; i < q; ++i) {
		int l, r; cin >> l >> r; --l;
		++timer;
		vector<int> st;
		for (int j = l; j < r; ++j) {
			if (!a[j][0]) st.push_back(j);
		}
		int ans=0;
		dsu row(n);
		while (st.size()) {
			int v=st.back(); st.pop_back();
			if (used[v]==timer) continue;
			used[v]=timer;
			row.act[row.get(v)]=1;
			++ans;
			if (v>l && row.act[row.get(v-1)]) row.unite(v-1,v);
			if (v+1<r && row.act[row.get(v+1)]) row.unite(v,v+1);
			int v1=row.l[row.get(v)].front()-1, v2=row.l[row.get(v)].back()+1;
			if (v1>=l && a[v1][1]<=row.l[row.get(v)].size()) st.push_back(v1);
			if (v2<r && a[v2][0]<=row.l[row.get(v)].size()) st.push_back(v2);
		}
		cout << ans << "\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}