#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 5e5, INF = 1e10;

vector<pair<int, int>> g[MAXN];
vector<pair<int, int>> mg[MAXN];

int tin[MAXN], up[MAXN];
bool used[MAXN];

int height[MAXN], parent[MAXN], dist[MAXN];

inline void init(int n) {
    for (int i = 0; i < n; i++) {
        height[i] = 0;
        parent[i] = i;
        used[i] = false;
        dist[i] = INF;
        mg[i].clear();
        mg[i].shrink_to_fit();
    }
}

int get_parent(int v) {
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = get_parent(parent[v]);
}

inline void merge(int v, int u) {
    v = get_parent(v), u = get_parent(u);
    if (v == u) {
        return;
    }
    if (height[v] == height[u]) {
        height[v]++;
    }
    if (height[v] > height[u]) {
        parent[u] = v;
    } else {
        parent[v] = u;
    }
}

int timer = 0;

int dfs(int v = 0, int prev = -1) {
    tin[v] = up[v] = timer++;
    used[v] = true;
    int x = 0;
    for (auto &[u, w] : g[v]) {
        if (u != prev) {
            if (!used[u]) {
                int y = dfs(u, v);
                up[v] = min(up[v], up[u]);
                if (up[u] <= tin[v] || y > 1) {
                    merge(v, u);
                }
            } else {
                up[v] = min(up[v], tin[u]);
            }
        } else {
            x++;
        }
    }
    return x;
}

void mini_dfs(int v, int prev = -1, int cur_mn = INF) {
//    cout << v << endl;
    cur_mn = min(cur_mn, dist[v]);
    dist[v] = cur_mn;
    for (auto &[u, w] : mg[v]) {
        if (u != prev) {
            mini_dfs(u, v, min(cur_mn, w));
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> h[i];
    }
    vector<int> left(n, -1);
    for (int i = 0; i < n; i++) {
        stack<int> st;
        st.emplace(i);
        for (int j = i - 1; j >= 0; j--) {
            while (!st.empty() && x[j] <= x[st.top()] - h[st.top()]) {
                st.pop();
            }
            if (st.empty()) {
                left[i] = j + 1;
                break;
            }
            if (x[j] + h[j] > x[st.top()]) {
                st.emplace(j);
            }
        }
    }
    vector<int> right(n, n);
    for (int i = n - 1; i >= 0; i--) {
        stack<int> st;
        st.emplace(i);
        for (int j = i + 1; j < n; j++) {
            while (!st.empty() && x[j] >= x[st.top()] + h[st.top()]) {
                st.pop();
            }
            if (st.empty()) {
                right[i] = j - 1;
                break;
            }
            if (x[j] - h[j] < x[st.top()]) {
                st.emplace(j);
            }
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int i = l; i < r; i++) {
            if (left[i] >= l || right[i] < r) {
                ans++;
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/