#include <iostream>
#include<vector>
#include<algorithm>
#include<map>
#include<random>
#include<ctime>

using namespace std;

int my_solve(int n, vector<int>& x, vector<int>& h, int l, int r) {
	int ans = 0;
	vector<int> en;
	en.reserve(n);
	vector<int> used(n + 2);
	for (int i = l; i <= r; ++i) {
		if (used[i] || (h[i] > abs(x[i] - x[i - 1])) && (h[i] > abs(x[i] - x[i + 1])))
			continue;
		used[i] = 1;
		++ans;
		int L = i - 1, R = i + 1;
		if (used[L]) {
			L = en.back();
			en.pop_back();
		}
		while (L >= l || R <= r) {
			if (L >= l && h[L] <= abs(x[L] - x[R])) {
				used[L--] = 1;
				if (L >= l && used[L] == 1) {
					L = en.back();
					en.pop_back();
				}
				ans++;
			}
			else if (R <= r && h[R] <= abs(x[R] - x[L])) {
				used[R++] = 1;
				ans++;
			}
			else
				break;
		}
		en.push_back(L);
	}
	return ans;
}

int stupid(int n, vector<int>& x, vector<int>& h, int l, int r) {
	int ans = 0;
	vector<int> used(n + 2);
	for (int ff = 0; ff < n; ++ff) {
		for (int i = l; i <= r; ++i) {
			if (used[i])
				continue;
			int left = i - 1, right = i + 1;
			for (; left > 0 && used[left]; --left) {}
			if (h[i] <= x[i] - x[left]) {
				used[i] = 1;
				++ans;
				break;
			}
			for (; right <= n && used[right]; ++right) {}
			if (h[i] <= x[right] - x[i]) {
				used[i] = 1;
				++ans;
				break;
			}
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> x(n + 2), h(n + 2); 
	for (int i = 0; i < n; ++i)
		cin >> x[i + 1] >> h[i + 1];
	x[0] = x[1], h[0] = 2e9;
	x[n + 1] = x[n], h[n + 1] = 2e9;
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << my_solve(n, x, h, l, r) << '\n';
	} 
	/*mt19937 gen(0);
	uniform_int_distribution<> uid(1, (int)1e9);
	for (;;) {
		int n = 5, q = 10;
		vector<int> x(n + 2), h(n + 2);
		for (int i = 1; i <= n; ++i) {
			x[i] = x[i - 1] + uid(gen) % 3 + 1;
			h[i] = uid(gen) % 15 + 1;
		}
		x[0] = x[1], h[0] = 2e9;
		x[n + 1] = x[n], h[n + 1] = 2e9;
		while (q--) {
			int l = uid(gen) % n + 1, r = uid(gen) % n + 1;
			if (l > r)
				swap(l, r);
			if (my_solve(n, x, h, l, r) != stupid(n, x, h, l, r)) {
				for (int i : x)
					cout << i << ' ';
				cout << '\n';
				for (int i : h)
					cout << i << ' ';
				cout << '\n';
				cout << l << ' ' << r << '\n';
				cout << my_solve(n, x, h, l, r) << ' ' << stupid(n, x, h, l, r);
				return 0;
			}
		}
	}*/
}