#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>
#include <cmath>
#include <string>
#include <queue>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;


const int ten9 = 1000000000;

const int N = 300300;
struct Edge {
	int to;
	int w;
	int num;
};
int n, m;
vector<Edge>edges;
vector<Edge> g[N];


const int inf = 2e9 + 100;

namespace First {
	int min_on_path[N];
	int max_on_path[N];
	void solve_tree(int v, int p) {
		if (p == -1) min_on_path[v] = inf;
		for (auto e : g[v]) {
			int u = e.to;
			int c = e.w;
			if (u == p) continue;
			min_on_path[u] = min(min_on_path[v], c);
			max_on_path[u] = max(max_on_path[v], c);
			solve_tree(u, v);
		}
	}
	void solve() {
		solve_tree(1, -1);
		for (int v = 2; v <= n; v++) {
			cout << min_on_path[v] + max_on_path[v] << "\n";
		}
	}
}


namespace Forth_Fifth {
	bool dp[30][1 << 21];
	int can_get[1 << 21];
	int ans[30];
	pii q[21 * (1 << 21)];
	void solve() {
		int qh = 0;
		int qe = 0;
		q[qe++] = { 1, 0 };
		dp[1][0] = true;
		while (qh < qe) {
			int v = q[qh].first;
			int mask = q[qh].second;
			qh++;
			dp[v][mask] = true;
			for (auto e : g[v]) {
				if (!(mask & (1 << e.num))) {
					int nmask = mask | (1 << e.num);
					if (!dp[e.to][nmask]) {
						dp[e.to][nmask] = true;
						q[qe++] = { e.to, nmask };
					}
				}
			}
		}
		for (int mask = 0; mask < (1 << m); mask++) {
			int mn = inf;
			int mx = 0;
			for (int i = 0; i < m; i++) {
				if (mask & (1 << i)) {
					mn = min(mn, edges[i].w);
					mx = max(mx, edges[i].w);
				}
			}
			can_get[mask] = mn + mx;
		}

		for (int v = 2; v <= n; v++) {
			ans[v] = inf;
			for (int mask = 0; mask < (1 << m); mask++) {
				if (dp[v][mask]) {
					ans[v] = min(ans[v], can_get[mask]);
				}
			}
		}
		for (int v = 2; v <= n; v++) {
			cout << ans[v] << "\n";
		}
	}
}


namespace Third {
	int dist[N];


	void solve() {
		set<pii> dij;
		for (int v = 1; v <= n; v++) dist[v] = inf;
		dij.insert({ inf, 1 });
		while (dij.size()) {
			int v = dij.begin()->second;
			dij.erase(dij.begin());
			for (auto e : g[v]) {
				int u = e.to;
				int w = e.w;
				if (dist[u] > min(dist[v], w)) {
					dij.erase({ dist[u], u });
					dist[u] = min(dist[v], w);
					dij.insert({ dist[u], u });
				}
			}
		}

		for (int v = 2; v <= n; v++) {
			cout << ten9 + dist[v] << "\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	bool all_out_109 = true;
	rep(i, m) {
		int u, v, t; 
		cin >> u >> v >> t;
		if (u == 1 && t != ten9) {
			all_out_109 = false;
		}
		if (v == 1 && t != ten9) {
			all_out_109 = false;
		}
		edges.pb({v, t, i });
		g[u].pb({ v, t, i });
		g[v].pb({ u, t, i });
	}

	if (m == n - 1) {
		First::solve();
		return 0;
	}

	if (n <= 20 && m <= 20) {
		Forth_Fifth::solve();
		return 0;
	}
	if (all_out_109) {
		Third::solve();
	}
	return 0;
}