#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;

const int MOD = 65521;
const int BASE = 3; 

int add(int a, int b) {
	if (a + b < MOD) {
		return a + b;
	}
	return a + b - MOD;
}

int sub(int a, int b) {
	if (a >= b) {
		return a - b;
	}
	return a - b - MOD;
}

int mul(int a, int b) {
	return 1LL * a * b % MOD;
}

void encode() {
	string s;
	cin >> s;
	int n = (int)s.size();
	cout << s;
	int h = 0;
	for (auto t : s) {
		h = mul(h, BASE);
		h = add(h, t - '0');
	}
	int c = 0;
	for (int i = 0; i < 16; i++) {
		cout << ((h >> i) & 1);
		c += ((h >> i) & 1);
	}
	cout << (c & 1) << endl;
}

void decode() {
	string s;
	cin >> s;
	int n = (int)s.size() - 17;
	{
		int c = 0;
		for (int i = n; i < n + 16; i++) {
			c += (s[i] - '0');
		}
		if ((c & 1) != s[n + 16] - '0') {
			for (int i = 0; i < n; i++) {
				cout << s[i];
			}
			cout << endl;
			return;
		}
	}
	int h = 0;
	for (int i = n; i < n + 16; i++) {
		h += (s[i] - '0') * (1 << (i - n));
	}
	int ch = 0;
	for (int i = 0; i < n; i++) {
		ch = mul(ch, BASE);
		ch = add(ch, s[i] - '0');
	}
	string ans = s.substr(0, n);
	if (h == ch) {
		cout << ans << endl;
		exit(0);
	}
	int cp = 1;
	for (int i = n - 1; i >= 0; i++) {
		ch = sub(ch, mul(cp, s[i] - '0'));
		int nch = add(ch, mul(cp, 1 - (s[i] - '0')));
		if (nch == h) {
			ans[i] = '0' + '1' - ans[i];
			cout << ans << endl;
			return;
		}
		ch = add(ch, mul(cp, s[i] - '0'));
		cp = mul(cp, BASE);
	}
	assert(false);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	if (t == 1) {
		encode();
	} else {
		decode();
	}
}