#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <chrono>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define cap(x) (int)(x).size()
mt19937 rnd(time(0));
vector<int> add(vector<int> a, vector<int> b) {
	while (cap(a) < cap(b)) a.push_back(0);
	while (cap(b) < cap(a)) b.push_back(0);
	int carry = 0, n = cap(a);
	for (int i = 0; i < n; i++) {
		a[i] += b[i] + carry;
		carry = a[i] / 10;
		a[i] %= 10;
	}
	if (carry) a.push_back(carry);
	return a;
}
bool ls(vector<int> a, vector<int> b) {
	if (cap(a) < cap(b)) return true;
	if (cap(a) > cap(b)) return false;
	for (int i = cap(a) - 1; i >= 0; i--) {
		if (a[i] < b[i]) return true;
		else if (a[i] > b[i]) return false;
	}
	return false;
}
vector<int> sub(vector<int> a, vector<int> b, bool& minus) {
	if (ls(a, b)) swap(a, b), minus = true;
	while (cap(a) < cap(b)) a.push_back(0);
	while (cap(b) < cap(a)) b.push_back(0);
	int carry = 0;
	int n = cap(a);
	for (int i = 0; i < n; i++) {
		a[i] -= b[i] + carry;
		carry = 0;
		if (a[i] < 0) a[i] += 10, carry = 1;
	}
	assert(!carry);
	return a;
}
void in(vector<int>& a, bool& minus) {
	string s;
	cin >> s;
	if (s[0] == '-') minus = true, s.erase(s.begin());
	for (char c : s) a.push_back(c - '0');
	reverse(all(a));
}
void out(vector<int> a) {
	while (cap(a) > 1 && a.back() == 0) a.pop_back();
	reverse(all(a));
	for (int i : a) cout << i;
}
void solve() {
	vector<int> a, b;
	bool ma = false, mb = false;
	in(a, ma), in(b, mb);
	if (ma && mb) {
		a = add(a, b);
		cout << '-';
		out(a);
	}
	else if (ma) {
		bool mr = false;
		b = sub(b, a, mr);
		if (mr) cout << '-';
		out(b);
	}
	else if (mb) {
		bool mr = false;
		a = sub(a, b, mr);
		if (mr) cout << '-';
		out(a);
	}
	else {
		a = add(a, b);
		out(a);
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	solve();
	return 0;
}