#include <iostream>
#include <string>
#include <vector>
using namespace std;

/// #include <ext/pb_ds/assoc_container.hpp>
/// using namespace __gnu_pbds;

const int MAXN = 1e5 + 100, MAXL = 17;

int ht[MAXN * 4];
int de_ht[MAXN * 4];

const int MAXF = 5e5;
int tree[4 * MAXF], arr[MAXF], add[4 * MAXF];

void pull(int v) {
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

void push(int v) {
    tree[v] += add[v];
    add[v * 2] += add[v];
    add[v * 2 + 1] += add[v];
    add[v] = 0;
}

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m, r);
}

void update(int v, int vl, int vr, int l, int r, int val) {
    push(v);
    if (l >= vr || r <= vl) {
        return;
    }
    if (l <= vl && r >= vr) {
        add[v] += val;
        push(v);
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, l, r, val);
    update(v * 2 + 1, vm, vr, l, r, val);
    pull(v);
}

int get(int v, int vl, int vr, int l, int r) {
    push(v);
    if (l >= vr || r <= vl) {
        return -1e9;
    }
    if (l <= vl && r >= vr) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    int res1 = get(v * 2, vl, vm, l, r);
    int res2 = get(v * 2 + 1, vm, vr, l, r);
    return max(res1, res2);
}

int main() {
    for (int i = 0; i < MAXF; ++i) {
        arr[i] = rand();
    }
    build(1, 0, MAXF);
    for (int i = 0; i < MAXF; ++i) {
        int l = rand() % MAXF;
        int r = rand() % MAXF;
        if (l > r) {
            swap(l, r);
        }
        r++;
        update(1, 0, MAXF, l, r, rand());
    }
    int sum = 0;
    for (int i = 0; i < MAXF; ++i) {
        int l = rand() % MAXF;
        int r = rand() % MAXF;
        if (l > r) {
            swap(l, r);
        }
        r++;
        sum += get(1, 0, MAXF, l, r);
    }
    if (sum == 57 * 179) {
        cout << "9536982365";
        return 0;
    }
    int cnt = 3;
    int no = 4;
    for (int i = 0; i < MAXN; ++i) {
        ht[i] = cnt;
        de_ht[cnt] = i;
        cnt++;
        if (cnt == no) {
            no *= 2;
            cnt++;
        }
    }
    /// cout << cnt << endl;
    int tp;
    cin >> tp;
    if (tp == 1) {
        string s;
        cin >> s;
        vector<int> cnt(MAXL, 0);
        int n = s.size();
        for (int i = 0; i < n; ++i) {
            if (s[i] == '0') {
                continue;
            }
            for (int j = 0; j < MAXL; ++j) {
                if ((ht[i] >> j) & 1) {
                    cnt[j] ^= 1;
                }
            }
        }
        cout << s;
        for (auto elem : cnt) {
            cout << elem;
        }
    } else {
        string s;
        cin >> s;
        int n = s.size() - MAXL;
        vector<int> cnt(MAXL, 0);
        for (int i = 0; i < n; ++i) {
            if (s[i] == '0') {
                continue;
            }
            for (int j = 0; j < MAXL; ++j) {
                if ((ht[i] >> j) & 1) {
                    cnt[j] ^= 1;
                }
            }
        }
        int c = 0, x = 0;
        for (int j = 0; j < MAXL; ++j) {
            if (cnt[j] != s[n + j] - '0') {
                c++;
                x |= (1 << j);
            }
        }
        if (c <= 1) {
            for (int i = 0; i < n; ++i) {
                cout << s[i];
            }
        } else {
            int id = de_ht[x];
            for (int i = 0; i < n; ++i) {
                int k = s[i] - '0';
                if (i == id) {
                    k ^= 1;
                }
                cout << k;
            }
        }
    }
    return 0;
}
/**
endl - 795, 804           1599
cout.flush() - 832, 772   1604
fflush(stdout) - 860, 838 1698
*/
