#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>

using namespace std;

#define endl '\n'

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) a.begin(), a.end()

typedef int64_t ll;
typedef uint64_t ull;
//typedef __int128_t lll;
//typedef __uint128_t ulll;

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}
void solve();
signed main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}


void fSolve();
void sSolve();
void solve() {
    int t; cin >> t;
    if (t == 1) {
        fSolve();
    } else {
        sSolve();
    }
}

const ll MOD = 1791791791;
const ll T = 567;
const ll R = 31;

ll mod(ll x) {
    while(x >= MOD) x-=MOD;
    while(x < 0) x+=MOD;
    return x;
}

ll countH(const string &s) {
    ll h = 0;
    for (auto c : s) {
        h = (h * T + (c - '0' + 1)) % MOD;
    }
    return h;
}

void fSolve() {
    string x; cin >> x;
    int n = x.size();
    if (n <= 10) {
        cout << x;
        cout << x;
        cout << x;
        return;
    }
    ll h = countH(x);
    cout << x;
    rrange(j, R) {
        cout << ((h >> j) & 1);
    }
    cout << endl;
//    cout << h;
}


void sSolve() {
    string z; cin >> z;
    int n = z.size() - R;
    if (n <= 40) {
        string x1, x2, x3;
        n = z.size() / 3;
        copy(z.begin(), z.begin() + n, back_inserter(x1));
        copy(z.begin() + n, z.begin() + 2 * n, back_inserter(x2));
        copy(z.begin() + 2 * n, z.begin() + 3 * n, back_inserter(x3));
        if (x1 == x2) cout << x1;
        else if (x1 == x3) cout << x1;
        else cout << x2;
        return;
    }
    string x; x.resize(n);
    copy(z.begin(), z.begin() + n, x.begin());
    ll h = 0;
    range(j, R) {
        h = h * 2 + (z[n + j] - '0');
    }
    ll xh = countH(x);
//    cout << xh << endl;
//    cout << h << endl;
    if (xh == h) {
        cout << x;
        return;
    }
    range(j, R) {
        ll sh = h ^ (1 << j);
        if (sh == xh) {
            cout << x;
            return;
        }
    }
    ll pp = 1;
    rrange(i, n) {
        ll sh = xh;
        if (x[i] == '0') {
            sh += pp;
            sh = mod(sh);
            if (sh == h) {
                x[i] = '1';
                cout << x;
                return;
            }
        } else {
            sh -= pp; sh = mod(sh);
            if (sh == h) {
                x[i] = '0';
                cout << x;
                return;
            }
        }
        pp *= T;
        pp %= MOD;
    }
}

