#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>

template <class T>
istream& operator>>(istream& in, vector<T>& a) {
	for (auto& aa : a) {
		in >> aa;
	}
	return in;
}
template <class T>
ostream& operator<<(ostream& out, vector<T>& a) {
	for (auto& aa : a) {
		out << aa << ' ';
	}
	return out;
}

bool operator<(string a, string b) {
	if (a.size() != b.size()) return a.size() < b.size();
	int n = a.size();
	for (int i = n - 1; i >= 0; --i) {
		if (a[i] < b[i]) return 1;
		if (a[i] > b[i]) return 0;
	}
	return 0;
}
string operator+(string a, string b) {
	while (a.size() < b.size()) a += '0';
	while (b.size() < a.size()) b += '0';

	string c = "";
	int n = a.size();
	int mind = 0;
	for (int i = 0; i < n; ++i) {
		int aa = a[i] - '0', bb = b[i] - '0', cc = aa + bb + mind;
		mind = cc / 10;
		cc %= 10;
		c += char('0' + cc);
	}
	if (mind) c += '1';
	if (c.size() == 0) c += '0';
	while (c.back() == '0' && c.size() >= 2) c.pop_back();
	reverse(c.begin(), c.end());
	return c;
}
string operator-(string a, string b) {
	while (a.size() < b.size()) a += '0';
	while (b.size() < a.size()) b += '0';

	string c = "";
	int n = a.size();
	int mind = 0;
	for (int i = 0; i < n; ++i) {
		int aa = a[i] - '0', bb = b[i] - '0', cc = aa - bb - mind;
		if (cc < 0) {
			cc += 10;
			mind = 1;
		}
		else mind = 0;
		c += char('0' + cc);
	}
	//if (mind) c += '1';
	if (c.size() == 0) c += '0';
	while (c.back() == '0' && c.size() > 2) c.pop_back();
	reverse(c.begin(), c.end());
	return c;
}

void solve() {
	string a, b; cin >> a >> b;
	string c = "";
	bool ma = a[0] == '-', mb = b[0] == '-';
	if (ma) a = a.substr(1, a.size() - 1);
	if (mb) b = b.substr(1, b.size() - 1);

	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());

	if (!ma && !mb) cout << (a + b) << '\n';
	else if (ma && mb) cout << '-' << a + b << '\n';
	else if (!ma && mb) {
		if (a == b) cout << "0\n";
		else if (a > b) {
			cout << a - b << '\n';
		}
		else {
			cout << '-' << b - a << '\n';
		}
	}
	else {
		if (a == b) cout << "0\n";
		else if (a > b) {
			cout << '-' << a - b << '\n';
		}
		else {
			cout << b - a << '\n';
		}
	}
	//reverse(c.begin(), c.end());
	//cout << c << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t = 1; //cin >> t;
	while (t--)
		solve();

}