#pragma GCC target("avx,avx2")
#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>

#include <ctime>
#include <chrono>
#include <random>
#include <immintrin.h>


std::mt19937 rnd(2532);
constexpr int n = 1000;

short gr[n][n];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	std::cout.precision(3);
	std::cout << std::fixed;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			gr[i][j] = rnd() % (int(1e4));
		}
	}

	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			//constexpr int B = 8;
			//__m256i v1 = _mm256_set1_epi32(gr[i][k]);
			//for (int j = 0; j < n / B; j++) {
			//	__m256i v2 = _mm256_loadu_si256((const __m256i *)(gr[i] + B * j));
			//	__m256i v3 = _mm256_loadu_si256((const __m256i *)(gr[k] + B * j));

			//	_mm256_storeu_si256((__m256i *)(gr[i] + B * j), _mm256_min_epi32(v2, _mm256_add_epi32(v1, v3)));
			//}
			for (int j = 0; j < n; j++) {
				gr[i][j] = std::min<short>(gr[i][j], gr[i][k] + gr[k][j]);
			}
		}
	}

	int s = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			s += gr[i][j];
		}
	}

	std::cout << CLOCKS_PER_SEC << " ";
	std::cout << clock() * 1.0 / CLOCKS_PER_SEC << "\n";

	std::cout << s << "\n";

	return 0;
}